#!/usr/local/bin/bash

### Hardware: 
# G420
bash /tce/etc/wanos/hw/g420.sh
# IB75N2
bash /tce/etc/wanos/hw/ib75n2.sh
# Amazon
bash /tce/etc/wanos/hw/ami_ip.sh

### Dummy NIC
modprobe dummy

### 801.1q
modprobe 8021q

### Make Partitions on first boot
bash /tce/etc/wanos/makepart.sh

### Mount EXT partitions
for PARTITION in `blkid | grep TYPE=\"ext | awk '{print $1}' | awk -F/ '{print $3}' | sed 's/\://g'`; do
    test ! -d /mnt/$PARTITION && mkdir /mnt/$PARTITION
    test `df -h | grep -c ^/dev/$PARTITION` -eq 0 && mount /dev/$PARTITION /mnt/$PARTITION
done

### Create Links
sudo -u tc /tce/etc/wanos/setdir

### Interface Masters Niagara Bypass Cards
NIAGARA=`grep ^NIAGARA= /tce/etc/wanos/wanos.conf | awk -F= '{print $2}'`
    if [[ $NIAGARA = "true" ]]; then
	echo "Info : Installing Niagara driver" | tee >(/tce/etc/wanos/logstamp)
        sudo insmod /tce/packages/click/niagara.ko >> /wanos/wanos.log &
	for i in 0..10
	do 
	test "`/usr/local/bin/niagara_util -S 2> /dev/null`" = 1 && break || sleep 1
	done
	echo "Info : Setting Niagara parameters" | tee >(/tce/etc/wanos/logstamp)
	test "`/usr/local/bin/niagara_util -S 2> /dev/null`" = 1 && /usr/local/bin/niagara_util -P -d4 -c0 -t 97 -h 0A || echo "Error : Failed to find Niagara card" >> /wanos/wanos.log
    fi

## SSH
SSHD=`grep ^SSHD= /tce/etc/wanos/wanos.conf | awk -F= '{print $2}'`
if [[ $SSHD = "enable" ]]; then
service ssh start
fi

## SNMPD
SNMPD=`grep ^SNMPD= /tce/etc/wanos/wanos.conf | awk -F= '{print $2}'`
if [[ $SNMPD = "enable" ]]; then
snmpd -c /etc/snmp/snmpd.conf
fi

## Webcache
HTTP_CACHE_REDIRECT=`grep ^HTTP_CACHE_REDIRECT= /tce/etc/wanos/wanos.conf | awk -F= '{print $2}'`
if [[ $HTTP_CACHE_REDIRECT = "true" ]]; then
/tce/etc/wanos/webcache
fi

## Lighttpd
/usr/sbin/lighttpd -f /etc/lighttpd.conf

## Clean Memory
sync
sudo sh -c 'echo 3 > /proc/sys/vm/drop_caches'

### Start Wanos Daemon
sudo -u tc /tce/etc/init.d/wanosd start now &

### Info
sleep 6
IP=`/sbin/ifconfig tap0 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'`
GW=`route -n | grep 'G[ \t]' | awk '{print $2}'`
VERSION=`grep VERSION= /tce/etc/wanos/wanos.conf | awk -F\= '{print $2}'`
echo " "
echo "############################################"
echo "                                            "
echo "          Wanos Networks : v.$VERSION       "
echo "                                            "
echo "          IP Address : $IP                  "
echo "          GW Address : $GW                  "
echo "                                            "
echo "          Press Enter to Login              "
echo "                                            "
echo "############################################"

### Initiate Statistic Files
sleep 30
sudo -u tc /tce/etc/wanos/stats.sh >> /wanos/wanos.log 2>> /wanos/wanos.log
