#!/usr/local/bin/bash
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 

rrdtool=/tce/packages/rrdtool-1.6.0/bin/rrdtool
db=/tce/www/stats/diskusage.rrd
img=/tce/www/stats

if [ ! -e $db ]
then 
	$rrdtool create $db \
	DS:usage:GAUGE:600:0:50000000000 \
	RRA:AVERAGE:0.5:1:576 \
	RRA:AVERAGE:0.5:6:672 \
	RRA:AVERAGE:0.5:24:732 \
	RRA:AVERAGE:0.5:144:1460
fi

disk=`df -P /wanos/ | awk 'NR>1{print $3}'`
disk=$((disk * 1024))

$rrdtool update $db -t usage N:$disk

for period in Hour Day Week Month Year
do
	$rrdtool graph $img/diskusage-$period.json --imgformat JSONTIME -s -1$period \
	-t "Disk usage the Last $period" -z \
      -c "BACK#FFFFFF" -c "SHADEA#FFFFFF" -c "SHADEB#FFFFFF" \
      -c "MGRID#AAAAAAAA" -c "GRID#CCCCCCAA" -c "ARROW#333333" \
      -c "FONT#333333" -c "AXIS#333333" -c "FRAME#333333" -c "CANVAS#F7F7F7" \
	DEF:usage=$db:usage:AVERAGE \
	VDEF:min=usage,MINIMUM \
        VDEF:max=usage,MAXIMUM \
        VDEF:avg=usage,AVERAGE \
        VDEF:lst=usage,LAST \
	"COMMENT: \l" \
	"COMMENT:                          " \
	"COMMENT:Minimum\t" \
	"COMMENT:Maximum\t" \
	"COMMENT:Average\t" \
	"COMMENT:Current\l" \
	"COMMENT:   " \
	"AREA:usage#556E0ACC:Usage  " \
	"LINE1:usage#556E0A" \
	"GPRINT:min:%5.1lf %sB\t" \
	"GPRINT:max:%5.1lf %sB\t" \
	"GPRINT:avg:%5.1lf %sB\t" \
	"GPRINT:lst:%5.1lf %sB\l" > /dev/null
done
