#!/usr/local/bin/bash
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 

rrdtool=/tce/packages/rrdtool-1.6.0/bin/rrdtool
db=/tce/www/stats/freetraffic.rrd
img=/tce/www/stats
reduction=/tce/www/stats/reduction

if [ ! -e $db ]
then 
	$rrdtool create $db \
	DS:free:DERIVE:600:0:125000000 \
	RRA:AVERAGE:0.5:1:576 \
	RRA:AVERAGE:0.5:6:672 \
	RRA:AVERAGE:0.5:24:732 \
	RRA:AVERAGE:0.5:144:1460
fi

fromlanrx=`tail -1 /tce/www/stats/reduction | awk {'print $1'}`
towantx=`tail -1 /tce/www/stats/reduction | awk {'print $2'}`

if ((fromlanrx > 0)) && ((towantx > 0))
then 
towan=`expr $fromlanrx - $towantx`
fromwan=0
else
exit 0
fi

$rrdtool update $db -t free N:$towan

for period in Hour Day Week Month Year
do
	$rrdtool graph $img/freetraffic-$period.json --imgformat JSONTIME -s -1$period \
	-t "Combined network traffic saved the last $period" -z \
      -c "BACK#FFFFFF" -c "SHADEA#FFFFFF" -c "SHADEB#FFFFFF" \
      -c "MGRID#AAAAAAAA" -c "GRID#CCCCCCAA" -c "ARROW#333333" \
      -c "FONT#333333" -c "AXIS#333333" -c "FRAME#333333" -c "CANVAS#F7F7F7" \
	DEF:free=$db:free:AVERAGE \
	CDEF:bits=free,8,* \
	VDEF:max=bits,MAXIMUM \
	VDEF:avg=bits,AVERAGE \
	VDEF:lst=bits,LAST \
	VDEF:tot=free,TOTAL \
	"COMMENT:\l" \
        "COMMENT:                           " \
	"COMMENT:Maximum \t" \
	"COMMENT:Average \t" \
	"COMMENT:Current \t" \
	"COMMENT:Total\l" \
	"COMMENT:  " \
	"AREA:bits#556E0ACC:Saved\t" \
	"LINE1:bits#556E0A" \
	"GPRINT:max:%5.1lf %sb/s\t" \
	"GPRINT:avg:%5.1lf %sb/s\t" \
	"GPRINT:lst:%5.1lf %sb/s\t" \
	"GPRINT:tot:%5.1lf %sB\l" > /dev/null
done
