#!/usr/local/bin/bash
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 

rrdtool=/tce/packages/rrdtool-1.6.0/bin/rrdtool
db=/tce/www/stats/load.rrd
img=/tce/www/stats

if [ ! -e $db ]
then 
	$rrdtool create $db \
	DS:load:GAUGE:600:0:50000000000 \
	RRA:AVERAGE:0.5:1:576 \
	RRA:AVERAGE:0.5:6:672 \
	RRA:AVERAGE:0.5:24:732 \
	RRA:AVERAGE:0.5:144:1460
fi

$rrdtool update $db -t load N:`cat /proc/loadavg | awk {'print $2'}`

for period in Hour Day Week Month Year
do
	$rrdtool graph $img/load-$period.json --imgformat JSONTIME -s -1$period \
	-t "Load the Last $period" -z \
      -c "BACK#FFFFFF" -c "SHADEA#FFFFFF" -c "SHADEB#FFFFFF" \
      -c "MGRID#AAAAAAAA" -c "GRID#CCCCCCAA" -c "ARROW#333333" \
      -c "FONT#333333" -c "AXIS#333333" -c "FRAME#333333" -c "CANVAS#F7F7F7" \
	DEF:load=$db:load:AVERAGE \
	CDEF:tload=load,20,* \
	VDEF:min=tload,MINIMUM \
        VDEF:max=tload,MAXIMUM \
        VDEF:avg=tload,AVERAGE \
        VDEF:lst=tload,LAST \
	"COMMENT: \l" \
	"COMMENT:                      " \
	"COMMENT:Minimum\t" \
	"COMMENT:Maximum\t" \
	"COMMENT:Average\t" \
	"COMMENT:Current\l" \
	"COMMENT:   " \
	"AREA:tload#556E0ACC:Load   " \
	"LINE1:tload#556E0A" \
	"GPRINT:min:%2.2lf\t" \
	"GPRINT:max:%2.2lf\t" \
	"GPRINT:avg:%2.2lf\t" \
	"GPRINT:lst:%2.2lf\l" > /dev/null
done
