#!/usr/local/bin/bash

test -f /tce/etc/wanos/makepart && exit 

SIZE=0
test "`df -h | grep -c ^/dev/sda1`" -gt 0 && SIZE=`df -h | grep ^/dev/sda1 | uniq -u |  awk '{print $2}' | uniq`
test "$SIZE" != "11G" && exit

SIZE=0
test `df -h | grep -c ^/dev/sda4` -gt 0 && SIZE=`df -h | grep ^/dev/sda4 | uniq -u |  awk '{print $2}' | uniq`
test "$SIZE" != "0"  && exit


### Create sda3 and sda4
if [[ -z "`fdisk -l | grep ^/dev/sda3`" ]]; then

	echo "Creating new partitions with fdisk"
echo "n
p
3
        

w
"| fdisk /dev/sda

        success=`fdisk -l /dev/sda | grep -c ^/dev/sda3`
        if [[ $success != 0 ]]
        then
        echo "Partition created."
        else
        echo "Partitioning failed. Contact Support for help."
        exit
        fi

fi


if [[ -z "`fdisk -l | grep ^/dev/sda4`" ]]; then

echo "n
p
4
        

w
"| fdisk /dev/sda

echo ""
        success=`fdisk -l /dev/sda | grep -c ^/dev/sda4`
        if [[ $success != 0 ]]
        then
        echo "Partition created. Reboot."
	reboot
	exit
        else
        echo "Partitioning failed. Contact Support for help."
        exit
        fi

fi


SDA4=`blkid | grep TYPE=\"ext | awk '{print $1}' | awk -F/ '{print $3}' | sed 's/\://g' | grep sda4`
if [[ -z "$SDA4" ]]; then
	echo "Format /dev/sda4"
	mkfs.ext3 /dev/sda4
fi

sudo -u tc touch /tce/etc/wanos/makepart
