#!/usr/local/bin/bash
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#

cd /tce/etc/wanos/
cp wanos.conf wanos.conf.restore
linux_version=`uname -an`

case "$1" in
	-net)
	sed -i -r "s/(^IP=*).*/\1$2/" wanos.conf
	sed -i -r "s/(^MASK=*).*/\1$3/" wanos.conf
	sed -i -r "s/(^NET=*).*/\1$4/" wanos.conf
	sed -i -r "s/(^GW=*).*/\1$5/" wanos.conf
	;;
	-sys)
	sed -i -r "s/(^MODE=*).*/\1$2/" wanos.conf
	sed -i -r "s/(^SIM=*).*/\1$3/" wanos.conf
	;;
	-cli)
	sed -i -r "s/(^IP=*).*/\1$2/" wanos.conf
	sed -i -r "s/(^MASK=*).*/\1$3/" wanos.conf
	sed -i -r "s/(^NET=*).*/\1$4/" wanos.conf
	sed -i -r "s/(^GW=*).*/\1$5/" wanos.conf
	sed -i -r "s/(^MODE=*).*/\1$6/" wanos.conf
	sudo /tce/etc/wanos/wanos reconfigure >> /dev/null
	;;
	-settings)
	sed -i -r "s/(^MTU=*).*/\1$2/" wanos.conf
	sed -i -r "s/(^HOLD=*).*/\1$3/" wanos.conf
	sed -i -r "s/(^NFEXPIRE=*).*/\1$4/" wanos.conf
	sed -i -r "s/(^NFPEERPORT=*).*/\1$5/" wanos.conf
	sed -i -r "s/(^NFEXPORT=*).*/\1$6/" wanos.conf
	sudo killall nfcapd
	;;
	-host)
	sed -i -r "s/(^HOST=*).*/\1$2/" wanos.conf
	sudo /usr/bin/sethostname $2 >> /wanos/wanos.log
	;;
	-nfpeerip)
	sed -i -r "s/(^NFPEERIP=*).*/\1$2/" wanos.conf
	sudo killall nfcapd
	;;
	-time)
	sudo date --set "$4-$3-$2 $5:$6"
	sudo hwclock --systohc
	sudo rm -rf /wanos/nf/l0/*
	sudo rm -rf /wanos/nf/w0/*
	/tce/etc/wanos/setdir
	sudo killall nfcapd
	;;
	-encapproto)
	sed -i -r "s/(^ENCAPPROTO=*).*/\1$2/" wanos.conf
	;;
	-reconfigure)
	/tce/etc/wanos/wanos reconfigure >> /dev/null
	;;
	-showtech)
	/tce/etc/wanos/showtech
	;;
	-benchmark)
	sudo /tce/etc/wanos/benchmark | tee /wanos/bench.log
	;;
	-dstore)
	sed -i -r "s/(^DSTORE=*).*/\1$2/" wanos.conf
        sudo rm -rf /wanos/ds0/*
	test -e /mnt/$2/wanos/ds0 && sudo rm -rf /mnt/$2/wanos/ds0/*
	test -f /tce/etc/wanos/siteslot && rm -rf /tce/etc/wanos/siteslot
	sudo rm -f /wanos
	/tce/etc/wanos/setdir
        echo "Info : Clearing the datastore" | tee >(./logstamp)
	;;
	-sshd)
	sed -i -r "s/(^SSHD=*).*/\1$2/" wanos.conf
        if [[ $linux_version == *buntu* ]]; then
		test $2 = "enable" && sudo service ssh start
		test $2 = "disable" && sudo service ssh stop
	else
		test $2 = "enable" && sudo /usr/local/etc/init.d/openssh start
		test $2 = "disable" && sudo /usr/local/etc/init.d/openssh stop
	fi
	;;
	-sshpass)
	echo "Info : SSH & Web Interface Password Reset" | tee >(./logstamp)
	PS=`grep ^wanos: /tce/etc/.lighttpdpassword | awk -F: '{print $2}'`
	echo tc:$PS | sudo chpasswd
       	if [[ $linux_version != *buntu* ]]; then
		sudo cp /etc/passwd /tce/etc/passwd
	fi
	TIME=`date +%s`
	sed -i -r "s/(^CHPASSWD=*).*/\1$TIME/" wanos.conf
	;;
	-reboot)
	sudo reboot
	;;
	-update)
	cd /tce/www/stats/reports/
	test -f $2 && tar -xvf $2
        test -f	update.sh && chmod +x update.sh
        test -f	update.sh && ./update.sh
        test -f	update.sh && rm -rf update.sh
	;;
	-backupcfg)
	/tce/etc/wanos/backupcfg -backup
	;;
	-restorecfg)
	/tce/etc/wanos/backupcfg -restore $2
	;;
	-comp_lvl)
	sed -i -r "s/(^COMP_LEVEL=*).*/\1$2/" wanos.conf
	;;
	-dd_lvl)
	sed -i -r "s/(^DD_LEVEL=*).*/\1$2/" wanos.conf
	;;
	-rsp_lvl)
	sed -i -r "s/(^RSP_LEVEL=*).*/\1$2/" wanos.conf
	;;
	-deployment)
	sed -i -r "s/(^DEPLOYMENT_MODE=*).*/\1$2/" wanos.conf
	test $2 != "router" && sed -i -r "s/(^VIRT_LAN0=*).*/\1/" wanos.conf
	;;
	-virtlan)
	sed -i -r "s|(^VIRT_LAN0=*).*|\1$2|" wanos.conf
	;;
	-aqm_num)
	./aqm.sh -num $2
	;;
	-aqm_name)
	./aqm.sh -name
	;;
	-new_license)
	sudo /usr/local/bin/click -e "require(package 'wanos'); wc::WConf(); Script ( wait 1, stop );"
	;;
	-dnsupdate)
	touch /tce/etc/resolv.conf

	if [[ ! -z "$2" ]]; then
	    DNS1=`grep ^DNS_SERVER_1= wanos.conf | awk -F= '{print $2}'`
	    sed -i -r "s/(^DNS_SERVER_1=*).*/\1$2/" wanos.conf
	    [[ ! -z "$DNS1" ]] && sudo sed -i "s/$DNS1/$2/" /etc/resolv.conf
	    [[ -z "`grep $2 /etc/resolv.conf`" ]] && echo "nameserver $2" | sudo tee -a /etc/resolv.conf
	fi
	if [[ ! -z "$3" ]]; then
	    DNS2=`grep ^DNS_SERVER_2= wanos.conf | awk -F= '{print $2}'`
	    sed -i -r "s/(^DNS_SERVER_2=*).*/\1$3/" wanos.conf
	    [[ ! -z "$DNS2" ]] && sudo sed -i "s/$DNS2/$3/" /etc/resolv.conf
	    [[ -z "`grep $3 /etc/resolv.conf`" ]] && echo "nameserver $3" | sudo tee -a /etc/resolv.conf
	fi

       	if [[ $linux_version != *buntu* ]]; then
		sudo cp /etc/resolv.conf /tce/etc/resolv.conf
	fi

	;;

esac

