#!/usr/local/bin/bash
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 

rrdtool=/tce/packages/rrdtool-1.6.0/bin/rrdtool
db=/tce/www/stats/freemem.rrd
img=/tce/www/stats

if [ ! -e $db ]
then 
	$rrdtool create $db \
	DS:reserv:GAUGE:600:0:50000000000 \
	DS:used:GAUGE:600:0:50000000000 \
	RRA:AVERAGE:0.5:1:576 \
	RRA:AVERAGE:0.5:6:672 \
	RRA:AVERAGE:0.5:24:732 \
	RRA:AVERAGE:0.5:144:1460
fi



TOTAL=`cat /proc/meminfo | grep ^MemTotal: | awk '{print $2}'` 
MAVAIL=`cat /proc/meminfo | grep ^MemAvailable: | awk '{print $2}'` 
USED=$((TOTAL - MAVAIL))
USEDPERC=$((USED * 100 / TOTAL)) 
USED=$((USED * 1024))

echo $USEDPERC > $img/memprec

$rrdtool update $db -t reserv:used N:`free -b | grep Mem: | awk '{print $3}'`:$USED

for period in Hour Day Week Month Year
do
	$rrdtool graph $img/memory-$period.json --imgformat JSONTIME -s -1$period \
	-t "Reserved memory versus actual used memory the Last $period" -z \
      -c "BACK#FFFFFF" -c "SHADEA#FFFFFF" -c "SHADEB#FFFFFF" \
      -c "MGRID#AAAAAAAA" -c "GRID#CCCCCCAA" -c "ARROW#333333" \
      -c "FONT#333333" -c "AXIS#333333" -c "FRAME#333333" -c "CANVAS#F7F7F7" \
	DEF:reserv=$db:reserv:AVERAGE \
	DEF:used=$db:used:AVERAGE \
	VDEF:minreserv=reserv,MINIMUM \
	VDEF:minused=used,MINIMUM \
        VDEF:maxreserv=reserv,MAXIMUM \
        VDEF:maxused=used,MAXIMUM \
        VDEF:avgreserv=reserv,AVERAGE \
        VDEF:avgused=used,AVERAGE \
        VDEF:lstreserv=reserv,LAST \
        VDEF:lstused=used,LAST \
	"COMMENT: \l" \
	"COMMENT:                               " \
	"COMMENT:Minimum\t" \
	"COMMENT:Maximum\t" \
	"COMMENT:Average\t" \
	"COMMENT:Current\l" \
	"COMMENT:   " \
	"AREA:reserv#556E0ACC:Reserved  " \
	"LINE1:reserv#556E0A" \
	"GPRINT:minreserv:%5.1lf %sB\t" \
	"GPRINT:maxreserv:%5.1lf %sB\t" \
	"GPRINT:avgreserv:%5.1lf %sB\t" \
	"GPRINT:lstreserv:%5.1lf %sB\l" \
	"COMMENT:   " \
	"AREA:used#707070CC:Actual        " \
	"LINE1:used#707070" \
	"GPRINT:minused:%5.1lf %sB\t" \
	"GPRINT:maxused:%5.1lf %sB\t" \
	"GPRINT:avgused:%5.1lf %sB\t" \
	"GPRINT:lstused:%5.1lf %sB\l" > /dev/null
done
