#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 
use Scalar::Util qw(looks_like_number);

my ($sim) = $ARGV[0];
my $sim_queue = $ARGV[1];
my $wanop_byte = $ARGV[2];
my $wanop_queue = $ARGV[3];
my $default_queue = $ARGV[4];
my $prio_queue = (sprintf "%0.0f", (($default_queue/5)+0.5));

my %classes = ();
my %rates = ();
my %rows = ();
my @missingclasses = (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17);

open(ROW, "<" , "/tce/etc/wanos/policies") || die("Couldn't open the file. Error: $!\n");
while (<ROW>) 
{                    
	chomp;
	next if /^\s*\#/;           
	next unless /=/;            
	my ($key, $commastring) = split(/\s*=\s*/,$_,2);
	$commastring =~ s/(\$(\w+))/$rows{$2}/g;                             
	$rows{$key} = $commastring;                                      
}                                                                 
close ROW;

print <<EOF;

//
// Post QoS
//

EOF
if ($sim ne "0") 
{
	print "priosched :: PrioSched -> global_shaper::BandwidthRatedUnqueue(" . $sim . "B/s, BURST_DURATION 0.01 ) -> global_out_q::ThreadSafeQueue -> tdwan0;\n"
}
else { print "priosched :: PrioSched -> tdwan0;\n"};
print <<END
p0queue :: Tee -> pq0::ThreadSafeQueue($prio_queue) -> [0]priosched;
p1queue :: Tee -> pq1::ThreadSafeQueue($default_queue) -> [1]priosched;
p2queue :: Tee -> pq2::ThreadSafeQueue($default_queue) -> [2]priosched;
unstrip0 :: Unstrip(14) -> [0]sw;
unstrip1 :: Unstrip(14) -> [1]sw;

lansched :: PrioSched -> lan0out;
lanqueue0 :: ThreadSafeQueue(250) -> [0]lansched;
lanqueue1 :: ThreadSafeQueue(1000) -> [1]lansched;

lan0qos :: CheckPaint(17) -> lanqueue0;
lan0qos[1] -> lanqueue1;

lan0policy::IPClassifier(icmp or udp port 53 or tcp syn,-) -> Paint(17) -> unstrip1;
lan0policy[1] -> unstrip1;

sw[0] -> lan0tx :: Tee -> lan0qos;
sw[1] -> qos::PaintSwitch;

checkout :: Counter -> checkoutcheck::CheckIPHeader(VERBOSE true) -> postfrag::CheckLength(1500) -> Unstrip(14) -> post_qos::PaintSwitch;
END
;

if ($wanop_byte ne "0" ) { print "wanopout :: ThreadSafeQueue(" . $wanop_queue . ") -> BandwidthRatedUnqueue(" . $wanop_byte . "B/s) -> checkout;\n" }
else { print "wanopout :: ThreadSafeQueue(" . $default_queue . ") -> Unqueue -> checkout;\n" }
print "lantx_c :: Counter -> lan0policy;\n";


foreach (sort { $a <=> $b } keys(%rows) )
{
 my @values = split(',',$rows{$_});
 next if $values[5] eq 'drop';
 # While we looping build the classes list
 $classes{$values[4]} = $values[5]; 
}

print "post_qos[17] -> p0queue;\n";

foreach (sort { $a <=> $b } keys(%classes) ) 
{
print "post_qos[$_] -> ";
if ($classes{$_} eq 'shape') { print "p2queue;\n"; }
if ($classes{$_} eq 'high') { print " p0queue;\n"; }
if ($classes{$_} eq 'low') { print "p2queue;\n"; }
if ($classes{$_} eq '-') { print "p1queue;\n"; }
$missingclasses[$_-1] = 0;
}

print "post_qos[";
foreach (@missingclasses) { if ($_ != 0) {print "$_,";} }
print "] -> p1queue;\n\n"; 

