//
// Switch
//
require(package "wanos_extra_packages");
require(package "wanos");
require(package "netflow");
wc::WConf(IPPROTO 108, MSS 1320);
tun :: KernelTap( 192.168.1.200/24 , 192.168.1.1, ETHER 00:0c:29:6f:ea:91 );
cltr :: ControlSocket(TCP, 13000, LOCALHOST true, RETRIES 3);
sw :: EtherSwitch;
totun :: Classifier(12/0800) -> Strip(14) -> DropBroadcasts -> encaptun :: EtherEncap(0x0800, 1:1:1:1:1:1, 00:0c:29:6f:ea:91) -> tun;
arptable :: ARPTable;
wanarp :: ARPQuerier(192.168.1.200, 00:0c:29:6f:ea:91, TABLE arptable);
lanarp :: ARPQuerier(192.168.1.200, 00:0c:29:6f:ea:91, TABLE arptable);
rsparp :: ARPQuerier(192.168.1.200, 00:0c:29:6f:ea:91, TABLE arptable);
elementclass SYS_Table { input -> sys_lookup::StaticIPLookup( 192.168.1.0/24 0, 0.0.0.0/0 192.168.1.1 0) -> output; };
sysout :: ThreadSafeQueue(1000) -> Unqueue -> system_route::SYS_Table -> [0]wanarp -> [2]sw[2] -> totun;
tun -> hostarp::Classifier(12/0800, 12/0806) -> Strip(14) -> hostcheck::CheckIPHeader -> sysout;
hostarp[1] -> ARPResponder(0.0.0.0/0 1:1:1:1:1:1) -> tun;

//
// Deployment method
//

wan0 :: FromDevice(wan0, SNIFFER false, PROMISC true, METHOD PCAP);
lan0 :: FromDevice(lan0, SNIFFER false, PROMISC true, METHOD PCAP);
lan0out :: VLANEncap(ANNO) -> ToDevice(lan0, METHOD PCAP);
tdwan0 :: VLANEncap(ANNO) -> ToDevice(wan0, METHOD PCAP);
Idle -> [0]lanarp -> Discard;

//
// Post QoS
//

priosched :: PrioSched -> tdwan0;
p0queue :: Tee -> pq0::ThreadSafeQueue(200) -> [0]priosched;
p1queue :: Tee -> pq1::ThreadSafeQueue(1000) -> [1]priosched;
p2queue :: Tee -> pq2::ThreadSafeQueue(1000) -> [2]priosched;
unstrip0 :: Unstrip(14) -> [0]sw;
unstrip1 :: Unstrip(14) -> [1]sw;

lansched :: PrioSched -> lan0out;
lanqueue0 :: ThreadSafeQueue(250) -> [0]lansched;
lanqueue1 :: ThreadSafeQueue(1000) -> [1]lansched;

lan0qos :: CheckPaint(17) -> lanqueue0;
lan0qos[1] -> lanqueue1;

lan0policy::IPClassifier(icmp or udp port 53 or tcp syn,-) -> Paint(17) -> unstrip1;
lan0policy[1] -> unstrip1;

sw[0] -> lan0tx :: Tee -> lan0qos;
sw[1] -> qos::PaintSwitch;

checkout :: Counter -> checkoutcheck::CheckIPHeader(VERBOSE true) -> postfrag::CheckLength(1500) -> Unstrip(14) -> post_qos::PaintSwitch;
wanopout :: ThreadSafeQueue(200) -> BandwidthRatedUnqueue(156250B/s) -> checkout;
lantx_c :: Counter -> lan0policy;
post_qos[17] -> p0queue;
post_qos[0] -> p1queue;
post_qos[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,] -> p1queue;

//
// Peer Sites
//
peer_route::SYS_Table -> [0]rsparp -> Strip(14) -> wanopout;
rsparp[1] -> pq2;
peer_lan_tx_c0::Counter -> lantx_c;
peer_wan_tx_c0::Counter -> wanopout;

peer_wred0::WRED(5, 50, 0.5, RSP rsp_peer0) -> dupq0::ThreadSafeQueue(2000) -> unq0::Unqueue ->  dedup0 :: Dedup(ACTION 0, DS 0, DS_START 0 , CLICK true, LEVEL 4, DS_SIZE 13000, MEM_DENSE false );

comp0 :: WComp(SKIP_TRANSPORT_HEADER true, MIN_DATA_LEN 192, COMPRESSOR 3, METHOD streaming);
wrtt_peer0::WRTT(LOCAL_IP 192.168.1.200 , PEER_IP 192.168.1.200, DEFAULT_RTT 3000, RTT_HISTORY_COUNT 2, TIMER_INTERVAL 5, ENABLE false);
rsp_peer0::RSP(MODE client, LOCAL_IP 192.168.1.200 , PEER_IP 192.168.1.200, WRTT wrtt_peer0 , WCOMP comp0 , RTT_DELTA 2, MAX_RETRANSMIT_COUNT 5 , MAX_RX_COUNT 2000 , CONGESTION_REPORT_PERIOD_MS 50 , DEBUG false, DELAYED_ACK_MS 10 );
dedup0[0]  -> compq0::ThreadSafeQueue(1000) -> compunq0::Unqueue -> comp0 -> rspq0::ThreadSafeQueue(1000) -> rspunq0::Unqueue -> rsp_peer0 -> peer_wan_tx_c0;
dedup0[1]  -> refq0::ThreadSafeQueue(100) -> refunq0::Unqueue -> IPMirror -> Unstrip(14) -> EtherMirror -> Strip(14) ->  peer_wan_tx_c0;
dedup0[2]  -> redupq0::ThreadSafeQueue(1000) -> redupunq0::Unqueue -> peer_lan_tx_c0;
rsp_peer0[2] -> peer_route;
wrtt_peer0[1] -> peer_route;
wrtt_peer0[2] -> Unstrip(14) -> EtherMirror -> pq1;


elementclass Wan_Out_Table {
input -> out_lookup::RadixIPLookup(
	0.0.0.0/0 0,
	);
	out_lookup[0] -> [0]output;
};

elementclass Wan_In_Table {
input -> in_lookup::WRadixIPLookup(
	0.0.0.0/0 0,
	);
	in_lookup[0] -> [0]output;
};

optable :: Wan_Out_Table;
optable[0] -> peer0::PeerProbe(MODE 1, INT 0, PROBE false) -> bypass0::Bypass -> peer_lan_rx_c0::Counter -> peer_wred0;
peer0[1] -> Paint(17) ->  checkout;
bypass0[1] ->  checkout;

handler0:: BypassHandler(BYPASS bypass0.active, PEERHELLO peer0.active, DD dedup0.ds_ready, HOLD 60, VERBOSE false);

handlertable :: Wan_In_Table;
handlertable[0] ->  handler0;

rtable :: Wan_In_Table;
rtable[0] -> peer_wan_rx_c0::Counter -> wrtt_peer0 -> [1]rsp_peer0[1] -> decomp0::WDeComp(SKIP_TRANSPORT_HEADER true, RSP rsp_peer0) -> peer_lan_tx_c0;
decomp0[1] -> dupq0;
decomp0[2] -> handler0;


StaticThreadSched(unq0 1,compunq0 1,)

//
// Network Policies
//
policymap :: IPClassifier(
udp port 53 or icmp,
tcp port 7 or  23 or  37 or  107 or  179 or  513 or  514 or  1494 or  1718 or  1719 or  1720 or  2000 or  2001 or  2002 or  2003 or  2427 or  2598 or  2727 or  3389 or  5060 or  5631 or  5900 or  5901 or  5902 or  5903 or  6000 or  (dst udp port > 16384),
tcp port 22 or  49 or  88 or  261 or  322 or  443 or  448 or  465 or  563 or  585 or  614 or  636 or  684 or  695 or  989 or  990 or  992 or  993 or  994 or  995 or  1701 or  1723 or  2252 or  2478 or  2479 or  2482 or  2484 or  2492 or  2679 or  2762 or  2998 or  3077 or  3078 or  3183 or  3191 or  3220 or  3269 or  3410 or  3424 or  3471 or  3496 or  3509 or  3529 or  3539 or  3660 or  3661 or  3713 or  3747 or  3864 or  3885 or  3896 or  3897 or  3995 or  4031 or  5007 or  5061 or  5723 or  7674 or  9802 or  11751 or  12109,
src 0.0.0.0/0 and dst 0.0.0.0/0 and tcp ,
-);

policymap[0] -> Paint(17) -> unstrip0;
policymap[1] -> Paint(0) -> unstrip0;
policymap[2] -> Paint(17) -> unstrip0;
policymap[3] -> Paint(0) -> Paint(1,27) -> unstrip0;
policymap[4] -> Paint(0) -> unstrip0;


precheck :: Counter -> udph_chk::WCheckUDPHeader(VERBOSE false) -> tcph_chk::WCheckTCPHeader(VERBOSE false) -> MSSAdjust -> WanosTCPFragmenter(MTU 1400) -> prefrag :: WanosIPFragmenter(1400) -> optable;
http_redirect :: Null -> precheck;
admission_control :: RED(20, 100, 0.01, QUEUES wanopout) -> http_redirect;
postpolicy :: CheckPaint(1,27);
postpolicy[0] -> Strip(14) -> admission_control;
postpolicy[1] -> pass_through_tx::Counter -> post_qos;
global_wan_red :: Null -> postpolicy;
qos[17] -> qos_class17::Counter -> postpolicy;
qos[0] -> qos_class0::Counter -> global_wan_red;
qos[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,] -> qos_class_all::Counter -> global_wan_red;


lan0[0]   -> VLANDecap -> class0 :: Classifier(12/0806 20/0002, 12/0806 20/0001, 12/0800 23/6C 34/697A, 12/0800, -)
class0[0] -> arpq0::Tee -> [0]sw;
class0[1] -> arpres0::Tee -> ARPResponder(192.168.1.200 00:0c:29:6f:ea:91) -> lanqueue1;
class0[2] -> peer_detect_on_lan_1::ThreadSafeQueue(1) -> DelayShaper(5) -> Print("Peer detected on lan0", CONTENTS false) -> Discard;
class0[3] -> Strip(14) -> check0::CheckIPHeader -> pass_through_broadcasts::DropBroadcasts -> lan0rx::Tee -> lprobe::PeerProbe(MODE 0, INT 1, PROBE true) -> policymap;
class0[4] -> [0]sw;
check0[1] -> unstrip0;
pass_through_broadcasts[1] -> unstrip0;
lprobe[1] -> peer_detect_on_lan_2::ThreadSafeQueue(1) -> DelayShaper(5) -> Print("Peer detected on lan0", CONTENTS false) -> Discard;

wan0rx1::Tee -> wanrx_c::Counter -> rtable;
wan0rx2::Tee -> pass_through_rx::Counter -> rprobe::PeerProbe(MODE 0, INT 1, PROBE true) -> lan0policy;
wan0[0]   -> VLANDecap -> class1 :: Classifier(12/0806 20/0002, 12/0806 20/0001, 12/0800 23/6C 34/697A, 12/0800 23/11, 12/0800, -)
class1[0] -> arpq1::Tee -> [1]sw;
class1[1] -> arpres1::Tee -> ARPResponder(192.168.1.200 00:0c:29:6f:ea:91) -> p1queue;
class1[2] -> Strip(14) -> check1::CheckIPHeader(VERBOSE false) -> wan0rx1; 
class1[4] -> Strip(14) -> check2::CheckIPHeader(VERBOSE false) -> wan0rx2;
class1[5] -> [1]sw;
check1[1] -> unstrip1;
check2[1] -> unstrip1;
rprobe[1] -> handlertable;
class1[3] -> Strip(14) -> check2;

icmperr ::  ICMPError(192.168.1.200, unreachable, needfrag) -> sysout;
postfrag[1]  -> icmperr;
prefrag[1]   -> icmperr;

udpencap_q::ThreadSafeQueue(100000) -> udpencap_uq::Unqueue -> encaptun;
udpencaplan :: UDPIPEncap(1.1.1.1, 1111, 192.168.1.200 , 9995) -> udpencap_q;
udpencapwan :: UDPIPEncap(1.1.1.2, 1112, 192.168.1.200 , 9996) -> udpencap_q;

lan0tx[1] -> lan_tx_flow_q::ThreadSafeQueue -> lan_tx_flow_uq::Unqueue -> Classifier(12/0800) -> Strip(14) -> CheckIPHeader -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> lantxflow :: AggregateIPFlows(TCP_TIMEOUT 240, FRAGMENTS false, REAP 4) -> lan_tx_flow_export::NetflowExport(NOTIFIER lantxflow, VERSION 5, INTERVAL 120) -> udpencaplan;
lan0rx[1] -> lan_rx_flow_q::ThreadSafeQueue -> lan_rx_flow_uq::Unqueue -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> lanrxflow :: AggregateIPFlows(TCP_TIMEOUT  240, FRAGMENTS false, REAP 4) -> lan_rx_flow_export::NetflowExport(NOTIFIER lanrxflow, VERSION 5, INTERVAL 120) -> udpencaplan;
wan0tx :: ThreadSafeQueue -> wan_tx_flow_uq::Unqueue -> Classifier(12/0800) -> Strip(14) -> CheckIPHeader -> txdecap::IPCompDecap -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> wantxflow :: AggregateIPFlows(TCP_TIMEOUT 240, FRAGMENTS false, REAP 4) -> wan_tx_flow_export::NetflowExport(NOTIFIER wantxflow, VERSION 5, INTERVAL 120) -> udpencapwan;
wanrxflowfilter :: ThreadSafeQueue -> wan_rx_flow_uq::Unqueue -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> wanrxflow::AggregateIPFlows(TCP_TIMEOUT  240, FRAGMENTS false, REAP 4) -> wan_rx_flow_export::NetflowExport(NOTIFIER wanrxflow, VERSION 5, INTERVAL 120) -> udpencapwan;

StaticThreadSched(lan_tx_flow_uq 1, lan_tx_flow_export 1, lan_rx_flow_uq 1, lan_rx_flow_export 1, wan_tx_flow_uq 1, wan_tx_flow_export 1, wan_rx_flow_uq 1, wan_rx_flow_export 1);

wan0rx1[1] -> rxdecap::IPCompDecap -> wanrxflowfilter;
wan0rx2[1] -> wanrxflowfilter;
p0queue[1] -> wan0tx;
p1queue[1] -> wan0tx;
p2queue[1] -> wan0tx;
arpq0[1]     -> [1]lanarp;
arpq1[1]     -> [1]wanarp;
arpres0[1]   -> [0]sw;
arpres1[1]   -> [1]sw;
Idle -> p0queue;
Idle -> p2queue;
Idle -> [1]rsparp;

//
// Script Elements
//


Script(
	label begin,
	set x $(checkout.byte_count),
	wait 20,
	set y $(checkout.byte_count),
	set x $(sub $y $x),
	set x $(idiv $x 20),
	goto ADMISSION_CONTROL $(gt $x 156250),
	wait 60,
	goto begin,
	label ADMISSION_CONTROL,
	set x $(mul $x 8),
	set x $(idiv $x 1000),
	print "Alert : Admission Control - Optimized bandwidth exceeds licensed rate. Active rate : " $x "Kbps",
	wait 60,
	goto begin,                                                                                                                        
        );                                                                             
        

