#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;;
use warnings;
use Cwd qw(abs_path);
use CGI::Carp qw ( fatalsToBrowser );

use File::Basename;

$CGI::POST_MAX = 1024 * 5000;
my $safe_filename_characters = "a-zA-Z0-9_.-";
my $upload_dir = "/tce/www/stats/reports/";

my $query = new CGI;
my $update = $query->param("update");
my $filename = $query->param("restorefile");

open(CONFIG, "<", "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
while (<CONFIG>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $variable) = split(/\s*=\s*/, $_, 2);
	$variable =~ s/(\$(\w+))/$config{$2}/g;
	$config{$key} = $variable;
}
close CONFIG;

if ($filename ne '')
{

	if (!$filename)
	{
		print $query->header ( );
		print "There was a problem uploading the file.";
		exit;
	}

	my ( $name, $path, $extension ) = fileparse ( $filename, '..*' );
	$filename = $name . $extension;
	$filename =~ tr/ /_/;
	$filename =~ s/[^$safe_filename_characters]//g;

	if ($filename =~ /^([$safe_filename_characters]+)$/)
	{
		$filename = $1;
	}
	else
	{
		die "Filename contains invalid characters";
	}

	my $upload_filehandle = $query->upload("restorefile");

	open ( UPLOADFILE, ">$upload_dir/$filename" ) or die "$!";
	binmode UPLOADFILE;

	while (<$upload_filehandle>) {
		print UPLOADFILE;
	}
	autoflush UPLOADFILE 1;
	close UPLOADFILE;

	print $query->header ( );

	$update = 2;
}

if ($update != 1 && $update != 2) {

	print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Backup & Restore</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>Backup</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
	;

}

if ($update != 1 && $update != 2) {
	print <<END

        <form id="create_backup" action="/cgi-bin/backupcfg.pl" enctype="post" method="post" class="form-inline">
            <label class="control-label col-md-6 col-sm-6 col-xs-12">Backup <p class="help-block">Generate backup configuration file</p></label>
              <button type="submit" class="btn btn-default" type="submit" name="Restore" value="Restore" style='font-size: 8pt;'>Go!</button>
        </form>
END
;

	print <<END
		    </div>
        </div>
    </div>
</div>
END
;

}

if ($update == 1) {

	print <<END
		<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Backup Configuration File is ready for download: </strong>
END
;

	system("sudo -u tc /tce/etc/wanos/makewanoscfg.sh -backupcfg > /dev/null" );

	my @backup_files = `cd /tce/www/stats/reports/ && ls *backupcfg.tar`;
	foreach (@backup_files) {
		print "<a href='../stats/reports/$_' style='color:#777'>$_</a></div>";
	}

}

if ($update != 1 && $update != 2) {

	print <<END;

<div class="row">
    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>Restore</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-wrench"></i></a>
                    <ul class="dropdown-menu" role="menu">
                        <li><a href="#">Settings 1</a>
                        </li>
                        <li><a href="#">Settings 2</a>
                        </li>
                    </ul>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
	;

}

if ($update != 1 && $update != 2) {
	print <<END

        <form id="restore_backup" action="/cgi-bin/backupcfg.pl" enctype="multipart/form-data" method="post" class="form-inline">
            <label class="control-label col-md-6 col-sm-6 col-xs-12" for="restorefile">Restore <p class="help-block">Upload and Restore Configuration File</p></label>
              <div class="form-group">
                <input id="restorefile" type="file" data-parsley-error-message="This field is required" required="required" multiple name="restorefile" style='font-size: 8pt;' />
              </div>

              <button type="submit" class="btn btn-default" type="submit" name="Restore" value="Restore" style='font-size: 8pt;'>Go!</button>
        </form>
END
;

	print <<END
		    </div>
        </div>
    </div>
</div>
END
;

}

if ($update == 2) {
	my $output = `sudo -u tc /tce/etc/wanos/makewanoscfg.sh -restorecfg $upload_dir$filename`;

	if ($output != '') {

		print '<div class="alert alert-danger alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Warning!</strong> Please check log files ! <br /> Can\'t execute : ';
		print "sudo -u tc /tce/etc/wanos/makewanoscfg.sh -restorecfg $upload_dir$filename <br />";
		print "Output: $output ";
		print '</div>';

	} else {

		print '<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Success!</strong> Backup is restored
		</div>
		';

	}

}
