#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;
use Cwd qw(abs_path);

my $cgi = CGI->new;
my $update = $cgi->param("update");

open(CONFIG, "<", "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
while (<CONFIG>)
{
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split(/\s*=\s*/, $_, 2);
    $variable =~ s/(\$(\w+))/$config{$2}/g;
    $config{$key} = $variable;
}
close CONFIG;

if ($update == 0) {
    print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Benchmark</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>System Benchmark</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
    ;
}

if ($update == 0)
{

    print <<END

        	<form action="/cgi-bin/update.pl" method="post" id="show_benchmark" class="form-inline">
            <label class="control-label col-md-6 col-sm-6 col-xs-12" for="benchmark">Run benchmark tests:</label>
              <button id="show_benchmark" type="submit" class="btn btn btn-default" type="submit" name="show_benchmark" value="Restore" style='font-size: 8pt;'>Submit</button>
        	</form>
END
;
}

if ($update == 1)
{

    print $cgi->header('text/plain;charset=UTF-8');
    print <<END
        	<h4>Results</h4><hr /><pre style='font-size:8pt;'>
END
;
    system("sudo -u tc /tce/etc/wanos/makewanoscfg.sh -benchmark" );

    print "</pre>";
}

if ($update == 0) {

    print <<END

        </div>
    </div>

</div>
END
;
}
