#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;

my $cgi = CGI->new;
my $name = $cgi->param( "trend" );
my $desc = $cgi->param( "desc" );
my $title = $cgi->param( "title" );
my $i = 0;
my $json = '';
my $filename = '';
my $datestring = time();

my @graphs;
push ( @graphs, "cpu,CPU Utilization" );

if ($title eq '') {
    $title = 'CPU';
}

my @colors_arr = (
    # top, top opacity, bottom, bottom opacity ;
    [ '#98B937', '0.2', '#606b2c', '0.2' ],
    [ '#6A9113', '0.2', '#141517', '0.2' ],
    [ '#52c234', '0.2', '#29323c', '0.2' ],
    [ '#52c234', '0.2', '#061700', '0.2' ],
    [ '#ADD100', '0.2', '#7B920A', '0.2' ],
    [ '#414d0b', '0.2', '#727a17', '0.2' ],
    [ '#727a17', '0.2', '#606b2c', '0.2' ],
    [ '#98B937', '0.2', '#71B280', '0.2' ]
);

print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>$title</h3>
    </div>
</div>
<div class="clearfix"></div>

<style>

END
;

my $k = 0;
for my $colors (@colors_arr) {

    print '.gradient'.$k.' {';
    print 'fill: url(#gradient-area'.$k.');';
    print '}';

    print '.line'.$k.' {';
    print 'fill: none; stroke: '.@$colors[0].'; stroke-width: 1;';
    print '}';

    for (my $j = 0; $j < 4; $j++) {
        if ($j == 0) {
            print '.lgt'.$k.' {';
            print 'stop-color : '.@$colors[$j].';';
        }

        if ($j == 1) {
            print 'stop-opacity : '.@$colors[$j].';';
        }

        if ($j == 2) {
            print '}';
            print '.lgb'.$k.' {';
            print 'stop-color : '.@$colors[$j].';';
        }

        if ($j == 3) {
            print 'stop-opacity : '.@$colors[$j].';';
            print '}';
        }
    }

    for (my $m = 0; $m < 4; $m++) {
        if ($m == 0) {
            print '.legend'.$k.' {';
            print 'background: '.@$colors[$m].';';
        }

        if ($m == 3) {
            print '}';
        }
    }
    $k++;
}

print <<END;
</style>

END
;

if ($name eq '')
{
    foreach $graph (@graphs)
    {
        ($graphname, $desc) = split( ',', $graph );
        print <<END;


<div class="row">
    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>$desc</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">
END
        ;

        $filename = "/tce/www/stats/$graphname-Day.json";
        open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
        local $/;
        $json = <$fh>;
    }
        $json =~ s/[\n\r\s]+//g;

        print <<END
		        <script type="text/javascript">
		            window.ratio = undefined;
                    var json=$json, tmp_arr = [];
                    var DURATION = 1500;
                    var DELAY    = 500;

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;
                        for(var j = 0; j < length_value; j++) {
                            for(var i = 0; i < json.data.length; i++) {
				if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr.push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j+length_value] != 'object' ? parseFloat(json.data[i][j+length_value]) : 0
                                    });
                                }
                            }
                            drawLineChart('lineChart', tmp_arr, 'cpu', 'CPU the Last Day', j);
                            tmp_arr = [];

                        }
                    }

                </script>

                <script type="text/javascript">
                    drawLegend('lineChart', json, 'cpu');
                </script>

                <a href="/#/cpu/all" id="lineChart" class="d3graph">
                    <svg id="lineChartSVG" class="lineChart--svg">
                      <defs>
END
        ;

        my $n = 0;
        for my $colors (@colors_arr) {

            for (my $j = 0; $j < 4; $j++) {

                if ($j == 0) {
                    print '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                    print '<stop class="lgt'.$n.'" offset="0%" />';
                }

                if ($j == 1) {
                    print '<stop class="lgb'.$n.'" offset="100%" />';
                }

                if ($j == 3) {
                    print '</linearGradient>';
                }
            }
            $n++;
        }
        print <<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
        ;


        #        OLD graph
        #        print <<END
        #                <a href='/#/cpu/all' class='img-table'>
        #                    <center> <img src='/stats/$graphname-Day.png?cachebuster=$datestring' border='0'> </center>
        #                </a>
        #END
        #        ;

        print <<END
            </div>
        </div>
    </div>
</div>
END
        ;
    }
}
else {
    print '<div class="row">';
    foreach $period ("Hour", "Day", "Week", "Month", "Year") {
        print <<END

    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x2_title title_block">
            <h2>$period</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>

        <div class="x_panel fixed_height_320">
            <div class="x_content">
END
        ;

        $filename = "/tce/www/stats/$name-$period.json";
        open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
            local $/;
            $json = <$fh>;
        }

        $json =~ s/[\n\r\s]+//g;

        print <<END
		         <script type="text/javascript">
		            window.ratio = undefined;
                    var json=$json, tmp_arr = [];

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;

                        for(var j = 0; j < length_value; j++) {
                            for(var i = 0; i < json.data.length; i++) {
				if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr.push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j+length_value] != 'object' ? parseFloat(json.data[i][j+length_value]) : 0
                                    });
                                }
                            }
                            drawLineChart('lineChart$i', tmp_arr, 'cpu', 'CPU the Last $period', j);
                            tmp_arr = [];

                        }
                    }
                </script>
                <script type="text/javascript">
                    drawLegend('lineChart$i', json, 'cpu');
                </script>
                <a href="/#/cpu" id="lineChart$i" class="d3graph">
                    <svg id="lineChartSVG" class="lineChart--svg">
                      <defs>
END
        ;

        my $n = 0;
        for my $colors (@colors_arr) {

            for (my $j = 0; $j < 4; $j++) {

                if ($j == 0) {
                    print '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                    print '<stop class="lgt'.$n.'" offset="0%" />';
                }

                if ($j == 1) {
                    print '<stop class="lgb'.$n.'" offset="100%" />';
                }

                if ($j == 3) {
                    print '</linearGradient>';
                }
            }
            $n++;
        }
        print <<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
        ;


        #        OLD graph
        #        print <<END
        #
        #
        #                <a href="/#/cpu" class="img-table">
        #				    <center> <img src='/stats/$name-$period.png?cachebuster=$datestring' border='0'> </center>
        #				</a>
        #
        #END
        #        ;

        print <<END

			</div>
	    </div>

</div>
END
        ;

        $i++;
    }
    print '</div>';

}
