#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

open(ROW, "<", "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
        chomp;
        next if /^\s*\#/;
        next unless /=/;
        my ($key, $commastring) = split(/\s*=\s*/, $_, 2);
        $commastring =~ s/(\$(\w+))/$rows{$2}/g;
        $rows{$key} = $commastring;
        my @values = split(',', $commastring);
        $sites{$values[1]} = $values[2];
}
close ROW;
my $num_sites = scalar keys %sites;


print <<END

<div class="page-title">
    <div class="title_left">
        <h3>Dashboard</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row"> 


    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Live Graph Options :  <span id="opt_graphs_for">Total</span></h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel" >
            <div class="x_content">

                <table class="nav-table" width="40%">
                    <tr>
                                    <td width="5%">Graph:</td><td width="20%"> <select name="main" style=" width:70%" onchange="setpeer(this.value)" class="form-control animated flipInY">
                                            <option value="">Total</option>
END
;

foreach (keys %sites)	{
                                           print "<option value='$_'>$sites{$_}</option>\n";
			}

print <<END

                                        </select>
                                    </td>
                                    <td width="5%">Interval:</td><td width="20%">
                                        <span><select onchange="livegraphrate(this.value)" style="width:70%;" class="form-control animated flipInY">
                                            <option value='3000'>3 Seconds</option><option value='10000'>10 Seconds</option>
                                            <option value='30000'>30 Seconds</option>
                                            </select>
                                            </span>

                        </td>
                    </tr>
                </table>


            </div>
        </div>
    </div>





    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x2_title title_block">
            <h2>Optimized Mbps : Wan Tx</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320"">
            <div class="x_content">
		<center>
                    <canvas id="canvas" width="600" height="130" ></canvas><br>
                        <span id="graphdir">Optimized Mbps from Lan <div id='boxsmall' style='background:#999'></div> to Wan <div id='boxsmall' style='background:#70944D'></div> </span>
                        <span id="graphinterval_tx">in 3 sec intervals</span>
                    </center>
            </div>
        </div>
    </div>

    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x2_title title_block">
            <h2>Optimized Mbps : Wan Rx</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

    <center>
    <canvas id="canvas1" width="600" height="130" ></canvas><br>
    <span id="graphdir">Optimized Mbps from Wan <div id='boxsmall' style='background:#70944D'></div> to Lan <div id='boxsmall' style='background:#999'></div> </span>
    <span id="graphinterval_rx">in 3 sec intervals</span>
    </center>

    </div>
    </div>
    </div>







    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x2_title title_block">
            <h2>Ratio</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

    <center>
    <canvas id="canvas2" width="600" height="130" ></canvas><br>
    <span >Ratio: Wan Rx <div id='boxsmall' style='background:#999'></div> Wan Tx <div id='boxsmall' style='background:#70944D'></div> </span>
    <span id="graphinterval_ratio">in 3 sec intervals</span>
    </center>

    </div>
    </div>
    </div>

    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x2_title title_block">
            <h2><span id="graphrtt_title">Pass-Through Mbps</span></h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

                    <center>
		    <canvas id="canvas3" width="600" height="130" ></canvas><br>
                        <span id="graphrtt">Pass-Through Mbps Wan Rx <div id='boxsmall' style='background:#999'></div> Wan Tx <div id='boxsmall' style='background:#70944D'></div></span>
                        <span id="peer_rtt"></span>
                        <span id="graphinterval_rtt">in 3 sec intervals</span>
                    </center>


            </div>
        </div>
    </div>



</div>







<div class="row">

    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Protocols: <span id="apps_stats_for">Total</span></h2> 
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

			    <table style="width:100%; position:relative; top:10px" class="table table-striped" id="proto_table" title="Top protocols in the last hour">
				    <thead>
				        <tr>
				            <th>Application</th>
				            <th>LAN Traffic %</th>
				            <th>LAN MB</th>
				            <th width='20%'>Optimization</th>
				            <th>WAN MB</th>
				            <th>Legend</th>
				            <th>Chart</th>
				        </tr>
				    </thead>
				    <tbody>
				        <div id='chartdata_table' title="Top protocols in the last hour" ></div>
				    </tbody>
				</table>
            </div>
        </div>
 <div style="position:relative;float:right; top:-255px; right:50px">				    <canvas id="chart-area" width="230" height="230"></canvas></div>
    </div>

</div>

END
;

my $myhostname;
open(ROW, "<", "/tce/etc/hostname") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
        chomp;
	$myhostname = $_;
}
print "<script> document.title ='" . $myhostname . " - ' + location.hostname; </script>\n"; 
