#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;

my @graphs;
my $cgi = CGI->new;
my $name = $cgi->param( "trend" );
my $desc = $cgi->param( "desc" );
my $time = $cgi->param( "time" );
my $export = $cgi->param( "export" );
my $maingraph = $cgi->param( "main" );
my $maingraphvalue = lc $maingraph;

my $datestring = time();

my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param( "ajax_trigger" );

$maingraphvalue =~ s/\s//g;
if ($time eq '') {
    $time = 'Day';
}
my $timename;
if ($time eq 'Hour') {
    $timename = "Last Hour";
}
if ($time eq 'Day') {
    $timename = "Last Day";
}
if ($time eq 'Week') {
    $timename = "Last Week";
}
if ($time eq 'Month') {
    $timename = "Last Month";
}
if ($time eq 'Year') {
    $timename = "Last Year";
}

if ($maingraph eq '') {
    $maingraph = 'Total';
}
if ($maingraph eq 'Total')
{
    push ( @graphs, "total-rate,Total Optimized", "total-passthrough, Total Pass-Through",
        "total-ratio,Total Ratio" );
}
else
{
    push ( @graphs, "$maingraphvalue-rate,$maingraph : Traffic", "$maingraphvalue-ratio,$maingraph : Ratios" );
}

if ($export eq 'pdf')
{
    open ( OUT, ">/tce/www/stats/reports/optimization.html" ) or die "Can't open OUT: $!";
    $url = "/tce/www";
}
else {
    open ( OUT, ">&STDOUT" ) or die "Can't open OUT: $!";
}

open( ROW, "<", "/tce/etc/wanos/peersites" ) || die( "Couldn't open the file. Error: $!\n" );
while (<ROW>)
{
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $commastring) = split( /\s*=\s*/, $_, 2 );
    $commastring =~ s/(\$(\w+))/$rows{$2}/g;
    $rows{$key} = $commastring;
    my @values = split( ',', $commastring );
    $sites{$values[1]} = $values[2];
}
close ROW;
my $num_sites = scalar keys %sites;

my @colors_arr = (
    # top, top opacity, bottom, bottom opacity ;
    [ '#CCCCCC', '0.2', '#555555', '0.2' ],
    [ '#669900', '0.5', '#30b300', '0.2' ],
    [ '#CCCCCC', '0.2', '#555555', '0.2' ],
    [ '#669900', '0.5', '#228000', '0.2' ],
    [ '#ADD100', '0.2', '#7B920A', '0.2' ],
    [ '#414d0b', '0.2', '#727a17', '0.2' ],
    [ '#727a17', '0.2', '#606b2c', '0.2' ],
    [ '#98B937', '0.2', '#144d00', '0.2' ]
);

if ($ajax_trigger == 0) {
    print OUT<<END

<div class="page-title">
    <div class="title_left">
        <h3>$title</h3>
    </div>
</div>
<div class="clearfix"></div>

<style>

END
    ;

    my $k = 0;
    for my $colors (@colors_arr) {

        print OUT '.gradient'.$k.' {';
        print OUT  'fill: url(#gradient-area'.$k.');';
        print OUT  '}';

        print OUT  '.line'.$k.' {';
        print OUT  'fill: none; stroke: '.@$colors[0].'; stroke-width: 1;';
        print OUT  '}';

        for (my $j = 0; $j < 4; $j++) {
            if ($j == 0) {
                print OUT  '.lgt'.$k.' {';
                print OUT  'stop-color : '.@$colors[$j].';';
            }

            if ($j == 1) {
                print OUT  'stop-opacity : '.@$colors[$j].';';
            }

            if ($j == 2) {
                print OUT  '}';
                print OUT  '.lgb'.$k.' {';
                print OUT  'stop-color : '.@$colors[$j].';';
            }

            if ($j == 3) {
                print OUT  'stop-opacity : '.@$colors[$j].';';
                print OUT  '}';
            }
        }

        for (my $m = 0; $m < 4; $m++) {
            if ($m == 0) {
                print OUT  '.legend'.$k.' {';
                print OUT  'background: '.@$colors[$m].';';
            }

            if ($m == 3) {
                print OUT  '}';
            }
        }
        $k++;
    }

    print OUT<<END
</style>

END
    ;

    print OUT<<END;
<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Display Options</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
    ;

    print OUT <<END;
<form id="optimization_form" action="#" method="post">
    <table class="nav-table" width="100%">
        <tr>
            <td>

                <td>Peer:
                    <br>
                    <select id="main" name="main" class="form-control animated flipInY" style="width:80%">
                        <option value="$maingraph">$maingraph</option>
                        <option value="Total">Total</option>
END
    ;

    foreach (keys %sites) {
        print OUT "<option value='Peer $_'>$sites{$_}</option>\n";
    }

    print OUT <<END

                    </select>
                </td>
                <td>Period:
                    <br>
                    <select id="time" name="time" class="form-control animated flipInY" style="width:80%">
                        <option value="$time">$timename</option>
                        <option value="Hour">Last Hour</option>
                        <option value="Day">Last Day</option>
                        <option value="Week">Last Week</option>
                        <option value="Month">Last Month</option>
                        <option value="Year">Last Year</option>
                    </select>
                </td>
                <td style="display:none;">Export:
                    <br>
                    <select id="export" name="export" class="form-control animated flipInY" style="width:100px;">
                        <option></option>
                        <option value="pdf">&nbsp;PDF&nbsp;</option>
                    </select>
                </td>
                <td align='left'>
                    <br>
                    <button id="btn_submit" type="submit" class="btn btn-success" style="font-size: 8pt;">Submit</button>
                </td>
        </tr>
        </center>
    </table>
</form>
END
    ;

    print OUT  <<END

            </div>
        </div>
    </div>
</div>
END
    ;

}

print OUT<<END
<div id="optimization_ctx">
END
;

my $i = 0;
my $j = 0;
if ($name eq '')
{
    foreach $graph (@graphs)
    {
        ($graphname, $desc) = split( ',', $graph );
        if (($i % 2) == 0) { print OUT "<div class='row'>\n"; }

        print OUT<<END;

            <div class="col-md-6 col-sm-6 col-xs-6">
                <div class="x_title title_block">
                    <h2>$desc</h2>
                    <ul class="nav navbar-right panel_toolbox">
                        <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                        <li><a class="close-link"><i class="fa fa-close"></i></a>
                        </li>
                    </ul>
                    <div class="clearfix"></div>
                </div>
                <div class="x_panel fixed_height_320">
                    <div class="x_content">

END
        ;


        my $filename = "../stats/$graphname-$time.json";

        if (-r $filename) {

            open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                local $/;
                $json = <$fh>;
            }

            print OUT<<END;
                    <script type="text/javascript">
END
            ;

            if ($graphname =~ 'ratio') {
                print OUT "window.ratio = 'ratio';";
            } else {
                print OUT "window.ratio = undefined;";
            }

            print OUT<<END
                    var json=$json, tmp_arr = [], minimum, maximum;
                    var DURATION = 1500;
                    var DELAY    = 500;

                    window.min = 0;
                    window.max = 0;

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;
                        for(var j = 0; j < length_value; j++) {
                            tmp_arr[j] = [];

                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr[j].push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
END
            ;
            if ($graphname =~ 'ratio') {
                print OUT "'value': typeof json.data[i][j*length_value + 1] != 'object' ? parseFloat(json.data[i][j*length_value + 1])*100: 0";
            } elsif ($graphname =~ 'rate') {
                print OUT "'value': typeof json.data[i][j * (length_value/2) + 1] != 'object' ? parseFloat(json.data[i][j * (length_value/2) + 1]) : 0";
            } else {
                print OUT "'value': typeof json.data[i][j*length_value + 1] != 'object' ? parseFloat(json.data[i][j*length_value + 1]): 0";
            }
            print OUT<<END
                                    });
                                }
                            }

                            maximum = d3.max(tmp_arr[j], function (d) {
                		return Math.ceil(d.value * 1.1)
                            }) > 1 ? d3.max(tmp_arr[j], function (d) {
                		return Math.ceil(d.value * 1.1)
                            }) : 0;

                            minimum = d3.min(tmp_arr[j], function (d) {
                		return Math.ceil(d.value * 1.1)
                            }) < 1 ? d3.min(tmp_arr[j], function (d) {
                		return Math.ceil(d.value * 1.1)
                            }) : 0;

                            if(minimum < window.min) {
                                window.min = minimum;
                            }

                            if(maximum > window.max) {
                                window.max = maximum;
                            }

                        }

                        for(var j = 0; j < length_value; j++) {
                            drawLineChart('lineChart$i', tmp_arr[j], 'traffic', '$desc the Last Day', j);
                        }

                    }

                </script>

                <script type="text/javascript">
END
            ;

            if ($graphname =~ 'rate') {
                print OUT "drawLegend('lineChart$i', json, 'traffic', true);";
            } else {
                print OUT "drawLegend('lineChart$i', json, 'traffic');";
            }

            print OUT<<END
                </script>

                <a href="#" id="lineChart$i" class="d3graph img-table" data-desc='$desc' data-name='$graphname'>
                    <svg id="lineChartSVG$i" class="lineChart--svg">
                      <defs>
END
            ;

            my $n = 0;
            for my $colors (@colors_arr) {

                for (my $j = 0; $j < 4; $j++) {

                    if ($j == 0) {
                        print OUT '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                        print OUT '<stop class="lgt'.$n.'" offset="0%" />';
                    }

                    if ($j == 1) {
                        print OUT '<stop class="lgb'.$n.'" offset="100%" />';
                    }

                    if ($j == 3) {
                        print OUT '</linearGradient>';
                    }
                }
                $n++;
            }
            print OUT<<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
            ;

        } else {
            print OUT "No Data<br>\n";
        }

        print OUT  <<END

                    </div>
                </div>
            </div>
END
        ;

        $i++;
        if (($i % 2) == 0) { print OUT "</div>\n"; }
    }

} else {

    print OUT<<END;

        <div class="row">
END
    ;

    foreach $period ("Hour", "Day", "Week", "Month", "Year") {

        print OUT<<END;

            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="x2_title title_block">
                    <h2>$desc : $period</h2>
                    <ul class="nav navbar-right panel_toolbox">
                        <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                        <li><a class="close-link"><i class="fa fa-close"></i></a>
                        </li>
                    </ul>
                    <div class="clearfix"></div>
                </div>
                <div class="x_panel fixed_height_320">
                    <div class="x_content">

END
        ;


        if ($name =~ 'rate') {

            my $filename = "../stats/$name-$period.json";

            if (-r $filename) {

                open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                    local $/;
                    $json = <$fh>;
                }

                print OUT<<END;
                    <script type="text/javascript">
END
                ;

                if ($name =~ 'ratio') {
                    print OUT "window.ratio = 'ratio';";
                } else {
                    print OUT "window.ratio = undefined;";
                }

                print OUT<<END
                    var json=$json, tmp_arr = [], minimum, maximum;
                    var DURATION = 1500;
                    var DELAY    = 500;

                    window.min = 0;
                    window.max = 0;
                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;
                        for(var j = 0; j < length_value; j++) {
                            tmp_arr[j] = [];

                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr[j].push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j * (length_value/2) +1] != 'object' ? parseFloat(json.data[i][j * (length_value/2) +1]) : 0
                                    });
                                }
                            }

                            maximum = d3.max(tmp_arr[j], function (d) {
                                return Math.ceil(d.value * 1.1)
                            }) > 1 ? d3.max(tmp_arr[j], function (d) {
                                return Math.ceil(d.value * 1.1)
                            }) : 10;

                            minimum = d3.min(tmp_arr[j], function (d) {
                                return Math.ceil(d.value * 1.1)
                            }) < 1 ? d3.min(tmp_arr[j], function (d) {
                                return Math.ceil(d.value * 1.1)
                            }) : 10;

                            if(minimum < window.min) {
                                window.min = minimum;
                            }

                            if(maximum > window.max) {
                                window.max = maximum;
                            }

                        }

                        for(var j = 0; j < length_value; j++) {

                            drawLineChart('lineChart$j', tmp_arr[j], 'traffic', '$desc the Last $period', j);
                        }

                    }

                </script>

                <script type="text/javascript">
                    drawLegend('lineChart$j', json, 'traffic', true);
                </script>

                <a href="#" id="lineChart$j" class="d3graph img-table">
                    <svg id="lineChartSVG$j" class="lineChart--svg">
                      <defs>
END
                ;

                my $n = 0;
                for my $colors (@colors_arr) {

                    for (my $j = 0; $j < 4; $j++) {

                        if ($j == 0) {
                            print OUT '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                            print OUT '<stop class="lgt'.$n.'" offset="0%" />';
                        }

                        if ($j == 1) {
                            print OUT '<stop class="lgb'.$n.'" offset="100%" />';
                        }

                        if ($j == 3) {
                            print OUT '</linearGradient>';
                        }
                    }
                    $n++;
                }
                print OUT<<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
                ;

            } else {
                print OUT "No Data<br>\n";
            }
            $j++;

        } else {

            my $filename = "../stats/$name-$period.json";
            if (-r $filename) {

                open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                    local $/;
                    $json = <$fh>;
                }


                print OUT<<END;
                    <script type="text/javascript">
END
                ;

                if ($name =~ 'ratio') {
                    print OUT "window.ratio = 'ratio';";
                } else {
                    print OUT "window.ratio = undefined;";
                }

                print OUT<<END
                    var json=$json, tmp_arr = [], minimum, maximum;
                    var DURATION = 1500;
                    var DELAY    = 500;

                    window.min = 0;
                    window.max = 0;
                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;
                        for(var j = 0; j < length_value; j++) {
                            tmp_arr[j] = [];

                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr[j].push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,

END
                ;
                if ($name =~ 'ratio') {
                    print OUT "'value': typeof json.data[i][j*length_value + 1] != 'object' ? parseFloat(json.data[i][j*length_value + 1])*100: 0";
                } else {
                    print OUT "'value': typeof json.data[i][j*length_value + 1] != 'object' ? parseFloat(json.data[i][j*length_value + 1]) : 0";
                }
                print OUT<<END
                                    });
                                }

                            }

                            maximum = d3.max(tmp_arr[j], function (d) {
                    		return Math.ceil(d.value * 1.1)
                            }) > 1 ? d3.max(tmp_arr[j], function (d) {
                    		return Math.ceil(d.value * 1.1)
                            }) : 0;

                            minimum = d3.min(tmp_arr[j], function (d) {
                    		return Math.ceil(d.value * 1.1)
                            }) < 1 ? d3.min(tmp_arr[j], function (d) {
                    		return Math.ceil(d.value * 1.1)
                            }) : 0;

                            if(minimum < window.min) {
                                window.min = minimum;
                            }

                            if(maximum > window.max) {
                                window.max = maximum;
                            }

                        }

                        for(var j = 0; j < length_value; j++) {
                            drawLineChart('lineChart$j', tmp_arr[j], 'traffic', '$desc the Last $period', j);
                        }

                    }

                </script>

                <script type="text/javascript">
END
                ;

                if ($name =~ 'rate') {
                    print OUT "drawLegend('lineChart$j', json, 'traffic', true);";
                } else {
                    print OUT "drawLegend('lineChart$j', json, 'traffic');";
                }

                print OUT<<END
                </script>

                <a href="#" id="lineChart$j" class="d3graph img-table">
                    <svg id="lineChartSVG$j" class="lineChart--svg">
                      <defs>
END
                ;

                my $n = 0;
                for my $colors (@colors_arr) {

                    for (my $j = 0; $j < 4; $j++) {

                        if ($j == 0) {
                            print OUT '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                            print OUT '<stop class="lgt'.$n.'" offset="0%" />';
                        }

                        if ($j == 1) {
                            print OUT '<stop class="lgb'.$n.'" offset="100%" />';
                        }

                        if ($j == 3) {
                            print OUT '</linearGradient>';
                        }
                    }
                    $n++;
                }
                print OUT<<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
                ;

            } else {
                print OUT  <<END;

		No Data
END
                ;
            }

            $j++;

        }

        print OUT  <<END

                    </div>
                </div>
            </div>
END
        ;

    }

    print OUT  <<END
        </div>
END
    ;
}

if ($ajax_trigger == 0) {
    print OUT  <<END

            </div>
        </div>
    </div>
</div>
END
    ;
}

print OUT<<END
</div>
END
;

close OUT;

if ($export eq 'pdf')
{
    system( "/tce/packages/click/exporttool /tce/www/stats/reports/optimization.html /tce/www/stats/reports/optimization.pdf" );
    print <<END
        <strong>Report Ready</strong> <br />
        Optimization report is ready for download:
        <a href='../stats/reports/optimization.pdf' style='color:#777'>Optimization stats for $maingraph from the $timename</a>

END
    ;
}

