#!/usr/local/bin/perl

my @lic;
open(INFO, "<", "/tce/etc/wanos/license.info") || die("Couldn't open the file. Error: $!\n");
while (<INFO>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $variable) = split(/\s*=\s*/, $_, 2);
	$variable =~ s/(\$(\w+))/$lic{$2}/g;
	$lic{$key} = $variable;
}
close INFO;

my @config;
open(CONFIG, "<", "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
while (<CONFIG>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $variable) = split(/\s*=\s*/, $_, 2);
	$variable =~ s/(\$(\w+))/$config{$2}/g;
	$config{$key} = $variable;
}
close CONFIG;

my $reg_token;
open(PREKEY, "<", "/tmp/wanos_prelicense.pre") || die("Couldn't open the file. Error: $!\n");
while (<PREKEY>) {
	$reg_token = $_;
}
close(PREKEY);

@info = `/tce/etc/wanos/makewanoscfg.sh -aqm_name`;
foreach (@info)
{
	next unless /NAME=/;
	$prod_name = (split(/=/, $_, 2))[1];
}

print <<END

<div class="page-title">
    <div class="title_left">
        <h3>License</h3>
    </div>
</div>


<div class="clearfix"></div>

<div class="row">
    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>Get Trial Keys</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">
END
;

print "<table border=0 width=200 cellpadding=0>";
print "<tr><td width=60>Version:</td><td>$config{VERSION}</td></tr>\n";
print "<tr><td>Status:</td><td>$lic{STATUS}</td></tr>\n";
print "<tr><td>Active:</td><td>$prod_name</td></tr>\n";
if ($lic{STATUS} ne 'Unlicensed')
{
	print "<tr><td>Expire:</td><td>$lic{EXPIRE}</td></tr>\n";
}

print <<END
</table>

<hr />

<form id="get_trial_form" data-parsley-validate class="form-horizontal form-label-left" name="trial-form" action="http://wanos.co/wan-optimization/trial-form/#wpcf7-f2201-p2206-o1" method="post" target="_blank">

    <div class="form-group">
        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="your-name">First Name <span class="required">*</span>
        </label>
        <div class="col-md-6 col-sm-6 col-xs-12">
            <input type="text" name="your-name" value="" size="40" maxlength="100" aria-required="true" aria-invalid="false" required="required" class="form-control col-md-7 col-xs-12">
        </div>
    </div>

    <div class="form-group">
        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="last-name">Last Name <span class="required">*</span>
        </label>
        <div class="col-md-6 col-sm-6 col-xs-12">
            <input type="text" id="last-name" name="last-name" value="" size="40" maxlength="100" aria-required="true" aria-invalid="false" required="required" class="form-control col-md-7 col-xs-12">
        </div>
    </div>

    <div class="form-group">
        <label for="your-email" class="control-label col-md-3 col-sm-3 col-xs-12">Email address <span class="required">*</span></label>
        <div class="col-md-6 col-sm-6 col-xs-12">
            <input type="text" name="your-email" value="" size="40" maxlength="100" aria-required="true" aria-invalid="false" required="required" class="form-control col-md-7 col-xs-12">
        </div>
    </div>

    <div class="form-group">
        <label for="your-email" class="control-label col-md-3 col-sm-3 col-xs-12">Title <span class="required">*</span></label>
        <div class="col-md-6 col-sm-6 col-xs-12">
            <input type="text" name="title" value="" size="40" maxlength="100" aria-required="true" aria-invalid="false" required="required" class="form-control col-md-7 col-xs-12">
        </div>
    </div>

    <div class="form-group">
        <label for="company" class="control-label col-md-3 col-sm-3 col-xs-12">Company <span class="required">*</span></label>
        <div class="col-md-6 col-sm-6 col-xs-12">
            <input type="text" name="company" value="" size="40" maxlength="100" aria-required="true" aria-invalid="false" required="required" class="form-control col-md-7 col-xs-12">
        </div>
    </div>

    <div class="form-group">
        <label for="country" class="control-label col-md-3 col-sm-3 col-xs-12">Country <span class="required">*</span></label>
        <div class="col-md-6 col-sm-6 col-xs-12">
            <input type="text" name="country" value="" size="40" maxlength="100" aria-required="true" aria-invalid="false" required="required" class="form-control col-md-7 col-xs-12">
        </div>
    </div>

    <div class="form-group">
        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="token">Appliance Registration Token <span class="required">*</span>
        </label>
        <div class="col-md-6 col-sm-6 col-xs-12">
            <textarea class="form-control" rows="5" placeholder="" required="required" name="token">$reg_token</textarea>
        </div>
    </div>

    <div class="ln_solid"></div>
    <div class="form-group">
        <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
            <a type="button" class="btn btn-default" href="/#/license" onclick="window.scrollTo(0, 0);" style='font-size: 8pt'>Cancel</a>
            <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt'>Submit</button>
        </div>
    </div>

    <input type="hidden" name="_wpcf7" value="2201" />
    <input type="hidden" name="_wpcf7_version" value="3.9.3" />
    <input type="hidden" name="_wpcf7_locale" value="en_US" />
    <input type="hidden" name="_wpcf7_unit_tag" value="wpcf7-f2201-p2206-o1" />
    <input type="hidden" name="_wpnonce" value="0b275d1f63" />

</form>

END
;

print <<END

        </div>
    </div>
</div>
END
;
