#!/usr/local/bin/perl

my @lic;
open(INFO, "<", "/tce/etc/wanos/license.info") || die("Couldn't open the file. Error: $!\n");
while (<INFO>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $variable) = split(/\s*=\s*/, $_, 2);
	$variable =~ s/(\$(\w+))/$lic{$2}/g;
	$lic{$key} = $variable;
}
close INFO;

my @config;
open(CONFIG, "<", "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
while (<CONFIG>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $variable) = split(/\s*=\s*/, $_, 2);
	$variable =~ s/(\$(\w+))/$config{$2}/g;
	$config{$key} = $variable;
}
close CONFIG;

=HEAD1
$license = $lic{TYPE};                
if ($lic{STATUS} eq "Unlicensed" ) { $license = "Express 1/10 Mbps";}
elsif ($license eq "1147100002" ) { $license = "Plus";}                
elsif ($license eq "1147100003" ) { $license = "Express 1/10 Mbps";}   
elsif ($license eq "1147100004" ) { $license = "Express 2/20 Mbps";}
elsif ($license eq "1147100005" ) { $license = "Express 4/40 Mbps";}   
elsif ($license eq "1147100006" ) { $license = "Express 6/60 Mbps";}
elsif ($license eq "1147100007" ) { $license = "Express 10/100 Mbps";}
elsif ($license eq "1147100008" ) { $license = "Express 20/200 Mbps";}
elsif ($license eq "1147100009" ) { $license = "Express 50/200 Mbps";}
elsif ($license eq "1147100010" ) { $license = "Express 100/200 Mbps";}
elsif ($license eq "1147100011" ) { $license = "Express 200/200 Mbps";}
elsif ($license eq "1147100012" ) { $license = "Express 1 Gbps";}
elsif ($license eq "1147100020" ) { $license = "Plus 2/20 Mbps";}
elsif ($license eq "1147100021" ) { $license = "Plus 4/40 Mbps";}
elsif ($license eq "1147100022" ) { $license = "Plus 6/60 Mbps";}
elsif ($license eq "1147100023" ) { $license = "Plus 10/100 Mbps";}
elsif ($license eq "1147100024" ) { $license = "Plus 20/200 Mbps";}    
elsif ($license eq "1147100025" ) { $license = "Plus 50/200 Mbps";}
elsif ($license eq "1147100026" ) { $license = "Plus 100/200 Mbps";}
elsif ($license eq "1147100027" ) { $license = "Plus 200/200 Mbps";}
elsif ($license eq "1147100028" ) { $license = "Plus 1 Gbps";}
else { $license = "None"; }
=cut

@info = `/tce/etc/wanos/makewanoscfg.sh -aqm_name`;
foreach (@info)
{
	next unless /NAME=/;
	$prod_name = (split(/=/, $_, 2))[1];
}

print <<END

<div class="page-title">
    <div class="title_left">
        <h3>License</h3>
    </div>
</div>


<div class="clearfix"></div>

<div class="row">
    <div class="col-md-4 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>Status</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">
END
;

print "<table border=0 width=200 cellpadding=0>";
print "<tr><td width=60>Version:</td><td>$config{VERSION}</td></tr>\n";
print "<tr><td>Status:</td><td>$lic{STATUS}</td></tr>\n";
print "<tr><td>Active:</td><td>$prod_name</td></tr>\n";
if ($lic{STATUS} ne 'Unlicensed')
{
	print "<tr><td>Expire:</td><td>$lic{EXPIRE}</td></tr>\n";
}

print <<END

</table>

<div style="margin-bottom:-15px;">
    <div style="display:inline-block;">

        <form id='license_new' action="" method="post">
            <br />
            <input type="submit" value="Add New" size="3" style="font-size: 8pt" class="btn btn-default">
        </form>

    </div>

    <div style='display:inline-block;'>
        <form id='license_trial' action='get-trial.pl' method='post'>
            <input type='submit' value='Get Trial' size='3' style='font-size: 8pt' class="btn btn-default">
        </form>
    </div>
</div>

<hr />

<ul>
    <li>License applies to a single appliance</li>
    <li>The Software may not be modified or resold</li>
    <li>By downloading, installing or using the product in any way the Licensee agree to the terms of this agreement.</li>
</ul>
<br />

</div>
</div>
</div>

<div class="col-md-8 col-sm-8 col-xs-12">
    <div class="x_title title_block">
        <h2>Terms and conditions</h2>
        <ul class="nav navbar-right panel_toolbox">
            <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
            </li>
            <li><a class="close-link"><i class="fa fa-close"></i></a>
            </li>
        </ul>
        <div class="clearfix"></div>
    </div>
    <div class="x_panel fixed_height_320">
        <div class="x_content">

            <ol>
                <li>Preamble: This Agreement governs the relationship between the End User, Entity or Company, (hereinafter: Licensee) and Wanos Networks Pty(Ltd), a duly registered company (Hereinafter: Licensor). This Agreement sets the terms, rights, restrictions and obligations on using [Wanos] (hereinafter: The Software) created and owned by Licensor, as detailed herein</li>
                <li>License Grant: Licensor hereby grants Licensee a Non-assignable &amp; non-transferable, Non-commercial, without the rights to modify the software, Non-exclusive license, all with accordance with the terms set forth and other legal restrictions set forth in 3rd party software used while running Software.
                    <li>Prior Inspection: Licensee hereby states that he inspected The Software thoroughly and found it satisfactory and adequate to his needs and that it does not interfere with his regular operation.</li>
                    <li>Non-Commercial: Licensee may not resell the Software or use any part for commercial purposes.</li>
                    <li>Term &amp; Termination: The Terms of this license shall be until terminated.</li>
                    <li>Upgrades, Updates and Fixes: Licensor may provide Licensee, from time to time, with Upgrades, Updates or Fixes, according to his sole discretion. Licensee hereby warrants to keep The Software up-to-date and install all relevant updates and fixes, and may, at his sole discretion, purchase upgrades, according to the rates set by Licensor. Nothing in this Agreement shall require Licensor to provide Updates or Fixes.</li>
                    <li>Support: Software is provided under an AS-IS basis and without any support, updates or maintenance. Nothing in this Agreement shall require Licensor to provide Licensee with support or fixes to any bug, failure, mis-performance or other defect in The Software.</li>
                    <li>Liability: To the extent permitted under Law, The Software is provided under an AS-IS basis. Licensor shall never, and without any limit, be liable for any damage, cost, expense or any other payment incurred by Licensee as a result of using the Software.</li>
                    <li>No-Warranty: The Software is provided without any warranty; Licensor hereby disclaims any warranty that The Software shall be error free or without defects.</li>
                    <li>Indemnification: Licensee hereby warrants to hold Licensor harmless and indemnify Licensor for any lawsuit brought against it in regards to Licensee use of The Software in means that violate, breach or otherwise circumvent this license, Licensor's intellectual property rights or Licensor's title in The Software.</li>
                    <li>Governing Law, Jurisdiction: Licensee hereby agrees not to initiate class-action lawsuits against Licensor in relation to this license and to compensate Licensor for any legal fees, cost or attorney fees should any claim brought by Licensee against Licensor be denied, in part or in full.</li>
            </ol>

        </div>
    </div>
</div>

</div>

END
;
