#!/usr/local/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;
my $cgi = CGI->new;
my $loglevel = $cgi->param("loglevel");

if ($loglevel eq '') {

    print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Logging</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Log information</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
    ;


    print '<form id="log_level" action="/cgi-bin/update.pl" method="post" class="form-inline">
            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="log_level">Display log level:</label>
              <div class="form-group"><select name="loglevel" id="log_level" class="form-control">';

    if ($loglevel ne 'Debug') {
        print "<option value='Informational' selected='selected'>Informational</option>\n";
    }
    else {
        print "<option value='Informational' >Informational</option>\n";
    }
    if ($loglevel ne 'Debug') {
        print "<option value='Debug'>Debug</option>\n";
    }
    else {
        print "<option value='Debug' selected='selected'>Debug</option>\n";
    }

    print '</select></div>
        </form><hr /><br />';
    print "<pre class='content' style='font-size:8pt; margin-left:20px'>\n";

    my $input = `tail -n 2000 /wanos/wanos.log`;
    my @loglines = split(/\n/, $input);
    my @printlines;
    my $arrsize = 0;
    my $c = 0;

    foreach (@loglines)
    {
        my $tmp_line;
        if ($loglevel ne 'Debug') {
            next if /^*:\s*Debug/;
        }
        if (/^*:\s*Alert/) {
            $tmp_line = "<font color='orange'>" . $_ . "</font>";
        }
        elsif (/^*:\s*Error/) {
            $tmp_line = "<font color='red'>" . $_ . "</font>";
        }
        else {
            $tmp_line = $_;
        }
        push (@printlines, $tmp_line);
    }
    $arrsize = @printlines;

    foreach (@printlines)
    {
        if ($arrsize - $c <= 134)
        {
            print $_ . "\n";
        }
        $c++;
    }

    print "</pre>";
    print <<END

        </div>
    </div>

</div>
END
;

} else {

    print $cgi->header('text/plain;charset=UTF-8');

    my $input = `tail -n 2000 /wanos/wanos.log`;
    my @loglines = split(/\n/, $input);
    my @printlines;
    my $arrsize = 0;
    my $c = 0;

    foreach (@loglines)
    {
        my $tmp_line;
        if ($loglevel ne 'Debug') {
            next if /^*:\s*Debug/;
        }
        if (/^*:\s*Alert/) {
            $tmp_line = "<font color='orange'>" . $_ . "</font>";
        }
        elsif (/^*:\s*Error/) {
            $tmp_line = "<font color='red'>" . $_ . "</font>";
        }
        else {
            $tmp_line = $_;
        }
        push (@printlines, $tmp_line);
    }
    $arrsize = @printlines;

    foreach (@printlines)
    {
        if ($arrsize - $c <= 134)
        {
            print $_ . "\n";
        }
        $c++;
    }

}