#!/usr/local/bin/perl -w
#
# Copyright (c) 2010-2014 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use IO::Socket;
use warnings;

my $cgi = CGI->new;

open(ROW, "<", "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $commastring) = split(/\s*=\s*/, $_, 2);
	$commastring =~ s/(\$(\w+))/$rows{$2}/g;
	$rows{$key} = $commastring;
	my @values = split(',', $commastring);
	$sites{$values[1]} = $values[2];
}
close ROW;

my $getstatus = $cgi->param("getstatus");
if ($getstatus eq '1')
{
	my %stats = ();
	my $data;
	my @vars;
	autoflush STDOUT 1;
	#        printf "Status: 200\r\n\r\n";
	print "Content-type: text/json;\n\n";

	print "{\n";
	foreach (keys %sites)
	{
		$data = `/tce/etc/wanos/wanos-stats 2h peer$_ peerlanrx peer$_ peerwantx`;
		chomp($data);
		@vars = ();
		@vars = split(' ', $data);
		if (($vars[2] > 0) && ($vars[1] > 0))
		{
			my $ratio = sprintf("%.0f", (($vars[1] - $vars[2]) / $vars[1]) * 100);
			if ($ratio < 0) {
				$ratio = 0;
			}
			print "    \"peer_tx_ratio$_\": \"$ratio%\",\n";
		}

		$data = `/tce/etc/wanos/wanos-stats 2h peer$_ peerlantx peer$_ peerwanrx`;
		chomp($data);
		@vars = ();
		@vars = split(' ', $data);
		if (($vars[2] > 0) && ($vars[1] > 0))
		{
			my $ratio = sprintf("%.0f", (($vars[1] - $vars[2]) / $vars[1]) * 100);
			if ($ratio < 0) {
				$ratio = 0;
			}
			print "    \"peer_rx_ratio$_\": \"$ratio%\",\n";
		}

	}

	my @data;
	my $socket;
	$socket = IO::Socket::INET->new(PeerAddr => 'localhost', PeerPort => '13000', Proto => 'tcp',) or die("Error :: $! ");

	foreach (keys %sites)
	{
		print($socket "read bypass$_.active\r\n");
		print($socket "#\r\n");
	}
	print($socket "quit\r\n");
	@data = ();
	@data = <$socket>;
	my $datanum = scalar @data;
	for (my $i = 0; $i < $datanum; $i++)
	{
		next unless $data[$i] =~ /bypass.*OK/;
		my @bypass = split('\'', $data[$i]);
		$bypass[1] = (substr($bypass[1], 0, - 7));
		(my $data, my $len) = split(' ', $data[$i + 1], 2);
		$data = (substr($data[$i + 2], 0, $len));
		if ($data eq 'true') {
			$data = 'Idle';
		}
		if ($data eq 'false') {
			$data = 'Up';
		}
		print "    \"$bypass[1]\": \"$data\",\n";
	}
	close($socket);

	$socket = IO::Socket::INET->new(PeerAddr => 'localhost', PeerPort => '13000', Proto => 'tcp',) or die("Error :: $! ");

	foreach (keys %sites)
	{
		print($socket "read dedup$_.ds_ready\r\n");
		print($socket "#\r\n");
	}
	print($socket "quit\r\n");
	@data = ();
	@data = <$socket>;
	$datanum = scalar @data;
	for (my $i = 0; $i < $datanum; $i++)
	{
		next unless $data[$i] =~ /dedup.*OK/;
		my @dedup = split('\'', $data[$i]);
		$dedup[1] = (substr($dedup[1], 0, - 9));
		(my $data, my $len) = split(' ', $data[$i + 1], 2);
		$data = (substr($data[$i + 2], 0, $len));
		if ($data eq '0') {
			$data = 'Loading';
		}
		if ($data eq '1') {
			$data = 'Ready';
		}
		print "    \"$dedup[1]\": \"$data\",\n";
	}
	close($socket);

	$socket = IO::Socket::INET->new(PeerAddr => 'localhost', PeerPort => '13000', Proto => 'tcp',) or die("Error :: $! ");

	foreach (keys %sites)
	{
		print($socket "read comp$_.active_method\r\n");
		print($socket "#\r\n");
	}
	print($socket "quit\r\n");
	@data = ();
	@data = <$socket>;
	$datanum = scalar @data;
	for (my $i = 0; $i < $datanum; $i++)
	{
		next unless $data[$i] =~ /comp.*OK/;
		my @plr = split('\'', $data[$i]);
		$plr[1] = (substr($plr[1], 0, - 14));
		(my $data, my $len) = split(' ', $data[$i + 1], 2);
		$data = (substr($data[$i + 2], 0, $len));
		if ($data eq 'Streaming') {
			$data = 'On';
		}
		if ($data eq 'Stateless') {
			$data = 'Off';
		}
		print "    \"$plr[1]\": \"$data\",\n";
	}
	close($socket);

	print "    \"item0\": \"0\"\n}\n";
	print "  \n";
	print "  \n";
	autoflush STDOUT 1;
	exit;
}

print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Peer Status</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Peer status</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
;


print <<END
    <script>
	function peer_update_status()
	{
	   \$.ajax({
	   	dataType: "json",
		cache: false,
		data: {
			"getstatus" : 1
		},
	   	url:'/cgi-bin/peerstatus.pl',success:function(result){
END
;
foreach (keys %sites) {
	print "if ( typeof result.bypass$_ !== 'undefined' ) { document.getElementById('bypass$_').textContent = result.bypass$_; } \n";
}
foreach (keys %sites) {
	print "if ( typeof result.dedup$_ !== 'undefined' ) { document.getElementById('ds_ready$_').textContent = result.dedup$_; } \n";
}
foreach (keys %sites) {
	print "if ( typeof result.peer_rx_ratio$_ !== 'undefined' ) { document.getElementById('peer_rx_ratio$_').textContent = result.peer_rx_ratio$_; } \n";
}
foreach (keys %sites) {
	print "if ( typeof result.peer_rx_ratio$_ !== 'undefined' ) { document.getElementById('meter_rx$_').style.width = result.peer_rx_ratio$_; } \n";
}
foreach (keys %sites) {
	print "if ( typeof result.peer_tx_ratio$_ !== 'undefined' ) { document.getElementById('peer_tx_ratio$_').textContent = result.peer_tx_ratio$_; } \n";
}
foreach (keys %sites) {
	print "if ( typeof result.peer_tx_ratio$_ !== 'undefined' ) { document.getElementById('meter_tx$_').style.width = result.peer_tx_ratio$_; } \n";
}

foreach (keys %sites) {
	print "if ( typeof result.comp$_ !== 'undefined' ) { document.getElementById('plr_status$_').textContent = result.comp$_; } \n";
}

print <<END
	    	   }});
	}

    </script>

<table class="table table-striped">
    <thead>
        <tr>
            <th width='8%'>Site #</th>
            <th width='25%'>Site Name</th>
            <th width='11%'>Local Status</th>
            <th width='11%'>Peer Status</th>
            <th width='8%' title='Packet Loss Recovery and Packet Order Correction'>PLR</th>
            <th width='15%' title='Rx Reduction the last 2h'>Wan Rx Reduction</th>
            <th width='15%' title='Tx Reduction the last 2h'>Wan Tx Reduction</th>
            <th width='12%'>Graph</th>
        </tr>
    </thead>
    <tbody>

END
;

for my $i (0 .. 64)
{
	print "<tr><td><center>" . $i . "</center></td><td>" . $sites{$i} . "</td><td><center><span id='ds_ready$i'>   </span></center></td><td><center><span id='bypass$i'>   </span></center></td><td title='Packet Loss Recovery and Packet Order Correction'><center><span id='plr_status$i'> </span></center></td>\n";
	if ($sites{$i} ne '')
	{
		print "<td width='80' title='Rx Reduction the last 2h'><div class='meter'><span style='width: 0%' id='meter_rx$i'><div style='position:relative; left:84px; font-size:9px; width:20px;' id='peer_rx_ratio$i'></div></span></div></td>\n";
		print "<td width='80' title='Tx Reduction the last 2h'><div class='meter'><span style='width: 0%' id='meter_tx$i'><div style='position:relative; left:84px; font-size:9px; width:20px;' id='peer_tx_ratio$i'></div></span></div></td>\n";
		print "<td><center><a href='/#/peer_status/peer$i'><i class='fa fa-search'></i></a></center></td></tr>\n";
	}
	else {
		print "<td></td><td></td><td></td></tr>";
	}
}

print <<END

            </div>
        </div>
    </div>
</div>
END
;
