#!/usr/local/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;

my $cgi = CGI->new;
my $host = $cgi->param("host");
my $count = $cgi->param("count");
my $proto = $cgi->param("proto");
my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param("ajax_trigger");

my $result;
my $cmd;

print <<END
    <div class="page-title">
        <div class="title_left">
            <h3>Ping</h3>
        </div>
    </div>
    <div class="clearfix"></div>

    <div class="row">
        <div class="col-md-6 col-sm-6 col-xs-12">
            <div class="x_title title_block">
                <h2>Diagnostic Ping</h2>
                <ul class="nav navbar-right panel_toolbox">
                    <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                    </li>
                    <li><a class="close-link"><i class="fa fa-close"></i></a>
                    </li>
                </ul>
                <div class="clearfix"></div>
            </div>
            <div class="x_panel fixed_height_320">
                <div class="x_content">
                    <form id="ping" class="form-horizontal form-label-left" action="" method="post">

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="host">Host <span class="description">Ex: 192.168.0.1</span></label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <input type="text" id="host" name="host" size="16" maxlength="16" class="form-control col-md-7 col-xs-12" data-toggle="tooltip" title="Hostname or IP address of host to ping">
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="proto">IP Protocol</label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select id="proto" name="count" class="form-control" data-toggle="tooltip" title="Type of IP protocol to use for ping">
                                    <option value="ipv4">IPv4</option>
                                    <option value="ipv6">IPv6</option>
                                </select>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="count">Count</span></label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select id="count" name="count" class="form-control" data-toggle="tooltip" title="How many echo requests should be sent to host?">
                                    <option value="1">1</option>
                                    <option value="2">2</option>
                                    <option value="3">3</option>
                                    <option value="4">4</option>
                                    <option value="5">5</option>
                                    <option value="6">6</option>
                                    <option value="7">7</option>
                                    <option value="8">8</option>
                                    <option value="9">9</option>
                                    <option value="10">10</option>
                                </select>
                            </div>
                        </div>

                        <div class="ln_solid"></div>
                        <div class="form-group">
                            <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
                                <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Ping</button>
                            </div>
                        </div>
                        </form>
END
;

if ($ajax_trigger == 1) {

    if ($proto eq "ipv4") {
        $cmd = "ping";
    } elsif ($proto eq 'ipv6') {
        $cmd = "ping6";
    }

    $result = `$cmd -c $count $host`;

print <<END
    <div class="form-group">
        <h3>Results</h3>
        <div class="col-md-12 col-sm-12 col-xs-12">
            <textarea class="form-control" readonly="true" rows="15">$result</textarea>
        </div>
    </div>
END
;

}

print <<END
                </div>
            </div>
        </div>
    </div>
END
;
