#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
my $cgi = CGI->new;
my $time = $cgi->param("time");
my $topn = $cgi->param("topn");
my $export = $cgi->param("export");
my $peervalue = $cgi->param("peervalue");

my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param("ajax_trigger");

if ($ajax_trigger == 0) {

	print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Protocols</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Protocol Distribution</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
	;
}

my %site_names;
open(ROW, "<", "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $commastring) = split(/\s*=\s*/, $_, 2);
	$commastring =~ s/(\$(\w+))/$rows{$2}/g;
	$rows{$key} = $commastring;
	my @values = split(',', $commastring);
	$sites{$values[1]} = $values[0];
	$site_names{$values[1]} = $values[2];
}
close ROW;
my $num_sites = scalar keys %site_names;

my @portobjs;
open(OBJ, "<", "/tce/etc/wanos/portobjects") || die("Couldn't open the file. Error: $!\n");
while (<OBJ>)
{
	chomp;
	my ($key, $commastring) = split(/,/, $_, 2);
	$portobjs{$key} = $commastring;
}
close OBJ;

my %ltable = ();
my %wtable = ();
my %lptable = ();
my %wptable = ();
my %wlegend = ();
my @lpercent;
my @wpercent;
my @lport;
my @wport;

if ($topn eq '') {
	$topn = 10;
}
if ($time eq '') {
	$time = 1800;
}
my $timename;
if ($time eq '300') {
	$timename = "Last 5 Min";
}
if ($time eq '900') {
	$timename = "Last 15 Min";
}
if ($time eq '1800') {
	$timename = "Last 30 Min";
}
if ($time eq '3600') {
	$timename = "Last 60 Min";
}
if ($time eq '7200') {
	$timename = "Last 2 Hours";
}
if ($time eq '28800') {
	$timename = "Last 8 Hours";
}
if ($time eq '86400') {
	$timename = "Last 24 Hours";
}

my $peername;
if ($peervalue eq '') {
	$peername = "All";
}
else {
	$peername = "Peer " . $peervalue;
}

if ($export eq 'pdf')
{
	open (OUT, ">/tce/www/stats/reports/topprotocols.html") or die "Can't open OUT: $!";
	$nav = 1;
	$batch = 5000;
	$url = "/tce/www";
}
else {
	open (OUT, ">&STDOUT") or die "Can't open OUT: $!";
}

if ($nav eq '') {
	system( "sudo -u tc /tce/etc/wanos/flows $time ports $peervalue" );
}
open(LROW, "<", "/wanos/nf/l0/ports") || die("Couldn't open the file. Error: $!\n");
while (<LROW>)
{
	chomp;
	next unless /-/;
	my @array = split(',', $_);
	push(@lpercent, $array[10]);
	my $label = (split(',', ($portobjs{"$array[4]/6"})))[1];
	if ($label eq '') {
		$label = "TCP " . $array[4];
	}
	push(@lport, $label);
	$ltable{$array[4]} = $array[9];
	$lptable{$array[4]} = $array[10];
}
close LROW;

my $i = 0;
open(WROW, "<", "/wanos/nf/w0/ports") || die("Couldn't open the file. Error: $!\n");
while(<WROW>)
{
	chomp;
	next unless /-/;
	my @array2 = split(',', $_);
	push(@wpercent, $array2[10]);
	my $label = (split(',', ($portobjs{"$array2[4]/6"})))[1];
	if ($label eq '') {
		$label = "TCP " . $array2[4];
	}
	push(@wport, $label);
	$wtable{$array2[4]} = $array2[9];
	$wptable{$array2[4]} = $array2[10];
	$wlegend{$array2[4]} = $i++;
}
close WROW;

@legendb = ( "#748A2F", "#2875c3", "#ebb526", "#E68080", "#e24545", "#ffa289", "#9bb4fd", "#e973e7", "#64dbdb", "#D7D7D7", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe",);
@legendc = ( "#8ea93a", "#338fed", "#ffc52d", "#ff7d7d", "#ff3e3e", "#fd8160", "#6a8ffb", "#fe6efc", "#6ef5f5", "#e7e7e7", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe",);

print OUT  <<END
  <script>


	// Ports
	var LanData = [
END
;
$i = 0;
foreach (@lpercent)
{
	if ($_ eq '-nan') { $_ = 0; }
	print OUT  "{ value: " . $_ . ", color: '" . $legendb[$i] . "', highlight: '" . $legendc[$i] . "', label: '" . $lport[$i] . "' },\n";
	$i++;
	if ($i eq $topn) {
		last;
	}
}
print OUT  "];\n";
print OUT  "var WanData = [\n";
$i = 0;
foreach (@wpercent)
{
	print OUT  "{ value: " . $_ . ", color: '" . $legendb[$i] . "', highlight: '" . $legendc[$i] . "', label: '" . $wport[$i] . "' },\n";
	$i++;
	if ($i eq $topn) {
		last;
	}
}
print OUT  "];\n </script>";

if ($ajax_trigger == 0) {

	print OUT <<END
                <form id="protocols_form" action="" method="post">
                    <table class="nav-table" width="100%">
                        <tr>
                            <td>
                                Protocols:
                                <br>
                                <select id="topn" name="topn" class="form-control animated flipInY" style="width:70%">
                                    <option value="$topn">Top $topn</option>
                                    <option value="10">Top 10</option>
                                    <option value="20">Top 20</option>
                                    <option value="30">Top 30</option>
                                    <option value="40">Top 40</option>
                                </select>
                            </td>
                            <td>Period:
                                <br>
                                <select id="time" name="time" class="form-control animated flipInY" style="width:70%">
                                    <option value="$time">$timename</option>
                                    <option value="300">Last 5 Min</option>
                                    <option value="900">Last 15 Min</option>
                                    <option value="1800">Last 30 Min</option>
                                    <option value="3600">Last 60 Min</option>
                                    <option value="7200">Last 2 Hours</option>
                                    <option value="28800">Last 8 Hours</option>
                                    <option value="86400">Last 24 Hours</option>
                                </select>
                            </td>
                            <td>Peer:
                                <br>
                                <select id="peervalue" name="peervalue" title="Session Stats Level" class="form-control animated flipInY" style="width:70%">
                                    <option value="$peervalue">$peername</option>
                                    <option value="">All</option>

END
;

foreach (keys %sites)   {                      
                                           print OUT "<option value='$_'>$site_names{$_}</option>\n";
                        } 

print OUT <<END
                                </select>
                            </td>
                            <td style="display:none;">Export:
                                <br>
                                <select id="export" name="export" class="form-control animated flipInY" style="width:100px;">
                                    <option></option>
                                    <option value="pdf">&nbsp;PDF&nbsp;</option>
                                </select>
                            </td>
                            <td align='left'>
                                <br>
                                <button id="btn_submit" type="submit" class="btn btn-success" style="font-size: 8pt;">Submit</button>
                            </td>
                        </tr>
                    </table>
                </form>

        </div>
    </div>
</div>

END
;

	print OUT <<END

<div id="protocol_ctx">

END
;

}

print OUT <<END

    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x_title title_block">
            <h2>Top Ports : LAN</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">
                <div id="canvas-holder" style="margin:30px auto 0 auto;width:300px;height:300px;">
                    <canvas id="chart-area" width="250" height="250" />
                </div>
        </div>
    </div>
</div>

<div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x_title title_block">
            <h2>Top Ports : WAN</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

                <div id="canvas-holder" style="margin:30px auto 0 auto;width:300px;height:300px;">
                    <canvas id="chart-area2" width="250" height="250" />
                </div>
        </div>
    </div>
</div>


<div class="col-md-12 col-sm-12 col-xs-12">
    <div class="x_title title_block">
        <h2>Details</h2>
        <ul class="nav navbar-right panel_toolbox">
            <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
            <li><a class="close-link"><i class="fa fa-close"></i></a>
            </li>
        </ul>
        <div class="clearfix"></div>
    </div>
    <div class="x_panel fixed_height_320">
        <div class="x_content">

<table width="100%" class="table table-striped">
<thead><tr><th width='4%'></th><th width='13%'>Application</th><th width='8%'>% of LAN</th><th width='9%'>LAN MB</th><th width='18%'>Reduction</th><th width='10%'>WAN MB</th><th width='10%'>% of WAN</th></tr></thead><tbody>

END
;

$i = 0;

foreach my $key (sort {
	$lptable{$b} <=> $lptable{$a}
} keys %lptable)
{
	($knownport, $portdesc) = split(',', $portobjs{"$key/6"});
	if ($knownport eq '') {
		$knownport = $key;
		$portdesc = "TCP Port: " .  $knownport;
	}
	my $ldata = sprintf('%.1f', $ltable{$key} / 1024000);
	$ldata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
	print OUT  "<tr><td title='TCP Port: " . $key . " - " . $knownport . "'><center><div id='box' style='background:" . $legendc[$i++] .  "'></div></center></td><td title='TCP Port: " . $key . " - " . $portdesc . "'>" . $knownport . "</td><td>" . $lptable{$key} . "</td><td title='Bytes : " . $ltable{$key} . "'>" . $ldata . "</td>\n";

	# $z = $y ? $x / $y : 0;
	my $scale = $ltable{$key} ? (($ltable{$key} - $wtable{$key}) / $ltable{$key}) : 0;
	$scale = sprintf("%.1f", $scale * 100);
	#my $scale = sprintf("%.0f", (($ltable{$key} - $wtable{$key})/$ltable{$key}) * 100);
	if ($scale <= 0) {
		$scale = 0;
	}
	if ($wptable{$key} eq '') {
		$wptable{$key} = 0;
	}
	my $wdata = sprintf('%.1f', $wtable{$key} / 1024000);
	$wdata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
	print OUT  "<td>" . "<div class='meter'><span style='width: " . $scale . "%'><div style='width:100%;display:block; text-align:center; font-size:9px;top:0;left:0;position:absolute;'>" . $scale . "%</div></span></div></td>\n";
	if ($wlegend{$key} eq '') {
		$wlegend{$key} = 19;
	}
	print OUT  "<td title='Bytes : " . $wtable{$key} . "'>" . $wdata . "</td><td>" .  $wptable{$key}  . "</td></tr>\n";
	if ($i eq $topn) {
		last;
	}
}

print OUT  <<END
</table>



        </div>
    </div>

</div>
END
;

if ($ajax_trigger == 0) {

	print OUT <<END

</div>

END
;

}

close OUT;

if ($export eq 'pdf')
{
	system("/tce/packages/click/exporttool /tce/www/stats/reports/topprotocols.html /tce/www/stats/reports/topprotocols.pdf" );
	print <<END
	<strong>Report Ready</strong><br />
	Protocol report is ready for download:
	<a href='../stats/reports/topprotocols.pdf' target="_blank" style='color:#777'>Top $topn Protocols from the $timename</a>
END
;
}

