#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;

my @graphs;
my $cgi = CGI->new;
my $name = $cgi->param( "trend" );
my $desc = $cgi->param( "desc" );
my $time = $cgi->param( "time" );
my $export = $cgi->param( "export" );

my $datestring = time();

my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param( "ajax_trigger" );

if ($time eq '') {
    $time = 'Day';
}

my $i = 0;
my $filename = '';
my $timename;
if ($time eq 'Hour') {
    $timename = "Last Hour";
}
if ($time eq 'Day') {
    $timename = "Last Day";
}
if ($time eq 'Week') {
    $timename = "Last Week";
}
if ($time eq 'Month') {
    $timename = "Last Month";
}
if ($time eq 'Year') {
    $timename = "Last Year";
}
my $maingraph = $cgi->param( "main" );
if ($maingraph eq '') {
    $maingraph = 'All';
}
my $maingraphvalue = lc $maingraph;
$maingraphvalue =~ s/\s//g;
if ($maingraph eq 'All')
{
    foreach my $i (0 .. 17)
    {
        my $filename = "../stats/qosclass$i-tx-$time.json";
        if (-r $filename)
        {
            push ( @graphs, "qosclass$i,QoS Class $i : WAN Tx" );
        }
    }
}
else {
    push ( @graphs, "$maingraphvalue,$maingraph : WAN Tx" );
}

if ($export eq 'pdf')
{
    open ( OUT, ">/tce/www/stats/reports/qosclasses.html" ) or die "Can't open OUT: $!";
    $url = "/tce/www";
}
else {
    open ( OUT, ">&STDOUT" ) or die "Can't open OUT: $!";
}

my @colors_arr = (
    # top, top opacity, bottom, bottom opacity ;
    [ '#98B937', '0.2', '#606b2c', '0.2' ],
    [ '#6A9113', '0.2', '#141517', '0.2' ],
    [ '#52c234', '0.2', '#29323c', '0.2' ],
    [ '#52c234', '0.2', '#061700', '0.2' ],
    [ '#ADD100', '0.2', '#7B920A', '0.2' ],
    [ '#414d0b', '0.2', '#727a17', '0.2' ],
    [ '#727a17', '0.2', '#606b2c', '0.2' ],
    [ '#98B937', '0.2', '#71B280', '0.2' ]
);

if ($ajax_trigger == 0) {
    print OUT<<END

<div class="page-title">
    <div class="title_left">
        <h3>$title</h3>
    </div>
</div>
<div class="clearfix"></div>

<style>

END
    ;

    my $k = 0;
    for my $colors (@colors_arr) {

        print OUT '.gradient'.$k.' {';
        print OUT  'fill: url(#gradient-area'.$k.');';
        print OUT  '}';

        print OUT  '.line'.$k.' {';
        print OUT  'fill: none; stroke: '.@$colors[0].'; stroke-width: 1;';
        print OUT  '}';

        for (my $j = 0; $j < 4; $j++) {
            if ($j == 0) {
                print OUT  '.lgt'.$k.' {';
                print OUT  'stop-color : '.@$colors[$j].';';
            }

            if ($j == 1) {
                print OUT  'stop-opacity : '.@$colors[$j].';';
            }

            if ($j == 2) {
                print OUT  '}';
                print OUT  '.lgb'.$k.' {';
                print OUT  'stop-color : '.@$colors[$j].';';
            }

            if ($j == 3) {
                print OUT  'stop-opacity : '.@$colors[$j].';';
                print OUT  '}';
            }
        }

        for (my $m = 0; $m < 4; $m++) {
            if ($m == 0) {
                print OUT  '.legend'.$k.' {';
                print OUT  'background: '.@$colors[$m].';';
            }

            if ($m == 3) {
                print OUT  '}';
            }
        }
        $k++;
    }

    print OUT<<END
</style>

END
    ;
    print OUT<<END

<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Quality of Service Classes</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
    ;

    print OUT<<END

<form id="qosclasses" action="#" method="post">

<table class='nav-table' width="100%">
	<tr>

		<td>Graph:
		    <br>
		    <select id="main" name="main" class="form-control animated flipInY" style="width:70%;">
		        <option value="$maingraph">$maingraph</option>
		        <option value="Qos Class 0">QoS Class 0</option>
		        <option value="Qos Class 1">QoS Class 1</option>
		        <option value="Qos Class 2">QoS Class 2</option>
		        <option value="Qos Class 3">QoS Class 3</option>
		        <option value="Qos Class 4">QoS Class 4</option>
		        <option value="Qos Class 5">QoS Class 5</option>
		        <option value="Qos Class 6">QoS Class 6</option>
		        <option value="Qos Class 7">QoS Class 7</option>
		        <option value="Qos Class 8">QoS Class 8</option>
		        <option value="Qos Class 9">QoS Class 9</option>
		        <option value="Qos Class 10">QoS Class 10</option>
		        <option value="Qos Class 11">QoS Class 11</option>
		        <option value="Qos Class 12">QoS Class 12</option>
		        <option value="Qos Class 13">QoS Class 13</option>
		        <option value="Qos Class 14">QoS Class 14</option>
		        <option value="Qos Class 15">QoS Class 15</option>
		        <option value="Qos Class 16">QoS Class 16</option>
		        <option value="Qos Class 17">QoS Class 17</option>
		        <option value="All">All</option>
		    </select>
		</td>
		<td>Period:
		    <br>
		    <select id="time" name="time" class="form-control animated flipInY" style="width:70%;">
		        <option value="$time">$timename</option>
		        <option value="Hour">Last Hour</option>
		        <option value="Day">Last Day</option>
		        <option value="Week">Last Week</option>
		        <option value="Month">Last Month</option>
		        <option value="Year">Last Year</option>
		    </select>
		</td>
		<td style="display:none;">Export:
		    <br>
		    <select id="export" name="export" class="form-control animated flipInY" style="width:70px;">
		        <option></option>
		        <option value="pdf">&nbsp;PDF&nbsp;</option>
		    </select>
		</td>
		<td align='left'>
		    <br>
		    <button id="btn_submit" type="submit" class="btn btn-success" style="font-size: 8pt;">Submit</button>
		</td>
	</tr>

</table>
</form>
END
    ;

    print OUT  <<END

            </div>
        </div>
    </div>
</div>
END
    ;
    print OUT "<div id='qos_ctx'>";

}

if ($ajax_trigger == 0 || $ajax_trigger == 1) {

    if ($name eq '') {
        foreach $graph (@graphs) {
            ($graphname, $desc) = split( ',', $graph );

            print OUT<<END;
                <div class="col-md-6 col-sm-6 col-xs-12">
                    <div class="x_title title_block">
                        <h2>$desc</h2>
                        <ul class="nav navbar-right panel_toolbox">
                            <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                            <li><a class="close-link"><i class="fa fa-close"></i></a>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                    <div class="x_panel fixed_height_320">
                        <div class="x_content">

END
            ;

            $filename = "/tce/www/stats/$graphname-tx-$time.json";
            if (-r $filename) {

                open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                    local $/;
                    $json = <$fh>;
                }

                print OUT<<END
		        <script type="text/javascript">
		            window.ratio = undefined;
                    var json=$json, tmp_arr = [];
                    var DURATION = 1500;
                    var DELAY    = 500;

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;
                        for(var j = 0; j < length_value; j++) {
                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr.push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j+length_value] != 'object' ? parseFloat(json.data[i][j+length_value]) : 0
                                    });
                                }
                            }
                            window.max = d3.max(tmp_arr, function (d) {
                                return Math.ceil(d.value * 1.1);
                            }) > 1 ? d3.max(tmp_arr, function (d) {
                                return Math.ceil(d.value * 1.1);
                            }) : 10;

                            drawLineChart('lineChart$graphname', tmp_arr, 'usage', '$desc the Last Day', j);
                            tmp_arr = [];

                        }
                    }

                </script>

                <script type="text/javascript">
                    drawLegend('lineChart$graphname', json, 'usage');
                </script>

                <a href="#" id="lineChart$graphname" class="d3graph img-table" data-desc='$desc' data-name='$graphname'>
                    <svg id="lineChartSVG$graphname" class="lineChart--svg">
                      <defs>
END
                ;

                my $n = 0;
                for my $colors (@colors_arr) {

                    for (my $j = 0; $j < 4; $j++) {

                        if ($j == 0) {
                            print OUT '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                            print OUT '<stop class="lgt'.$n.'" offset="0%" />';
                        }

                        if ($j == 1) {
                            print OUT '<stop class="lgb'.$n.'" offset="100%" />';
                        }

                        if ($j == 3) {
                            print OUT '</linearGradient>';
                        }
                    }
                    $n++;
                }
                print OUT<<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
                ;

            } else {
                print OUT "No Data<br>\n";
            }

            print OUT<<END;
                    </div>
                </div>
            </div>
END
            ;

            $j++;
        }
    } else {

        print OUT<<END;
            <div class="row">
END
        ;

        foreach $period ("Hour", "Day", "Week", "Month", "Year") {
            print OUT<<END;
                <div class="col-md-6 col-sm-6 col-xs-12">
                    <div class="x2_title title_block">
                        <h2>$desc : $period</h2>
                        <ul class="nav navbar-right panel_toolbox">
                            <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                            <li><a class="close-link"><i class="fa fa-close"></i></a>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                    <div class="x_panel fixed_height_320">
                        <div class="x_content">

END
            ;

            $filename = "/tce/www/stats/$name-tx-$period.json";
            if (-r $filename) {

                open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                    local $/;
                    $json = <$fh>;
                }

                print OUT<<END
		        <script type="text/javascript">
		            window.ratio = undefined;
                    var json=$json, tmp_arr = [];
                    var DURATION = 1500;
                    var DELAY    = 500;

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;
                        for(var j = 0; j < length_value; j++) {
                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr.push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j+length_value] != 'object' ? parseFloat(json.data[i][j+length_value]) : 0
                                    });
                                }
                            }
                            window.max = d3.max(tmp_arr, function (d) {
                                return Math.ceil(d.value * 1.1);
                            }) > 1 ? d3.max(tmp_arr, function (d) {
                                return Math.ceil(d.value * 1.1);
                            }) : 10;

                            drawLineChart('lineChart$i', tmp_arr, 'usage', '$desc the Last $period', j);
                            tmp_arr = [];

                        }
                    }

                </script>

                <script type="text/javascript">
                    drawLegend('lineChart$i', json, 'usage');
                </script>

                <a href="#" id="lineChart$i" class="d3graph img-table" data-desc='$desc' data-name='$graphname'>
                    <svg id="lineChartSVG$i" class="lineChart--svg">
                      <defs>
END
                ;

                my $n = 0;
                for my $colors (@colors_arr) {

                    for (my $j = 0; $j < 4; $j++) {

                        if ($j == 0) {
                            print OUT '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                            print OUT '<stop class="lgt'.$n.'" offset="0%" />';
                        }

                        if ($j == 1) {
                            print OUT '<stop class="lgb'.$n.'" offset="100%" />';
                        }

                        if ($j == 3) {
                            print OUT '</linearGradient>';
                        }
                    }
                    $n++;
                }
                print OUT<<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
                ;

            } else {

                print OUT "No Data<br>\n";

            }

            $i++;

            print OUT  <<END
                    </div>
                </div>
            </div>
END
            ;
        }

        print OUT <<END
		</div>

END
        ;

    }
}

close OUT;

if ($export eq 'pdf') {

    print <<END;
            <div class="row">
                <div class="col-md-12 col-sm-12 col-xs-12">
                    <div class="x_title title_block">
                        <h2>PDF download</h2>
                        <ul class="nav navbar-right panel_toolbox">
                            <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                            <li><a class="close-link"><i class="fa fa-close"></i></a>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                    <div class="x_panel fixed_height_320">
                        <div class="x_content">

END
    ;

    system( "/tce/packages/click/exporttool /tce/www/stats/reports/qosclasses.html /tce/www/stats/reports/qosclasses.pdf" );
    print <<END
        <strong>Report Ready</strong><br />
        QoS report is ready for download:
        <a href='../stats/reports/qosclasses.pdf' style='color:#777'>QoS stats for $maingraph from the $timename</a>
END
    ;

    print <<END
                    </div>
                </div>
            </div>
        </div>
END
    ;

}

print OUT " < / div > ";
