#!/usr/local/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;

use autodie;

my $cgi = CGI->new;
my $stats = $cgi->param("stats");
my $conf = $cgi->param("conf");
my $if = $cgi->param("if");
my $ds = $cgi->param("ds");
my $service = $cgi->param("service");
my $boot = $cgi->param("boot");
my $shutdown = $cgi->param("shutdown");
my $setpass = $cgi->param("setpass");
my $webpass = $cgi->param("webpass");
my $msg = '';
my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param("ajax_trigger");

my $update = 0;

if ($stats eq "") {
	$stats = "no";
}
if ($conf eq "") {
	$conf = "no";
}
if ($if eq "") {
	$if = "no";
}
if ($ds eq "") {
	$ds = "no";
}
if ($service eq "") {
	$service = "no";
}
if ($boot eq "") {
	$boot = "no";
}
if ($shutdown eq "") {
	$shutdown = "no";
}
if ($setpass eq "") {
	$setpass = "no";
}

if (($stats eq "yes") || ($conf eq "yes") || ($if eq "yes") || ($ds eq "yes") || ($service eq "yes") || ($boot eq "yes") || ($shutdown eq "yes")) {
	$update = 1;
}

if ($setpass eq "yes") {
	$update = 2;
}

if ($webpass ne "") {
	$update = 3;
}

open(CONFIG, "<", "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
while (<CONFIG>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $variable) = split(/\s*=\s*/, $_, 2);
	$variable =~ s/(\$(\w+))/$config{$2}/g;
	$config{$key} = $variable;
}
close CONFIG;

if ($ajax_trigger == 0) {
	if ($update == 0) {

		print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Reset</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>Reset Options</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
		;
	}
}

if (($update == 1) && ($boot eq "yes")) {
	$msg = $msg . "Reset initiated. Appliance is rebooting.<br>\n";
}
if (($update == 1) && ($shutdown eq "yes")) {
	$msg = $msg . "Appliance is shutting down.<br>\n";
}
if (($update == 1) && ($boot ne "yes") && ($shutdown ne "yes")) {
	$msg = $msg . "Reset service initiated. Processes are resetting.<br>\n";
}
if ($update == 3) {
	$msg = $msg . "SSH & Web Interface Password Changed<br>\n";
}

if ($msg ne '') {

	if ($ajax_trigger == 0) {
		print <<END
		<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Done! </strong> $msg
		</div>

END
	;
	}

	if ($ajax_trigger == 2) {

		print <<END
	<strong>Done! </strong> $msg
END
	;

	}

}

if ($ajax_trigger == 0) {
	if ($update == 0) {
		print <<END

    <form id="reset_form" class="form-horizontal form-label-left" name="reset-form" method="post" data-parsley-validate>

        <div class="form-group">
            <label class="control-label col-md-4 col-sm-4 col-xs-12" for="service">Reset Service
            </label>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="checkbox">
                    <label>
                        <input id="service"
                        name="service" title="Reset the Wanos Service"
                        type="checkbox" size="12" class="flat" data-parsley-multiple="my_input_group"
                        data-toggle="tooltip" />
                    </label>
                </div>
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-md-4 col-sm-4 col-xs-12" for="setpass">Change SSH & Web Password
            </label>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="checkbox">
                    <label>
                        <input id="setpass" name="setpass"
                            title="Change SSH & Web Interface Password"
                            type="checkbox" size="12" class="flat"
                            data-toggle="tooltip" />
                    </label>
                </div>
            </div>
        </div>

        <div class="form-group">
            <label for="stats" class="control-label col-md-4 col-sm-4 col-xs-12">Reset Statistics
            </label>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="checkbox">
                    <label>
                        <input id="stats" name="stats"
                            title="Reset log and statistics" type="checkbox"
                            size="12" class="flat" data-toggle="tooltip" />
                    </label>
                </div>
            </div>
        </div>

        <div class="form-group">
            <label for="conf" class="control-label col-md-4 col-sm-4 col-xs-12">Reset Configuration
            </label>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="checkbox">
                    <label>
                        <input id="conf" name="conf"
                            title="Reset configurations to factory defaults" type="checkbox"
                            size="12" class="flat" data-toggle="tooltip" />
                    </label>
                </div>
            </div>
        </div>

        <div class="form-group">
            <label for="ds" class="control-label col-md-4 col-sm-4 col-xs-12">Reset Datastore
            </label>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="checkbox">
                    <label>
                        <input id="ds" name="ds" type="checkbox"
                            title='Clear the Deduplication Datastore. Requires Datastore Clear on Peers.'
                            size="12" class="flat" data-toggle="tooltip" />
                    </label>
                </div>
            </div>
        </div>

        <div class="form-group">
            <label for="boot" class="control-label col-md-4 col-sm-4 col-xs-12">Reboot Appliance
            </label>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="checkbox">
                    <label>
                        <input id="boot" name="boot" title="Reboot the Wanos Appliance"
                        type="checkbox" size="12" class="flat" data-toggle="tooltip" />
                    </label>
                </div>
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-md-4 col-sm-4 col-xs-12" for="shutdown">Shutdown Appliance
            </label>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="checkbox">
                    <label>
                        <input id="shutdown" name="shutdown"
                        title="Shutdown the Wanos Appliance"
                        type="checkbox" size="12" class="flat" data-toggle="tooltip" />
                    </label>
                </div>
            </div>
        </div>

        <div class="ln_solid"></div>
        <div class="form-group">
            <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
                <a type="button" class="btn btn-default" href="/#/reset" onclick="location.reload();" style='font-size: 8pt;'>Cancel</a>
                <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Submit</button>
            </div>
        </div>

    </form>

END
	;
	}

}

if ($update == 2)
{
	print <<END
  	<form id="reset_ssh" action="" method="post" class="form-horizontal form-label-left">
	    <div class="form-group">
		    <label class="control-label col-md-3 col-sm-3 col-xs-12" for="webpass">New SSH & Web Interface password <span class="required">*</span>
		    </label>
		    <div class="col-md-6 col-sm-6 col-xs-12">
		         <input id="webpass" name="webpass"
                    title="Change SSH & Web Interface Password" maxlength="12" type="password" size="14"
                    class="form-control col-md-4 col-xs-12" required />
		    </div>
		</div>

	    <div class="ln_solid"></div>

	    <div class="form-group">
	        <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
	            <a type="button" class="btn btn-default" href="/#/reset" onclick="location.reload();" style='font-size: 8pt;'>Cancel</a>
	            <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Submit</button>
	        </div>
	    </div>

	</form>
END
;
}

if ($update == 0)
{
	print <<END

        </div>
    </div>

</div>
END
;
}

if ($update == 1)
{
	open(CMD, "|sudo -u tc /tce/etc/wanos/reset.sh $stats $conf $if $ds $service $boot $setpass $shutdown &");
	close(CMD);

	print <<END
		<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Done! </strong>
		</div>

END
;
}

if ($update == 3)
{
	$| = 1;
	myspecial_characters;
	$special_characters{"_"} = "\\_";
	$special_characters{"\\\$"} = "\\\$";
	$special_characters{"{"} = "\\{";
	$special_characters{"}"} = "\\}";
	$special_characters{"#"} = "\\#";
	$special_characters{"%"} = "\\%";
	$special_characters{"&"} = "\\&";


	print <<END
		<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Done! </strong> Password changed
		</div>

END
;

	open(OUT, ">", "/tce/etc/.lighttpdpassword") || die("Couldn't open the file. Error: $!\n");
	print OUT "wanos:" . $webpass;
	close(OUT);

	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -sshpass");
	close(CMD);

}
