#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#


use CGI;
use warnings;
use autodie;
use Scalar::Util qw(looks_like_number);

my $cgi = CGI->new;
my $dstnet = $cgi->param("dstnet");
my $remove = $cgi->param("remove");
my $peerip = $cgi->param("peerip");
my $update = 0;
my $paramerror = 0;
my $removed = 0;
my $errmsg = "";
my @dst = ();

my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param("ajax_trigger");
my $ajax_table_trigger = 0;
my $ajax_table_trigger = $cgi->param("ajax_table_trigger");

if ($dstnet ne '') {
	$update = 1;
}
if ($dstnet eq '') {
	$dstnet = "0.0.0.0/0";
}

my @rows;
my %routes;
my $i = 0;

open(ROW, "<", "/tce/etc/wanos/static_routes") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
	chomp;
	next if /^\s*\#/;
	next unless /\//;
	$rows{$i} = $_;
	$i++;
}
close ROW;
my $totalroutes = scalar keys %routes;


my @config;
open(CONFIG, "<", "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
while (<CONFIG>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $variable) = split(/\s*=\s*/, $_, 2);
	$variable =~ s/(\$(\w+))/$config{$2}/g;
	$config{$key} = $variable;
}
close CONFIG;

# Skip rules if the values are suspect
if ($update == 1)
{
	@dst = split(/\//, $dstnet);
	my $ipno = qr/2(?:5[0-5]|[0-4]\d)|1\d\d|[1-9]?\d/x;
	if ($dst[0] !~ /^($ipno\.){3}$ipno$/) {
		$update = 0;
		$paramerror = 2;
	}
	if (!looks_like_number($dst[1])) {
		$update = 0;
		$paramerror = 3;
	}
	if (( $dst[1] > 32) || ( $dst[1] < 1 )) {
		$update = 0;
		$paramerror = 3;
	}
	if (( $peerip ne ``) && ( $peerip !~ /^($ipno\.){3}$ipno$/ )) {
		$update = 0;
		$paramerror = 6;
	}


	$longmask="255";
	$b=$config{MASK}-8;
 	for($i=0;$i<3;$i++)
 	{
	    $b=$b-8;
	    if($b >= 0) { $longmask = $longmask . "." . 255;}
	    if($b < 0)
 	    {
                if ($b == -1)  { $longmask = $longmask . "." . 254;}
                if ($b == -2)  { $longmask = $longmask . "." . 252;}
                if ($b == -3)  { $longmask = $longmask . "." . 248;}
                if ($b == -4)  { $longmask = $longmask . "." . 240;}
                if ($b == -5)  { $longmask = $longmask . "." . 224;}
                if ($b == -6)  { $longmask = $longmask . "." . 192;}
                if ($b == -7)  { $longmask = $longmask . "." . 128;}
                if ($b <= -8)  { $longmask = $longmask . "." . 0;}
           }
	}

	my $NetAddr;
 	@maskbyte=split /\./,$longmask;
	@ipbyte=split /\./, $config{IP};
	for($i=0;$i<4;$i++)
 	{
	    $b1=$maskbyte[$i]+0;
 	    $b2=$ipbyte[$i]+0;
 	    $NetByte=$b1&$b2;
  	    if($i != 0) {$NetAddr = $NetAddr . "." . $NetByte; }
 	    else        { $NetAddr=$NetByte ;}
	}	
        @gwbyte=split /\./, $peerip;
        for($i=0;$i<4;$i++)
        {
            $b1=$maskbyte[$i]+0;
            $b2=$gwbyte[$i]+0;
            $gwByte=$b1&$b2;
            if($i != 0) {$gwAddr = $gwAddr . "." . $gwByte; }
            else        { $gwAddr=$gwByte ;}
        }
        if ( $gwAddr ne $NetAddr ) { $paramerror = 5; $update = 0; }

}

foreach my $check (keys %rows)
{
#print "XXXXXXXXXXXXXXXXXXXXXX\n";
#print "#####" . $rows{$check} . "\n";
}
#exit;


if ($update == 1)
{
	if ($dstnet eq '0.0.0.0/0') {
		$update = 0;
		$paramerror = 8;
	}

	if ($dstnet eq "$config{NET}/$config{MASK}") {
		$update = 0;
		$paramerror = 7;
	}
}

if ($update == 1)
{
	open(OUT, ">>", "/tce/etc/wanos/static_routes") || die("Couldn't open the file. Error: $!\n");
	my $updatestring = "$dst[0]/$dst[1] $peerip";
	print OUT $updatestring . "\n";
	$rows{$i} = $updatestring;
	$i++;
	close OUT;

	open(OUT, ">", "/tce/etc/wanos/reconfigure") || die("Couldn't open the file. Error: $!\n");
	print OUT "1";
	close OUT;
}

if ($remove ne '') 
{

	open(OUT, ">", "/tce/etc/wanos/static_routes") || die("Couldn't open the file. Error: $!\n");
		print OUT "#Routes for Management Access\n";
		print OUT "#Static Route Example:\n";
		print OUT "#192.168.100.0/24 192.168.100.1\n";
	foreach (keys %rows)
	{
		next if $rows{$_} =~ m/^$remove/;
		print OUT $rows{$_} . "\n" ;
	}
	close(OUT);
	$removed = $remove;

	open(OUT, ">", "/tce/etc/wanos/reconfigure") || die("Couldn't open the file. Error: $!\n");
	print OUT "1";
	close OUT;
}

if ($ajax_trigger == 0) {

	if ($ajax_table_trigger == 0) {

		print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Routes</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Static Routes</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div id="routes" class="x_content">
END
		;

	}
}

if ($ajax_table_trigger == 2) {

		print <<END
		<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Done! </strong> Route $removed removed. Apply the new policy by restarting the Wanos service under <a target='_parent' href='#/reset'>Configure > Reset</a>
		</div>

END
;
}

if ($ajax_trigger == 0) {


	print <<END
                <table id="routes_table" class="table table-striped">
		            <thead>
                        <tr>
                            <th width='20%' title='Network Subnet. &#013;For Example: 192.168.1.0/24'>
                               Network Subnet 
                            </th>
                            <th width='20%' title='Next Hop Gateway IP Address&#013;For Example: 10.10.20.1'>
                               Gateway IP
                            </th>
                            <th width='15%' title='Remove this rule'>
                               Delete
                            </th>
                        </tr>
		            </thead>
END
;

	foreach ( keys(%rows))
	{

#print "############################\n";
#print $rows{$_} . "\n";
#exit;
		next if $rows{$_} =~ m/^#/;
		next if $rows{$_} =~ m/^$removed/;
		my @values = split(/ /, $rows{$_});
		print  "<tr data-id='$_'><td title='Network Subnet'>$values[0]</td><td title='Next Hop Gateway IP Address&#013;For Example: 10.10.20.1'>";
		if ($values[1] eq '') {
			print "Error";
		}
		else {
			print $values[1];
		}
			print  "</td><td><a class='btn_trash' href='#' data-id='$values[0]' title='Remove this rule' ><i class='fa fa-trash-o'></i></a></td></tr>\n";

	}
	print "<tr ><td title='Default Route'>0.0.0.0/0</td><td title='Default Gateway'>$config{GW}</td><td></td></tr>\n";
	print "</table>";

	if ($ajax_table_trigger == 0) {
		print <<END

            </div>
        </div>
    </div>
</div>
END
	;

	}
	if ($ajax_table_trigger == 0) {

		print <<EOF;

<div class="row">
    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x_title title_block">
            <h2>Add Route</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">


EOF
		;

	}

}

$i++;

if ($ajax_table_trigger == 0) {

	if ($update == 1) {

		print <<END
		<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Done! </strong> Route Policy updated. Apply the new policy by restarting the Wanos service under <a target='_parent' href='#/reset'>Configure > Reset</a>
		</div>

END
	;
	}
}

if ($ajax_table_trigger == 0) {
	if ($paramerror == 1) {
		$errmsg = $errmsg . " Invalid Source Network<br />\n";
	}
	if ($paramerror == 2) {
		$errmsg = $errmsg . " Invalid Destination Network<br />\n";
	}
	if ($paramerror == 3) {
		$errmsg = $errmsg . " Invalid Network Mask<br />\n";
	}
	if ($paramerror == 4) {
		$errmsg = $errmsg . " Could not add site. 32-Bit platform supports a maximum of 4 peers<br />\n";
	}
	if ($paramerror == 5) {
		$errmsg = $errmsg . " Valid gateway needs to be on the primary wan0 subnet: $config{NET}/$config{MASK}<br />\n";
	}
	if ($paramerror == 6) {
		$errmsg = $errmsg . " Invalid Remote Peer IP Address.<br />\n";
	}
	if ($paramerror == 7) {
		$errmsg = $errmsg . " Subnet matches wan0 Primary IP subnet<br />\n";
	}
	if ($paramerror == 8) {
		$errmsg = $errmsg . " Change the default route in the Setting Page <br />\n";
	}
	if ($paramerror == 9) {
		print $errmsg . "<br />\n";
	}

	if ($errmsg ne '') {
		print <<END
		<div class="alert alert-danger alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Warning! </strong> $errmsg
		</div>

END
	;
	}
}

if ($ajax_table_trigger == 0) {

	if ($removed > 0) {
		print <<END
		<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Done! </strong> Rule # $removed removed. Apply the new policy by restarting the Wanos service under <a target='_parent' href='#/reset'>Configure > Reset</a>
		</div>

END
	;
	}
}

if ($ajax_table_trigger == 0) {

	if ($removed == 100) {
		print <<END
		<div class="alert alert-danger alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Warning! </strong> Removing the default site is not recommended. Please add a default catch all site.
		</div>

END
	;
	}

}

if ($ajax_table_trigger == 0) {

	print <<END

				<form id="form_routes" action="" class="form-horizontal form-label-left" name="addrule" action="" method="post" data-parsley-validate>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="dstnet">Network Subnet<span class="description">For Example: 192.168.1.0/24</span></label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input name="dstnet" title="Network Subnet & Mask. For Example 192.168.1.0/24"
                            type="text" size="14" maxlength="18" data-parsley-check_ip_and_mask
                            id="dstnet" class="form-control col-md-4 col-xs-12" required
                            data-toggle="tooltip" />
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="peerip">Gateway IP<span class="description">For Example: 10.10.20.254</span></label>
                         <div class="col-md-6 col-sm-6 col-xs-12">
                            <input name="peerip" title="Next Hop Gateway IP Address&#013;For Example: 10.10.20.254"
                            size="20" maxlength="15" type="text" id="peerip"
                            class="form-control col-md-4 col-xs-12" 
                            data-parsley-check_ip
                            data-toggle="tooltip" />
                        </div>
                    </div>


                    <div class="ln_solid"></div>
                    <div class="form-group">
                        <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
                            <a type="button" class="btn btn-default" href="/#/system_settings" onclick="window.location.reload();return false;" style='font-size: 8pt;'>Cancel</a>
                            <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Submit</button>
                        </div>
                    </div>
                </form>
END
	;

	if ($ajax_trigger == 0) {
		print <<END
			</div>
		</div>
	</div>
</div>

END
	;
	}
}
