#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
#use warnings;
use autodie;
use Cwd qw(abs_path);

print "Content-type: text/html;\n\n";

my $cgi = CGI->new;
my $page = $cgi->param("page");
my $time = $cgi->param("time");
my $maxkb = $cgi->param("maxkb");
my $minkb = $cgi->param("minkb");
my $ipfilter = $cgi->param("ip");
my $portfilter = $cgi->param("port");
my $peervalue = $cgi->param("peervalue");
my $export = $cgi->param("export");
my $batch = $cgi->param("batch");
my $nav = $cgi->param("nav");
my $url = $cgi->param("url");
my $displayip;
my $displayport;
my $displayminkb = $minkb;
my $displaymaxkb = $maxkb;

my $update = 0;
$update = $cgi->param("update");

my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param("ajax_trigger");


open(ROW, "<", "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
        chomp;
        next if /^\s*\#/;
        next unless /=/;
        my ($key, $commastring) = split(/\s*=\s*/, $_, 2);
        $commastring =~ s/(\$(\w+))/$rows{$2}/g;
        $rows{$key} = $commastring;
        my @values = split(',', $commastring);
        $sites{$values[1]} = $values[2];
}
close ROW;
my $num_sites = scalar keys %sites;



if ($page eq '') {
	$page = 1;
}
if ($minkb eq '') {
	$minkb = 10000;
	$displayminkb = 10;
}
else {
	$displayminkb = $minkb;
	$minkb *= 1000;
}
if ($minkb eq '0') {
	$minkb = 1000;
	$displayminkb = 1;
}
if ($maxkb eq '') {
	$maxkb = 100000000000;
	$displaymaxkb = '';
}
else {
	$displaymaxkb = $maxkb;
	$maxkb *= 1000;
}
if ($displaymaxkb = 100000000000) {
	$displaymaxkb = '';
}
if ($batch eq '') {
	$batch = 1000;
}
if ($ipfilter eq '') {
	$ipfilter = ".*";
	$displayip = '';
}
else {
	$displayip = $ipfilter;
}
if ($portfilter eq '') {
	$portfilter = ".*";
	$displayport = '';
}
else {
	$displayport = $portfilter;
}
if ($time eq '') {
	$time = 1800;
}
my $timename;
if ($time eq '300') {
	$timename = "Last 5 Min";
}
if ($time eq '900') {
	$timename = "Last 15 Min";
}
if ($time eq '1800') {
	$timename = "Last 30 Min";
}
if ($time eq '3600') {
	$timename = "Last 60 Min";
}
if ($time eq '7200') {
	$timename = "Last 2 Hours";
}
if ($time eq '28800') {
	$timename = "Last 8 Hours";
}
if ($time eq '86400') {
	$timename = "Last 24 Hours";
}

if ($export eq 'pdf') {
	open (OUT, ">/tce/www/stats/reports/sessions.html") or warn "Can't open OUT: $!";
	$nav = 1;
	$batch = 1000;
	$url = "/tce/www";

} else {
	open (OUT, ">&STDOUT") or warn "Can't open OUT: $!";
}

if ($nav eq '') {
	system( "sudo -u tc /tce/etc/wanos/flows $time flows $peervalue" );
}

open(LROW, "<", "/wanos/nf/l0/flowdetail") || die("Couldn't open the file. Error: $!\n");
chomp(my @lrows = <LROW>);
close LROW;
open(WROW, "<", "/wanos/nf/w0/flowdetail") || die("Couldn't open the file. Error: $!\n");
chomp(my @wrows = <WROW>);
close WROW;
my @portobjs;
open(OBJ, "<", "/tce/etc/wanos/portobjects") || die("Couldn't open the file. Error: $!\n");
while (<OBJ>)
{
	chomp;
	my ($key, $commastring) = split(/,/, $_, 2);
	$portobjs{$key} = $commastring;
}
close OBJ;

my $lrownum = scalar @lrows;
my $wrownum = scalar @wrows;
my $rows = ();
my %table = ();
my %sorted = ();
my %portinfo = ();

for (my $i = 1; $i < ($lrownum - 4); $i++)
{
	@lvalues = split(' ', $lrows[$i]);
	if (($lvalues[4] > $minkb) &&
		(($lvalues[0] =~ /^$ipfilter$/) || ($lvalues[2] =~ /^$ipfilter$/)) &&
		(($lvalues[1] =~ /^$portfilter/) || ($lvalues[3] =~ /^$portfilter/)) &&
		($lvalues[4] < $maxkb))
	{
		$table{($lvalues[0].$lvalues[1].$lvalues[2].$lvalues[3])} = $lvalues[4];
	}
}

for (my $i = 1; $i < ($wrownum - 4); $i++)
{
	my @wvalues = split(' ', $wrows[$i]);
	my $ldata = $table{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])};
	if ($ldata > ($minkb))
	{
		my $scale = (100 - (sprintf("%.0f", ($wvalues[4] / $ldata) * 100)));
		if ($scale < 0) {
			$scale = 0;
		}
		$ldata = sprintf("%.0f", ($ldata / 1024));
		$ldata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
		$wdata = sprintf("%.0f", ($wvalues[4] / 1024));
		$wdata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
		my $port = '';
		if ($wvalues[1] <= $wvalues[3]) {
			$port = $portobjs{"$wvalues[1]/$wvalues[5]"};
		}
		if ($port eq '') {
			$port = $portobjs{"$wvalues[3]/$wvalues[5]"};
		}
		if ($port eq '') {
			$port = $portobjs{"$wvalues[1]/$wvalues[5]"};
		}
		$rows{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = "$wvalues[0] $wvalues[1] $wvalues[2] $wvalues[3] $ldata $wdata";
		$sorted{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = $scale;
		$portinfo{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = "$port";
	}
}
my @keys = sort {
	$sorted{$a} <=> $sorted{$b}
} keys(%sorted);
my $rownum = scalar @keys;
my $lastpage = sprintf("%.0f", ($rownum / $batch) + 0.5);
my $nextpage = $page + 1;
my $prevpage = $page - 1;
if ($prevpage < 1) {
	$prevpage = 1;
}
if ($nextpage > $lastpage) {
	$nextpage = $lastpage;
}

if ($ajax_trigger == 0) {

	print OUT <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Flow Sessions</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Display Options</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
	;

	print OUT <<END

<form id="sessionsummary" action="" method="post">
    <table width="100%">
        <tr>
            <td>Address:
                <br>
                <input id='ip'
	                title='Full or partial IP Address as regular expression.&#013;Example: 172.16.100.* will match 172.16.100.0/24'
	                name="ip" type="text" size="12" style="font-size: 8pt; width:80%" value='$displayip'
	                class="form-control animated flipInY">
            </td>
            <td>Port:
                <br>
                <input id='port' title='Port number' name="port" type="text" size="6" style="width:70px" value='$displayport' class="form-control animated flipInY">
            </td>
            <td>Min KB:
                <br>
                <input id='minkb' title='Minimum data'
                name="minkb" type="text" size="6"
                style="width:50%" value='$displayminkb' class="form-control animated flipInY">
            </td>
            <td>Peer:
                <br>
                <select id='peervalue' name="peervalue" style="width:80%" title="Session Stats Level" class="form-control animated flipInY">
                    <option value="$peervalue">$peervalue</option>
                    <option value="">All</option>

END
;

foreach (keys %sites)   { print OUT "<option value='$_'>$sites{$_}</option>\n"; }

print OUT <<END

                </select>
            </td>
            <td>Period:
                <br>
                <select id='time' name="time" style="width:70%" class="form-control animated flipInY">
                    <option value="$time">$timename</option>
                    <option value="300">Last 5 Min</option>
                    <option value="900">Last 15 Min</option>
                    <option value="1800">Last 30 Min</option>
                    <option value="3600">Last 60 Min</option>
                    <option value="7200">Last 2 Hours</option>
                    <option value="28800">Last 8 Hours</option>
                    <option value="86400">Last 24 Hours</option>
                </select>
            </td>
            <td style="display:none;">Export:
                <br>
                <select id='export' name="export" style="width:70px" class="form-control animated flipInY">
                    <option></option>
                    <option value="pdf">&nbsp;PDF&nbsp;</option>
                </select>
            </td>
            <td>
                <br>
                <button id="btn_submit" type="submit" class="btn btn-success" style="font-size: 8pt;">Submit</button>
            </td>
        </tr>
    </table>
    </center>
</form>
END
;

	print OUT <<END

			</div>
		</div>
	</div>
</div>
END
;

	print OUT <<END;

<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12">
        <div class="x_title title_block">
            <h2>Sessions</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div id="sessions_data" class="x_content">
END
	;
}

if ($update != 1) {
	print OUT <<END
	<table id="sessionsummary_table" class="table table-striped" title='Session Summary for the $timename'>
    <thead>
        <tr>
            <th width='2%'>#</th>
            <th width='20%'>Source</th>
            <th width='20%'>Destination</th>
            <th width='12%'>LAN KB</th>
            <th width='12%'>WAN KB</th>
            <th width='14%'>Application</th>
            <th width='16%'>Reduction</th>
            <th width='2%'>Detail</th>
        </tr>
    </thead>
    <tbody>
END
;
	my $c = - 1;
	foreach (reverse @keys)
	{
		$c++;
		next if $c < (($page * $batch) - $batch);
		if ($c == ($page * $batch)) {
			last;
		}
		my $ratio = $sorted{$_};
		my @values = split(' ', $rows{$_});
		my @valuesc = split(/,/, $portinfo{$_});
		#next if $values[1]
		print OUT "<tr><td>" . ($c + 1) . "</td>";
		print OUT "<td>" . $values[0] . ":" .  $values[1] . "</td>\n";
		print OUT "<td>" . $values[2] . ":" .  $values[3] . "</td>\n";
		print OUT "<td>" . $values[4] . "</td>\n";
		print OUT "<td>" . $values[5] . "</td>\n";
		print OUT "<td title='" . $valuesc[1] . "'>" . $valuesc[0] . "</td>\n";
		print OUT "<td width='130'><div class='meter'><span style='width: " . $ratio . "%'><div style='width:100%;display:block; text-align:center; font-size:9px;top:0;left:0;position:absolute;'>" . $ratio . "%</div></span></div></td>\n";
		print OUT "<td><a href='#' title='Session details' data-flowid='".$values[0] . $values[2]."' class='more'><i class='fa fa-search'></i></a></td></tr>\n";
	}

	print <<END

    </tbody></table>

END
;
}

close OUT;

if ($export eq 'pdf')
{
	system("/tce/packages/click/exporttool /tce/www/stats/reports/sessions.html /tce/www/stats/reports/sessionsreport.pdf" );
	print <<END
		Flow Session report is ready for download (Max 1000 records): <br />
        <a href='../stats/reports/sessionsreport.pdf' style='color:#777'> Sessions from the $timename</a>
END
;
}

if ($ajax_trigger == 0) {
	print OUT <<END

			</div>
		</div>
	</div>
</div>
END
;
}
