#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;
use autodie;
use Cwd qw(abs_path);

my $cgi = CGI->new;
my $hostname = $cgi->param("host");
my $mode = $cgi->param("mode");
my $sim = $cgi->param("sim");
my $update = 0;
my $reconfigure = 0;
my $errmsg = '';
my @config;
my $ip = $cgi->param("ip");
my $mask = $cgi->param("mask");
my $gw = $cgi->param("gw");
my $virt_lan0 = $cgi->param("virt_lan0");
my $deployment = $cgi->param("deployment");
my $mtu = $cgi->param("mtu");
my $hold = $cgi->param("hold");
my $nfexpire = $cgi->param("nfexpire");
my $nfexport = $cgi->param("nfexport");
my $nfpeerip = $cgi->param("nfpeerip");
my $nfpeerport = $cgi->param("nfpeerport");
my $dns1 = $cgi->param("dns1");
my $dns2 = $cgi->param("dns2");
my $comp_lvl = $cgi->param("comp_lvl");
my $dd_lvl = $cgi->param("dd_lvl");
my $rsp_lvl = $cgi->param("rsp_lvl");
my $net;
my $disable_secondary_ip;

my $ajax = 0; # Check for ajax call
$ajax = $cgi->param('ajax_trigger');

my $encapproto = $cgi->param("encapproto");
my $newencapproto = 0;
my $new_deployment = 0;
my $new_virt_lan = 0;

my $time;
my $time_day = $cgi->param("day");
my $time_month = $cgi->param("month");
my $time_year = $cgi->param("year");
my $time_hour = $cgi->param("hour");
my $time_minute = $cgi->param("minute");

my $sshd = $cgi->param("sshd");
my $dstore = $cgi->param("dstore");

### Drive the DS is mounted on
my $link = '/wanos';
my $path = abs_path($link);
my @drive = split '/', $path;

my $msg = '';
my $disabled = '';

my %peerips = ();
open(ROW, "<", "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $commastring) = split(/\s*=\s*/, $_, 2);
	$commastring =~ s/(\$(\w+))/$rows{$2}/g;
	$rows{$key} = $commastring;
	my @values = split(',', $commastring);
	$sites{$values[1]} = $values[0];
	if ($peerips{$values[1]} eq '') {
		$peerips{$values[1]} = $values[3];
	}
}
close ROW;

open(CONFIG, "<", "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
while (<CONFIG>)
{
	chomp;
	next if /^\s*\#/;
	next unless /=/;
	my ($key, $variable) = split(/\s*=\s*/, $_, 2);
	$variable =~ s/(\$(\w+))/$config{$2}/g;
	$config{$key} = $variable;
}
close CONFIG;

if ($dstore eq "") {
	$dstore = $config{DSTORE};
}
if ($sshd eq "") {
	$sshd = $config{SSHD};
}
if ($mtu eq "") {
	$mtu = $config{MTU};
}
if ($dns1 eq "") {
	$dns1 = $config{DNS_SERVER_1};
}
if ($dns2 eq "") {
	$dns2 = $config{DNS_SERVER_2};
}
if ($hold eq "") {
	$hold = $config{HOLD};
}
if ($hold > 86400) {
	$hold = 86400;
}
if ($nfexpire eq "") {
	$nfexpire = $config{NFEXPIRE};
}
if ($nfexport eq "") {
	$nfexport = $config{NFEXPORT};
}
if ($nfpeerip eq "") {
	$nfpeerip = $config{NFPEERIP};
}
if ($nfpeerport eq "") {
	$nfpeerport = $config{NFPEERPORT};
}
#if ($ip eq "") { $ip = $config{IP}; $mask = $config{MASK};}
if ($gw eq "") {
	$gw = $config{GW};
}
#if ($mask eq "") { $mask = $config{MASK};}
if ($mode eq "") {
	$mode = $config{MODE};
}
if ($deployment eq "") {
	$deployment = $config{DEPLOYMENT_MODE};
}
if ($virt_lan0 eq "") {
	$virt_lan0 = $config{VIRT_LAN0};
}
if ($hostname eq "") {
	$hostname = $config{HOST};
}
if ($sim eq "") {
	$sim = $config{SIM};
}
if ($encapproto eq "") {
	$encapproto = $config{ENCAPPROTO};
}
if ($comp_lvl eq "") {
	$comp_lvl = $config{COMP_LEVEL};
}
if ($dd_lvl eq "") {
	$dd_lvl = $config{DD_LEVEL};
}
if ($rsp_lvl eq "") {
	$rsp_lvl = $config{RSP_LEVEL};
}

if ($ip eq "")
{
	$ip = $config{IP};
	$mask = $config{MASK};
}
else
{
	$ip =~ s/\s//g;
	($ip, $mask) = split ("/", $ip);
}

if ($virt_lan0 eq "")
{
	$virt_lan0 = $config{VIRT_LAN0};
}
else
{
	$virt_lan0 =~ s/\s//g;
	($virt_lan_ip, $virt_lan_mask) = split ("/", $virt_lan0);
}

if (($mode ne $config{MODE}) ||
	($sim ne $config{SIM}) ||
	($mtu ne $config{MTU}) ||
	($hold ne $config{HOLD}) ||
	($ip ne $config{IP}) ||
	($gw ne $config{GW}) ||
	($mask ne $config{MASK}) ||
	($comp_lvl ne $config{COMP_LEVEL}) ||
	($dd_lvl ne $config{DD_LEVEL}) ||
	($rsp_lvl ne $config{RSP_LEVEL})
)
{
	$update = 1;
	$reconfigure = 1;
}

if ($virt_lan0 ne $config{VIRT_LAN0})
{
	$new_virt_lan = 1;
	$reconfigure = 1;
}

if ($encapproto ne $config{ENCAPPROTO})
{
	$newencapproto = 1;
	$reconfigure = 1;
}

if ($deployment ne $config{DEPLOYMENT_MODE})
{
	$new_deployment = 1;
	$reconfigure = 1;
}

my $sshupdate = 0;
if ($sshd ne $config{SSHD})
{
	$update = 1;
	$sshupdate = 1;
}

my $ds_changed = 0;
if (( $dstore ne $config{DSTORE} ) && ( $dstore ne $drive[2] ))
{
	$update = 1;
	$ds_changed = 1;
	$reconfigure = 1;
}

if (($time_day ne "") && ($time_month ne "") && ($time_year ne "") && ($time_hour ne "") && ($time_minute ne ""))
{
	$time = 1;
	$reconfigure = 1;
}

if (($hostname ne $config{HOST}) || ($nfpeerip ne $config{NFPEERIP}) || ($nfpeerport ne $config{NFPEERPORT}) || ($nfexpire ne $config{NFEXPIRE}) || ($nfexport ne $config{NFEXPORT}))
{
	$update = 1;
}

if ($dns1 ne $config{DNS_SERVER_1})
{
	$dnsupdate = 1;
	my $ipno = qr/2(?:5[0-5]|[0-4]\d)|1\d\d|[1-9]?\d/x;
	if (( $dns1 ne "") && ( $dns1 !~ /^($ipno\.){3}$ipno$/ )) {
		$dnsupdate = 0;
		$errmsg = "DNS Server IP Address 1 invalid: $dns1";
	}
}

if ($dns2 ne $config{DNS_SERVER_2})
{
	$dnsupdate = 1;
	my $ipno = qr/2(?:5[0-5]|[0-4]\d)|1\d\d|[1-9]?\d/x;
	if (( $dns2 ne "") && ( $dns2 !~ /^($ipno\.){3}$ipno$/ )) {
		$dnsupdate = 0;
		$errmsg = "DNS Server IP Address 2 invalid: $dns2";
	}
}

if ($update == 1)
{
	if ($mask < 8 || $mask > 32) {
		$reconfigure = 0;
		$update = 0;
		$errmsg = "MASK invalid: $mask";
	}
}

my $ipno = qr/2(?:5[0-5]|[0-4]\d)|1\d\d|[1-9]?\d/x;
if ($update == 1)
{
	if ($ip =~ /^($ipno\.){3}$ipno$/)
	{
		$update = 1;
		$longmask = "255";
		$b = $mask - 8;
		for ($i = 0; $i < 3; $i++)
		{
			$b = $b - 8;
			if ($b >= 0) {
				$longmask = $longmask . "." . 255;
			}
			if ($b < 0)
			{
				if ($b == - 1) {
					$longmask = $longmask . "." . 254;
				}
				if ($b == - 2) {
					$longmask = $longmask . "." . 252;
				}
				if ($b == - 3) {
					$longmask = $longmask . "." . 248;
				}
				if ($b == - 4) {
					$longmask = $longmask . "." . 240;
				}
				if ($b == - 5) {
					$longmask = $longmask . "." . 224;
				}
				if ($b == - 6) {
					$longmask = $longmask . "." . 192;
				}
				if ($b == - 7) {
					$longmask = $longmask . "." . 128;
				}
				if ($b <= - 8) {
					$longmask = $longmask . "." . 0;
				}
			}
		}

		@maskbyte = split /\./, $longmask;
		@ipbyte = split /\./, $ip;
		for ($i = 0; $i < 4; $i++)
		{
			$b1 = $maskbyte[$i] + 0;
			$b2 = $ipbyte[$i] + 0;
			$NetByte = $b1 & $b2;
			if ($i != 0) {
				$NetAddr = $NetAddr . "." . $NetByte;
			}
			else {
				$NetAddr = $NetByte;
			}

		}
	}
	else {
		$reconfigure = 0;
		$update = 0;
		$errmsg = "IP/MASK invalid: $ip/$mask";
	}

	if ($gw =~ /^($ipno\.){3}$ipno$/)
	{
		@gwbyte = split /\./, $gw;
		for ($i = 0; $i < 4; $i++)
		{
			$b1 = $maskbyte[$i] + 0;
			$b2 = $gwbyte[$i] + 0;
			$gwByte = $b1 & $b2;
			if ($i != 0) {
				$gwAddr = $gwAddr . "." . $gwByte;
			}
			else {
				$gwAddr = $gwByte;
			}
		}
		if ($gwAddr ne $NetAddr) {
			$reconfigure = 0;
			$update = 0;
			$errmsg = "Invalid Gateway : $gw should match network $NetAddr/$mask";
		}
	}
	else {
		$reconfigure = 0;
		$update = 0;
		$errmsg = "Gateway invalid: $gw";
	}

	if (( $nfpeerip ne "") && ( $nfpeerip !~ /^($ipno\.){3}$ipno$/ )) {
		$reconfigure = 0;
		$update = 0;
		$errmsg = "Netflow peer invalid: $nfpeerip";
	}

}

if ($new_virt_lan == 1)
{
	if ($virt_lan_mask ne '')
	{
		if ($virt_lan_mask < 8 || $virt_lan_mask > 32) {
			$reconfigure = 0;
			$update = 0;
			$new_virt_lan = 0;
			$errmsg = "MASK invalid: $mask";
		}
	}

	if ($virt_lan_ip ne '')
	{
		if ($virt_lan_ip !~ /^($ipno\.){3}$ipno$/) {
			$reconfigure = 0;
			$update = 0;
			$new_virt_lan = 0;
			$errmsg = "IP Invalid: $virt_lan_ip";
		}
	}
}

if ($new_deployment == 1 && $deployment eq 'tunnel')
{
	foreach (values %peerips)
	{
		if ($_ !~ /^($ipno\.){3}$ipno$/) {
			$reconfigure = 0;
			$update = 0;
			$new_deployment = 0;
			$errmsg = "MultiSite is missing a static Remote Peer IP";
		}
	}

	if ($encapproto ne 'udp') {
		$reconfigure = 0;
		$update = 0;
		$new_deployment = 0;
		$errmsg = "Tunnel mode requires UDP Encapsulation";
	}
}

if ($new_deployment == 1 && $deployment eq 'router' && $new_virt_lan == 0) {
	$reconfigure = 0;
	$update = 0;
	$new_deployment = 0;
	$new_virt_lan = 0;
	$errmsg = "Router mode requires a secondary addresse";
}
if ($new_virt_lan == 1 && $deployment ne 'router') {
	$reconfigure = 0;
	$update = 0;
	$new_deployment = 0;
	$new_virt_lan = 0;
	$errmsg = "Secondary Addresses are only compatible with Router Mode";
}

if (($update == 1) || ($newencapproto == 1))
{
	$config{DSTORE} = $dstore;
	$config{SSHD} = $sshd;
	$config{MTU} = $mtu;
	$config{HOLD} = $hold;
	$config{NFEXPIRE} = $nfexpire;
	$config{NFEXPORT} = $nfexport;
	$config{NFPEERIP} = $nfpeerip;
	$config{NFPEERPORT} = $nfpeerport;
	$config{IP} = $ip;
	$config{GW} = $gw;
	$config{MASK} = $mask;
	$config{MODE} = $mode;
	$config{HOST} = $hostname;
	$config{SIM} = $sim;
	$config{COMP_LEVEL} = $comp_lvl;
	$config{DD_LEVEL} = $dd_lvl;
	$config{RSP_LEVEL} = $rsp_lvl;
	$config{ENCAPPROTO} = $encapproto;
	$config{DNS_SERVER_1} = $dns1;
	$config{DNS_SERVER_2} = $dns2;
}

if ($new_deployment == 1)
{
	$config{DEPLOYMENT_MODE} = $deployment;
}

if ($new_virt_lan == 1)
{
	$config{VIRT_LAN0} = $virt_lan0;
}

if ($ajax == 0) {

	print <<END;

<script type="text/javascript" langage="JavaScript">
        function secondary_enable(mode_selected)
	{
	if (mode_selected == 'router') { document.getElementById("virt_lan0").disabled = false; }
	else { document.getElementById("virt_lan0").disabled = true; }
	}
</script>

<div class="page-title">
    <div class="title_left">
        <h3>Settings</h3>
    </div>
</div>
<div class="clearfix"></div>
END
	;

}

# System Settings

if ($ajax == 0) {

	print <<END

<div class="row">
    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>System Settings</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">
END
;
}

if ($ajax == 1) {

	print <<END
	<div class="alert alert-success alert-dismissible fade in" role="alert">
	    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
	    <strong>Done!</strong> New settings applied. <br />

END
;
	if ($sshupdate == 1) {
		print "Applying SSH settings. Established SSH sessions may be terminated. <br />\n";
		open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -sshd $sshd ");
	}

	if ($dnsupdate == 1) {
		$config{DNS_SERVER_1} = $dns1;
		$config{DNS_SERVER_2} = $dns2;
		print "Applying new DNS settings.<br />\n";
		open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -dnsupdate $dns1 $dns2");
	}

	if ($time == 1) {
		print "Setting new system time.<br />\n";
		open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -time $time_day $time_month $time_year $time_hour $time_minute ");
	}

	print <<END

	</div>

END
;

}

if ($ajax == 1 || $ajax == 0) {
	print <<END

                <form id="setting_1_4" class="form-horizontal form-label-left" name="settings-form" action="" method="post" data-parsley-validate>



                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="host">Hostname <span class="required">*</span>
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input id="host" type="text" name="host" value="$config{HOST}" size="40" maxlength="100" aria-required="true" aria-invalid="false" class="form-control col-md-7 col-xs-12" data-parsley-error-message="This field is required" required="required" data-toggle="tooltip" title="Hostname of appliance">
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="last-name">Date</label>
                        <div class="col-md-6 col-sm-6 col-xs-12" style="padding:0;">
                            <div class="form-group row">

                                <div class="col-md-4 col-sm-4 col-xs-12">
                                    <input class="form-control" id="month"
                                        name="month" type="text"
                                        title="Month value between (1-12)" data-toggle="tooltip"
                                        id="month" value=""
                                        size="2" maxlength="2" placeholder="Month"
                                        data-parsley-min="1" data-parsley-type="integer"
                                        data-parsley-group="time"
                                        data-parsley-range="[1, 12]">
                                </div>

                                <div class="col-md-4 col-sm-4 col-xs-12">
                                    <input class="form-control" id="day"
	                                    name="day" type="text"
	                                    title="Day value between (1-31)" data-toggle="tooltip"
	                                    id="day" value=""
	                                    size="2" maxlength="2" placeholder="Day"
	                                    data-parsley-min="1" data-parsley-type="integer"
	                                    data-parsley-group="time"
	                                    data-parsley-range="[1, 31]">
                                </div>

                                <div class="col-md-4 col-sm-4 col-xs-12">
                                    <input class="form-control" id="year"
	                                    name="year" type="text"
	                                    title="Year value between (2015-2017)" data-toggle="tooltip"
	                                    id="year" value=""
	                                    size="4" maxlength="4" placeholder="Year"
	                                    data-parsley-min="2" data-parsley-type="integer"
	                                    data-parsley-group="time"
	                                    data-parsley-range="[2015, 2017]">
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="last-name">Time</label>
                        <div class="col-md-6 col-sm-6 col-xs-12" style="padding:0;">
                            <div class="form-group row">

                                <div class="col-md-4 col-sm-4 col-xs-12">
                                    <input class="form-control" id="hour"
	                                    name="hour" type="text"
	                                    title="Hour value between (0-23)" data-toggle="tooltip"
	                                    id="hour" value=""
	                                    size="2" maxlength="2" placeholder="Hour"
	                                    data-parsley-min="0" data-parsley-type="integer"
	                                    data-parsley-group="time"
	                                    data-parsley-range="[0, 23]">
                                </div>

                                <div class="col-md-4 col-sm-4 col-xs-12">
                                    <input class="form-control" id="minute"
	                                    name="minute" type="text"
	                                    title="Minute value between (0-59)"
	                                    data-toggle="tooltip"id="minute" value=""
	                                    size="2" maxlength="2" placeholder="Minute" data-parsley-min="0"
	                                    data-parsley-type="integer"
	                                    data-parsley-group="time"
	                                    data-parsley-range="[0, 59]">
                                </div>

                                <div class="col-md-4 col-sm-4 col-xs-12">
                                    <input class="form-control" id="second"
	                                    name="second" type="text"
	                                    title="Seconds value between (0-59)"
	                                    data-toggle="tooltip"id="second" value=""
	                                    size="2" maxlength="2" placeholder="Second" data-parsley-min="0"
	                                    data-parsley-type="integer"
	                                    data-parsley-group="time"
	                                    data-parsley-range="[0, 59]">
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="form-group" id="time_error" style="display:none;">
                        <label for="sshd" class="control-label col-md-3 col-sm-3 col-xs-12"></label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <ul class="parsley-errors-list filled" ><li class="parsley-min">Please enter a full date and time</li></ul>
                        </div>
                    </div>

                    <div class="form-group">
                        <label for="sshd" class="control-label col-md-3 col-sm-3 col-xs-12">SSH
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <select id="sshd" name="sshd" class="form-control" data-toggle="tooltip" title="Enable SSH server on appliance?">
END
;
	if ($config{SSHD} eq 'disable') {
		print "<option value='disable' selected='selected'>Disable</option><option value='enable'>Enable</option></select>\n";
	}
	if ($config{SSHD} eq 'enable') {
		print "<option value='enable' selected='selected'>Enable</option><option value='disable'>Disable</option></select>\n";
	}

	print <<END;
                        </div>
                    </div>

                    <div class="form-group">
                        <label for="dstore" class="control-label col-md-3 col-sm-3 col-xs-12">Datastore</label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <select name="dstore" id="dstore" class="form-control" onchange="alert('Warning: Changing the partition will clear the datastore and requires careful consideration.')">
END
	;
	# Disk partitions
	foreach $partition (`/tce/etc/wanos/wanos-fdisk list`)
	{
		($part, $partsize) = split(' ', $partition);
		if (( $config{DSTORE} eq $part ) || ( $drive[2] =~ /$part/ )) {
			print "<option value='$part' selected='selected'>$part  $partsize </option>\n";
		}
		else {
			print "<option value='$part' >$part  $partsize </option>\n";
		}
	}

	print <<END;
                            </select>
                        </div>
                    </div>

                    <div class="form-group">
                        <label for="dns1" class="control-label col-md-3 col-sm-3 col-xs-12">Primary DNS Server</label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input type="text" id="dns1" name="dns1" value="$config{DNS_SERVER_1}" size="16"
                            maxlength="16" id="dns1" class="form-control col-md-7 col-xs-12"
                            data-parsley-check_ip="" data-toggle="tooltip" title="IP address of primary DNS server">
                        </div>
                    </div>

                    <div class="form-group">
                        <label for="dns2" class="control-label col-md-3 col-sm-3 col-xs-12">Secondary DNS Server</label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input type="text" id="dns2" name="dns2" value="$config{DNS_SERVER_2}" size="16"
                            maxlength="16" id="dns2" class="form-control col-md-7 col-xs-12"
                            data-parsley-check_ip="" data-toggle="tooltip" title="IP address of secondary DNS server">
                        </div>
                    </div>

                    <div class="ln_solid"></div>
                    <div class="form-group">
                        <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
                            <a type="button" class="btn btn-default" href="/#/system_settings" onclick="window.location.reload();return false;" style='font-size: 8pt;'>Cancel</a>
                            <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Submit</button>
                        </div>
                    </div>

                </form>
END
	;
}

if ($ajax == 0) {

	print <<END
            </div>
        </div>
    </div>
END
;

}

# Network Settings

if ($ajax == 0) {

	print <<END

<div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>Network Settings</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
;
}

if ($ajax == 2) {

	if ($errmsg ne '') {

		print <<END
		<div class="alert alert-danger alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Unsuccessful!</strong> $errmsg <br />
		</div>

END
	;

	} else {

		if ($reconfigure == 1) {
			$msg = "Restarting Wanos Service !";
		} else {
			$msg = "New settings applied.";
		}

		if ($new_deployment == 1) {
			$msg = "New deployment applied. <br />\n";
			open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -deployment $deployment ");
		}

		if ($new_virt_lan == 1) {
			$msg = $msg . "New VIRT_LAN0 address applied. $virt_lan0<br />\n";
			open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -virtlan $virt_lan0 ");
		}

		print <<END
		<div class="alert alert-success alert-dismissible fade in" role="alert">
		    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
		    <strong>Done!</strong> $msg
		</div>

END
	;

	}

}

if ($ajax == 0 || $ajax == 2) {

	print <<END
                <form id="setting_2_4" class="form-horizontal form-label-left" name="settings-form" action="" method="post" data-parsley-validate>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="ip">Wan IP Address / Mask
                        <span class="description">Ex: 192.168.0.1/24</span>
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input id="ip" name="ip" type="text" size="16"
	                            value="$config{IP}/$config{MASK}"
	                            class="form-control col-md-7 col-xs-12"
	                            data-parsley-check_ip_and_mask="" data-toggle="tooltip" title="IP address and subnet mask length that should be applied to WAN interface">
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="gw">Wan Gateway
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input id="gw" name="gw" type="text" size="16" value="$config{GW}" class="form-control col-md-7 col-xs-12"
                            data-parsley-check_ip="" data-toggle="tooltip" title="IP address of gateway to reach network outside local LAN network">
                        </div>
                    </div>

                    <div class="form-group">
                        <label for="sshd" class="control-label col-md-3 col-sm-3 col-xs-12">Deployment Mode</label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <select name="deployment" id="deployment" class="form-control" onchange="secondary_enable(this.value)">
END
;

	if ($config{DEPLOYMENT_MODE} eq 'bridge') {
		$config{VIRT_LAN0} = '';
		$disable_secondary_ip = 'disabled';
		print "<option value='bridge'>bridge</option><option value='router'>router</option><option value='tunnel'>tunnel</option>";
	}
	if ($config{DEPLOYMENT_MODE} eq 'router') {
		print "<option value='router'>router</option><option value='bridge' >bridge</option><option value='tunnel'>tunnel</option>";
	}
	if ($config{DEPLOYMENT_MODE} eq 'tunnel') {
		$disable_secondary_ip = 'disabled';
		print "<option value='tunnel'>tunnel</option><option value='bridge' >bridge</option><option value='router'>router</option>";
	}

	print <<END;
                            </select>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="virt_lan0">Secondary Address / Mask
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input name="virt_lan0"
                            id="virt_lan0" type="text"
                            size="16" value="$config{VIRT_LAN0}" class="form-control col-md-7 col-xs-12"
                            data-parsley-validate-if-empty
                            data-parsley-is_tunnel='["#deployment option:selected", "router"]'
			    $disable_secondary_ip
                            >
                        </div>
                    </div>

                    <div class="ln_solid"></div>
                    <div class="form-group">
                        <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
                            <a type="button" class="btn btn-default" href="/#/system_settings" onclick="window.location.reload();return false;" style='font-size: 8pt;'>Cancel</a>
                            <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Submit</button>
                        </div>
                    </div>

                </form>

END
	;
}

if ($ajax == 0) {
	print <<END

            </div>
        </div>
    </div>

</div>
END
;

}

if ($ajax == 0) {

	print <<END

<div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>Optimization Settings</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">
END
;
}

if ($ajax == 3) {

	$msg = "New settings applied. <br />";

	if ($newencapproto == 1) {
		$msg = $msg . "New encapsulation applied.<br />\n";
		open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -encapproto $encapproto ");
	}

	print <<END
	<div class="alert alert-success alert-dismissible fade in" role="alert">
	    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
	    <strong>Done!</strong> $msg
	</div>
END
;
}

if ($ajax == 0 || $ajax == 3) {

	print <<END

                <form id="setting_3_4" class="form-horizontal form-label-left" name="settings-form" action="" method="post">

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="comp_lvl">Compression Level
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">

                            <select id="comp_lvl" name="comp_lvl" data-toggle="tooltip" title="0 to Disable compression. Level 1 for highest throughput. Level 8-12 for best results." class="form-control">
                                <option value="$config{COMP_LEVEL}" selected='selected'>$config{COMP_LEVEL}</option>
                                <option value="0">0</option>
                                <option value="1">1</option>
                                <option value="2">2</option>
                                <option value="3">3</option>
                                <option value="4">4</option>
                                <option value="5">5</option>
                                <option value="6">6</option>
                                <option value="7">7</option>
                                <option value="8">8</option>
                                <option value="9">9</option>
                                <option value="10">10</option>
                                <option value="11">11</option>
                                <option value="12">12</option>
                                <option value="13">13</option>
                                <option value="14">14</option>
                                <option value="15">15</option>
                                <option value="16">16</option>
                                <option value="17">17</option>
                                <option value="18">18</option>
                                <option value="19">19</option>
                                <option value="20">20</option>
                            </select>

                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="dd_lvl">Deduplication Level
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">

                            <select id="dd_lvl" name="dd_lvl" data-toggle="tooltip" title="4 : Best Results.&#013;1 : Fastest throughput 0 : Receive Only." class="form-control">
                                <option value="$config{DD_LEVEL}" selected='selected'>$config{DD_LEVEL}</option>
                                <option value="0">0</option>
                                <option value="1">1</option>
                                <option value="2">2</option>
                                <option value="3">3</option>
                                <option value="4">4</option>
                            </select>

                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="rsp_lvl">Packet Loss Recovery
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">

                            <select id="rsp_lvl" name="rsp_lvl" data-toggle="tooltip" title="Level 1 - Most Conservative loss detection and recovery.&#013;Level 4 - Most Aggressive loss detection and recovery." class="form-control">
                                <option value="$config{RSP_LEVEL}" selected="selected">$config{RSP_LEVEL}</option>
                                <option value="1">1</option>
                                <option value="2">2</option>
                                <option value="3">3</option>
                                <option value="4">4</option>
                            </select>

                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="encapproto">Encapsulation
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">

                            <select name="encapproto" id="encapproto" data-toggle="tooltip" title="Encapsulation for optimized traffic needs to match on all sites" onchange="encap_change(this.value)" class="form-control">
END
;

	foreach $encap ('ipcomp', 'udp')
	{
		print "<option value='" . $encap . "' ";
		if ($encap eq $config{ENCAPPROTO}) {
			print "selected='selected'";
		}
		print ">" . $encap . "</option>\n";
	}

	print <<END

                            </select>

                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="hold">Peer Timeout
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input id="hold" name="hold" type="text" size="16" value="$config{HOLD}"
                                class="form-control col-md-7 col-xs-12"
                                data-parsley-error-message="This field is required" required="required"
                                data-toggle="tooltip" title="Number of seconds before peer times out">
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12" for="sim">Global Wan Tx Rate
                        </label>
                        <div class="col-md-6 col-sm-6 col-xs-12">
                            <input id="sim" name="sim" type="text" size="16" value="$config{SIM}"
                            class="form-control col-md-7 col-xs-12"
                            data-parsley-error-message="This field is required" required="required"
			    data-toggle="tooltip" title="The Global WAN Outbound Tx Shaper shapes all outbound traffic to the WAN link transmit rate. It is recommended to set the Global WAN Tx rate to WAN link transmit rate. 0 to Disable. Rate in kbps.">
                        </div>
                    </div>

                    <div class="ln_solid"></div>
                    <div class="form-group">
                        <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
                            <a type="button" class="btn btn-default" href="/#/system_settings" onclick="window.location.reload();return false;" style='font-size: 8pt;'>Cancel</a>
                            <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Submit</button>
                        </div>
                    </div>

                </form>

END
;
}

if ($ajax == 0) {

	print <<END
            </div>
        </div>
    </div>

</div>
END
;

}

if ($ajax == 0) {

	print <<END

<div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>NetFlow Settings</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
;
}

if ($ajax == 4) {

	$msg = "New settings applied. <br />";

	print <<END
	<div class="alert alert-success alert-dismissible fade in" role="alert">
	    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
	    <strong>Done!</strong> $msg
	</div>
END
;
}

if ($ajax == 0 || $ajax == 4) {
	print <<END
                <form id="setting_4_4" class="form-horizontal form-label-left" name="settings-form" action="" method="post">

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="nfexport">Netflow Exports
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">

                                <select name="nfexport" id="nfexport" class="form-control" data-toggle="tooltip" title="Should Netflow exports be enabled?">

END
;

	if ($config{NFEXPORT} eq 'Disable') {
		$disabled = 'disabled';
		print "<option value='Disable'>Disable</option><option value='Enable'>Enable</option>";
	}
	if ($config{NFEXPORT} eq 'Enable') {
		print "<option value='Enable'>Enable</option><option value='Disable'>Disable</option>";
	}

	print <<END

                                </select>

                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="nfpeerip">Netflow Collector IP
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <input id="nfpeerip" name="nfpeerip" id="nfpeerip" type="text" size="16"
                                value="$config{NFPEERIP}" class="form-control col-md-7 col-xs-12"
                                $disabled required data-parsley-check_ip="" data-toggle="tooltip" title="IP address of Netflow collector">
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="nfpeerport">Netflow Collector Port
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <input id="nfpeerport" name="nfpeerport" type="text" size="16" value="$config{NFPEERPORT}"
	                                class="form-control col-md-7 col-xs-12" $disabled
									data-parsley-type="integer"
									data-parsley-range="[1, 65535]" required data-toggle="tooltip" title="Port on which Netflow collector is exposed">
                            </div>
                        </div>

                        <div class="ln_solid"></div>
                        <div class="form-group">
	                        <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
	                            <a type="button" class="btn btn-default" href="/#/system_settings" onclick="window.location.reload();return false;" style='font-size: 8pt;'>Cancel</a>
	                            <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Submit</button>
	                        </div>
	                    </div>

                    </form>


END
;
}
if ($ajax == 0) {
	print <<END
            </div>
        </div>
    </div>

</div>
END
;
}

if ($ds_changed == 1 && $update == 1)
{
	print "<br /><b>Clearing the Datastore to apply new Datastore settings.<br />\n";
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -dstore $dstore ");
}

if ($update == 1)
{

	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -sys $mode $sim ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -comp_lvl $comp_lvl ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -dd_lvl $dd_lvl ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -rsp_lvl $rsp_lvl ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -host $hostname ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -nfpeerip $nfpeerip ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -net $ip $mask $NetAddr $gw ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -settings $mtu $hold $nfexpire $nfpeerport $nfexport ");
}


if ($reconfigure == 1) {
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -reconfigure &");
}
