#!/usr/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;
use Cwd qw(abs_path);
use List::Util qw(sum);

my $cgi = CGI->new;
my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param( "ajax_trigger" );

my $datestring = time();

my $json = '';
my @colors_arr = (
    # top, top opacity, bottom, bottom opacity ;
    [ '#98B937', '0.2', '#606b2c', '0.2' ],
    [ '#6A9113', '0.2', '#141517', '0.2' ],
    [ '#52c234', '0.2', '#29323c', '0.2' ],
    [ '#52c234', '0.2', '#061700', '0.2' ],
    [ '#ADD100', '0.2', '#7B920A', '0.2' ],
    [ '#414d0b', '0.2', '#727a17', '0.2' ],
    [ '#727a17', '0.2', '#606b2c', '0.2' ],
    [ '#98B937', '0.2', '#71B280', '0.2' ]
);

if ($ajax_trigger == 0) {

    print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>$title</h3>
    </div>
</div>
<div class="clearfix"></div>

<style>

END
    ;

    my $k = 0;
    for my $colors (@colors_arr) {

        print '.gradient'.$k.' {';
        print 'fill: url(#gradient-area'.$k.');';
        print '}';

        print '.line'.$k.' {';
        print 'fill: none; stroke: '.@$colors[0].'; stroke-width: 1;';
        print '}';

        for (my $j = 0; $j < 4; $j++) {
            if ($j == 0) {
                print '.lgt'.$k.' {';
                print 'stop-color : '.@$colors[$j].';';
            }

            if ($j == 1) {
                print 'stop-opacity : '.@$colors[$j].';';
            }

            if ($j == 2) {
                print '}';
                print '.lgb'.$k.' {';
                print 'stop-color : '.@$colors[$j].';';
            }

            if ($j == 3) {
                print 'stop-opacity : '.@$colors[$j].';';
                print '}';
            }
        }

        for (my $m = 0; $m < 4; $m++) {
            if ($m == 0) {
                print '.legend'.$k.' {';
                print 'background: '.@$colors[$m].';';
            }

            if ($m == 3) {
                print '}';
            }
        }
        $k++;
    }

    print <<END;
</style>

END
    ;

    print <<END;
<div class="row">
    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x_title title_block">
            <h2>System Information</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
    ;
}

my $name = $cgi->param( "trend" );
print $name;
my $desc = $cgi->param( "desc" );

my @graphs;
push ( @graphs, "cpu,CPU Load", "diskio,Disk Input/Output", "memory,RAM Utilization", "diskusage,Disk Usage" );

open( CONFIG, "<", "/tce/etc/wanos/wanos.conf" ) || die( "Couldn't open the file. Error: $!\n" );
while (<CONFIG>)
{
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split( /\s*=\s*/, $_, 2 );
    $variable =~ s/(\$(\w+))/$config{$2}/g;
    $config{$key} = $variable;
}
close CONFIG;

### Drive the DS is mounted on
my @drive_used = split ' ', `df -h /wanos | grep ^/dev/`;
chop( $drive_used[4] );
my @drive;

if ($drive_used[0] !~ "by-uuid")
{
    @drive = split '/', $drive_used[0];
}
else
{
    my $path = `ls -la $drive_used[0]`;
    my @path = split ' ', $path;
    @drive = split '/', $path[10];
}

my $platform = "Ubuntu";
if (`uname -an` !~ "buntu")
{
    $platform = "MicroCore";
}

my @totals = split( / /, `tail -1 /tce/www/stats/reduction` );
$total = sprintf '%.2f', (($totals[0] - $totals[1]) / 1024000000);

my @uptime = split( / /, `uptime` );
$up = "$uptime[3] $uptime[4] $uptime[5]";
chop( $up );

open( ROW, "<", "/tce/etc/wanos/peersites" ) || die( "Couldn't open the file. Error: $!\n" );
while (<ROW>)
{
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $commastring) = split( /\s*=\s*/, $_, 2 );
    $commastring =~ s/(\$(\w+))/$rows{$2}/g;
    $rows{$key} = $commastring;
    my @values = split( ',', $commastring );
    $sites{$values[1]} = $values[0];
}
close ROW;

@info = `/tce/etc/wanos/makewanoscfg.sh -aqm_name`;
foreach (@info)
{
    next unless /NAME=/;
    $prod_name = (split( /=/, $_, 2 ))[1];
}

# get load value
$load = `cat /proc/loadavg`;
@array = split ' ', $load;
$load = $array[0] * 20;

# get cpu value
$cpu_threads = `awk '/^processor/ {count++} END {print count}' /proc/cpuinfo`;
my $cpu = 0;
if ($ajax_trigger == 2) 
{

   my $diff_usage;
   my ($prev_idle, $prev_total, $idle, $total, $diff_idle, $diff_total) = 0;
        open(STAT, '/proc/stat') or die "Error: $!";
        while (<STAT>) {
                next unless /^cpu\s+[0-9]+/;
                my @cpu = split /\s+/, $_;
                shift @cpu;
                $idle = $cpu[3];
                $total = sum(@cpu);
                $prev_idle = $idle;
                $prev_total = $total;
        }
        close STAT;

        select(undef, undef, undef, 0.5);

        open(STAT, '/proc/stat') or die "Error: $!";
        while (<STAT>) {
                next unless /^cpu\s+[0-9]+/;
                my @cpu = split /\s+/, $_;
                shift @cpu;
                $idle = $cpu[3];
                $total = sum(@cpu);

                $diff_idle = $idle - $prev_idle;
                $diff_total = $total - $prev_total;
                $diff_usage = 100 * ($diff_total - $diff_idle) / $diff_total;
        }
        close STAT;

   $cpu = sprintf '%.1f', $diff_usage;
}

# get mem %
$mem = `cat /tce/www/stats/memprec`;

$mem =~ s/^\s+|\s+$//g;

$totalmem = sprintf '%.1f', ((split " ", `head -1 /proc/meminfo`)[1] / 1024000);

# datastore stats
@array = sort {
    $a <=> $b
} keys( %sites );
$cfgsites = @array;
$cfgsites = ($cfgsites * ($config{DS_SIZE} / 1024));
$disk = `du -s /wanos/ds0/`;
@array = split ' ', $disk;
$disk = $array[0];
$disk = sprintf '%.2f', ($disk / 1024 / 1024);
$disk = ($disk / $cfgsites) * 100;
$disk = sprintf '%.0f', $disk;

$disk =~ s/^\s+|\s+$//g;

# swap disk
my $swap_line=`grep ^/dev/ /proc/swaps`;
my @swap_tab = split(/\s+/, $swap_line);
my $swap_space = sprintf '%.1f', ($swap_tab[2] / 1000000);
@swap_tab = split('\/', $swap_tab[0]);
$swap_line=$swap_tab[2];


if ($ajax_trigger == 0) {

    print <<END

<div>
                <table class="table table-striped">
                    <tr>
                        <td width='50%'>
                            Hostname
                        </td>
                        <td width='50%'>
                           $config{HOST}
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            Software Version
                        </td>
                        <td width='50%'>
                            $config{VERSION} $prod_name
                        </td>
                    </tr>
					<tr>
                        <td width='50%'>
                            CPU Threads
                        </td>
                        <td width='50%'>
                            $cpu_threads
                        </td>
                    </tr>
					<tr>
                        <td width='50%'>
                            Datastore Disk
                        </td>
                        <td width='50%'>
                            $drive[2]
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            System Memory
                        </td>
                        <td width='50%'>
                            $totalmem GB
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            Total GB Saved
                        </td>
                        <td width='50%'>
                            $total GB
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            Swap Disk
                        </td>
                        <td width='50%'>
                            $swap_line $swap_space GB
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            Uptime
                        </td>
                        <td width='50%'>
                            $up
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            Platform
                        </td>
                        <td width='50%'>
                            $platform
                        </td>
                    </tr>
                </table>
END
    ;

    print <<END

            </div>
        </div>
    </div>
</div>
END
    ;

    print <<END;

    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x_title title_block">
            <h2>Indicators</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel" style="height:350px;">
            <div class="x_content" style="text-align: center;top:40%;transform: translateY(-35%)  ">

END
    ;

}

if ($ajax_trigger == 0) {

    print <<END
<center>	
        <div style='display:inline-block;'> <center><h5>Load</h5><span id="chart-load" class="chart" data-percent="$load"> <span class="percent"></span> </span></center></div>
        <div style='display:inline-block;'> <center><h5>CPU</h5><span id="chart-cpu" class="chart" data-percent="$cpu"> <span class="percent"></span> </span></center></div>
        <div style='display:inline-block;'> <center><h5>Memory</h5><span id="chart-mem" class="chart" data-percent="$mem"> <span class="percent"></span> </span></center></div>
        <div style='display:inline-block;'> <center><h5>Disk</h5><span id="chart-disk" class="chart" data-percent="$drive_used[4]"> <span class="percent"></span> </span></center></div>
        <div style='display:inline-block;'> <center><h5>Datastore</h5><span id="chart-datastore" class="chart" data-percent="$disk" data-bar-color="#75BCDD"> <span class="percent"></span> </span></center></div>
</center>
<script>
        \$(function () {
            \$('.chart').easyPieChart({
                easing: 'easeOutBounce',
		size: 95,
		lineWidth: 5,
                barColor: function (percent) {
       			return (percent < 40 ? '#5cb85c' : percent < 85 ? '#f0ad4e' : '#cb3935');
		},
                onStep: function (from, to, percent) {
                    \$(this.el).find('.percent').text(Math.round(percent));
                }
            });
	});
</script>
</div>
END
    ;

    print <<END

	        </div>
	    </div>
	</div>

END
    ;

}

if ($ajax_trigger == 0) {

    if ($name eq '')
    {
        foreach $graph (@graphs)
        {
            ($graphname, $desc) = split( ',', $graph );

            print <<END

    <div class="col-md-6 col-sm-6 col-xs-12">
        <div class="x_title title_block">
            <h2>$desc</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>

        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
            ;

            if ($graphname eq 'cpu') {

                $filename = "/tce/www/stats/cpu-Day.json";
                open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                    local $/;
                    $json = <$fh>;
                }
                $json =~ s/[\n\r\s]+//g;

                print <<END
		        <script type="text/javascript">
		            window.ratio = undefined;
                    var json=$json, tmp_arr = [];
                    var DURATION = 1500;
                    var DELAY    = 500;

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;
                        for(var j = 0; j < length_value; j++) {
                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr.push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j+length_value] != 'object' ? parseFloat(json.data[i][j+length_value]) : 0
                                    });
                                }
                            }
                            drawLineChart('lineChart$graphname', tmp_arr, 'cpu', 'CPU the Last Day', j);
                            tmp_arr = [];

                        }
                    }

                </script>

                <script type="text/javascript">
                    drawLegend('lineChart$graphname', json, 'cpu');
                </script>

                <a href="/#/cpu/all" id="lineChart$graphname" class="d3graph">
                    <svg id="lineChartSVG$graphname" class="lineChart--svg">
                      <defs>
END
                ;

                my $n = 0;
                for my $colors (@colors_arr) {

                    for (my $j = 0; $j < 4; $j++) {

                        if ($j == 0) {
                            print '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                            print '<stop class="lgt'.$n.'" offset="0%" />';
                        }

                        if ($j == 1) {
                            print '<stop class="lgb'.$n.'" offset="100%" />';
                        }

                        if ($j == 3) {
                            print '</linearGradient>';
                        }
                    }
                    $n++;
                }
                print <<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
                ;

            }

            if ($graphname eq 'memory') {

                $filename = "/tce/www/stats/memory-Day.json";
                open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                    local $/;
                    $json = <$fh>;
                }

                close( $fh );
                $json =~ s/[\n\r\s]+//g;

                print <<END
		         <script type="text/javascript">
		            window.ratio = undefined;
                    var json=$json, tmp_arr = [];

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;

                        for(var j = 0; j < length_value; j++) {
                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr.push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j+length_value] != 'object' ? parseFloat(json.data[i][j+length_value]) : 0
                                    });
                                }
                            }
END
                ;
                print <<END
                window.max = d3.max(tmp_arr, function (d) {
                    return Math.ceil(d.value * 1.2);
                }) > 1 ? d3.max(tmp_arr, function (d) {
                    return Math.ceil(d.value * 1.2);
                }) : 10;
END
                ;
                print <<END
                            drawLineChart('lineChart$graphname', tmp_arr, 'memory', 'Memory the Last Day', j);
                            tmp_arr = [];

                        }
                    }
                </script>
                <script type="text/javascript">
                    drawLegend('lineChart$graphname', json, 'memory');
                </script>
                <a href="/#/memory/all" id="lineChart$graphname" class="d3graph">
                    <svg id="lineChartSVG" class="lineChart--svg">
                      <defs>
END
                ;

                my $n = 0;
                for my $colors (@colors_arr) {

                    for (my $j = 0; $j < 4; $j++) {

                        if ($j == 0) {
                            print '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                            print '<stop class="lgt'.$n.'" offset="0%" />';
                        }

                        if ($j == 1) {
                            print '<stop class="lgb'.$n.'" offset="100%" />';
                        }

                        if ($j == 3) {
                            print '</linearGradient>';
                        }
                    }
                    $n++;
                }
                print <<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
                ;

            }

            if ($graphname eq 'diskio') {

                $filename = "/tce/www/stats/$graphname-Day.json";
                open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                    local $/;
                    $json = <$fh>;
                }

                print <<END
		         <script type="text/javascript">
		            window.ratio = undefined;
                    var json=$json, tmp_arr = [];

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;

                        for(var j = 0; j < length_value; j++) {
                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr.push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j+length_value] != 'object' ? parseFloat(json.data[i][j+length_value]) : 0
                                    });
                                }
                            }
END
                ;
                print <<END
                window.max = d3.max(tmp_arr, function (d) {
                    return Math.ceil(d.value);
                }) > 1 ? d3.max(tmp_arr, function (d) {
                    return Math.ceil(d.value);
                }) : 10;
END
                ;
                print <<END
                            drawLineChart('lineChart$graphname', tmp_arr, 'load', 'Disk Input/Output the Last Day', j);
                            tmp_arr = [];

                        }
                    }
                </script>
                <script type="text/javascript">
                    drawLegend('lineChart$graphname', json, 'load');
                </script>
                <a href="/#/diskio/all" id="lineChart$graphname" class="d3graph">
                    <svg id="lineChartSVG" class="lineChart--svg">
                      <defs>
END
                ;

                my $n = 0;
                for my $colors (@colors_arr) {

                    for (my $j = 0; $j < 4; $j++) {

                        if ($j == 0) {
                            print '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                            print '<stop class="lgt'.$n.'" offset="0%" />';
                        }

                        if ($j == 1) {
                            print '<stop class="lgb'.$n.'" offset="100%" />';
                        }

                        if ($j == 3) {
                            print '</linearGradient>';
                        }
                    }
                    $n++;
                }
                print <<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
                ;

            }

            if ($graphname eq 'diskusage') {

                $filename = "/tce/www/stats/$graphname-Day.json";
                open( my $fh, '<', $filename ) or die "cannot open file $filename"; {
                    local $/;
                    $json = <$fh>;
                }

                print <<END
		         <script type="text/javascript">
		            window.ratio = undefined;
                    var json=$json, tmp_arr = [];

                    if(typeof json != 'undefined') {
                        var length_value, length_arr = json.data[0];
                        length_arr.splice(0,1);

                        length_value = length_arr.length / 2;

                        for(var j = 0; j < length_value; j++) {
                            for(var i = 0; i < json.data.length; i++) {
                                if(i == json.data.length-1 && json.data[i][j+length_value] == null) { 
                                 } else {
                                    tmp_arr.push({
                                        'date' : (parseInt(json.meta.start) + parseInt(json.meta.step)*i)*1000,
                                        'value': typeof json.data[i][j+length_value] != 'object' ? parseFloat(json.data[i][j+length_value]) : 0
                                    });
                                }
                            }
END
                ;
                print <<END
                window.max = d3.max(tmp_arr, function (d) {
                    return Math.ceil(d.value * 1.2);
                }) > 1 ? d3.max(tmp_arr, function (d) {
                    return Math.ceil(d.value * 1.2);
                }) : 10;
END
                ;
                print <<END
                            drawLineChart('lineChart$graphname', tmp_arr, 'usage', 'Disk Space Utilization the Last Day', j);
                            tmp_arr = [];

                        }
                    }
                </script>
                <script type="text/javascript">
                    drawLegend('lineChart$graphname', json, 'usage');
                </script>
                <a href="/#/diskusage/all" id="lineChart$graphname" class="d3graph">
                    <svg id="lineChartSVG" class="lineChart--svg">
                      <defs>
END
                ;

                my $n = 0;
                for my $colors (@colors_arr) {

                    for (my $j = 0; $j < 4; $j++) {

                        if ($j == 0) {
                            print '<linearGradient id="gradient-area'.$n.'" x1="0" x2="0" y1="0" y2="1">';
                            print '<stop class="lgt'.$n.'" offset="0%" />';
                        }

                        if ($j == 1) {
                            print '<stop class="lgb'.$n.'" offset="100%" />';
                        }

                        if ($j == 3) {
                            print '</linearGradient>';
                        }
                    }
                    $n++;
                }
                print <<END
                        <marker id="arrow-top" viewBox="0 0 20 20" refX="0" refY="10" markerWidth="50" markerHeight="8" orient="auto">
                            <path d="M 0 0 l -6 13 l 4 0 l 4 0 l 4 0 z" class="arrowHead"></path>
                        </marker>
                        <marker id="arrow-right" viewBox="0 0 20 20" refX="0" refY="5" markerWidth="50" markerHeight="10" orient="auto">
                            <path d="M 0 0 L 10 5 L 0 10 z" class="arrowHead"></path>
                        </marker>
                      </defs>
                    </svg>
                </a>
END
                ;

            }

            print <<END

			</div>
	    </div>

</div>

END
            ;

        }
    } else {
        foreach $period ("Hour", "Day", "Week", "Month", "Year") {

            print <<END

    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>$name : $period</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>

        <div class="x_panel fixed_height_320">
            <div class="x_content">

				<center> <img src='/stats/$name-$period.png?cachebuster=$datestring' border='0'> </center>

END
            ;

            print <<END

			</div>
	    </div>

</div>
END
            ;

        }
    }
}

if ($ajax_trigger == 2) {

    autoflush STDOUT 1;
    #printf "Status: 200\r\n\r\n";
    print "Content-type: text/json;\n\n";

    print <<END
{"load":"$load","cpu":"$cpu","mem":"$mem","datastore":"$disk","disk":"$drive_used[4]"}
END
    ;
    autoflush STDOUT 1;

}
