#!/usr/local/bin/perl
#
# Copyright (c) 2010-2016 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;

my $cgi = CGI->new;
my $host = $cgi->param("host");
my $count = $cgi->param("count");
my $countOptions = '';
my $proto = $cgi->param("proto");
my $reverse = $cgi->param("reverse");
my $icmp = $cgi->param("icmp");
my $ajax_trigger = 0;
my $ajax_trigger = $cgi->param("ajax_trigger");

my $result;
my $cmd;

for (my $i = 1; $i <= 64; $i++) {
    if ($i == 20) {
        $countOptions .= qq(<option value=$i selected="selected">$i</option>)
    }
    else {
        $countOptions .= qq(<option value=$i>$i</option>)
    }
}

print <<END
    <div class="page-title">
        <div class="title_left">
            <h3>Traceroute</h3>
        </div>
    </div>
    <div class="clearfix"></div>

    <div class="row">
        <div class="col-md-6 col-sm-6 col-xs-12">
            <div class="x_title title_block">
                <h2>Diagnostic Traceroute</h2>
                <ul class="nav navbar-right panel_toolbox">
                    <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                    </li>
                    <li><a class="close-link"><i class="fa fa-close"></i></a>
                    </li>
                </ul>
                <div class="clearfix"></div>
            </div>
            <div class="x_panel fixed_height_320">
                <div class="x_content">
                    <form id="traceroute" class="form-horizontal form-label-left" action="" method="post">

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="host">Host <span class="description">Ex: 192.168.0.1</span></label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <input type="text" id="host" name="host" size="16" maxlength="16" class="form-control col-md-7 col-xs-12" data-parsley-check_ip=""
                                data-toggle="tooltip" title="Destination hostname or IP address">
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="proto">IP Protocol</label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select id="proto" name="count" class="form-control" data-toggle="tooltip" title="Type of IP protocol to use for ping">>
                                    <option value="ipv4">IPv4</option>
                                    <option value="ipv6">IPv6</option>
                                </select>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="count">Maximum number of hops</span></label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select id="count" name="count" class="form-control" data-toggle="tooltip" title="Sets TTL (Time-To-Live) value, i.e. maximum number of hosts which will be probed">
                                    $countOptions
                                </select>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="reverse">Reverse Address Lookup</span></label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                 <div class="checkbox">
                                    <label>
                                        <input id="reverse" name="reverse"
                                            type="checkbox" checked="checked" size="12" class="flat"
                                            data-toggle="tooltip" title="Whether IP address should be tried and resolved to hostnames"/>
                                    </label>
                                </div>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12" for="icmp">Use ICMP</span></label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                 <div class="checkbox">
                                    <label>
                                        <input id="icmp" name="icmp"
                                            type="checkbox" size="12" class="flat" data-toggle="tooltip" title="Whether ICMP echo probes should be used?"/>
                                    </label>
                                </div>
                            </div>
                        </div>

                        <div class="ln_solid"></div>
                        <div class="form-group">
                            <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
                                <button id="btn_submit" type="submit" class="btn btn-success" style='font-size: 8pt;'>Traceroute</button>
                            </div>
                        </div>
                        </form>
END
;

if ($ajax_trigger == 1) {

    if ($proto eq "ipv4") {
        $proto = "-4";
    } elsif ($proto eq 'ipv6') {
        $proto = "-6";
    }

    if ($reverse ne "yes") {
        $reverse = "-n";
    } else {
        $reverse = '';
    }

    if ($icmp eq "yes") {
        $icmp = "-I";
    } else {
        $icmp = '';
    }

    $result = `traceroute $proto $reverse $icmp -m $count $host`;

print <<END
    <div class="form-group">
        <h3>Results</h3>
        <div class="col-md-12 col-sm-12 col-xs-12">
            <textarea class="form-control" readonly="true" rows="15">$result</textarea>
        </div>
    </div>
END
;

}

print <<END
                </div>
            </div>
        </div>
    </div>
END
;
