#!/usr/local/bin/perl


use strict;
use CGI;
use CGI::Carp qw ( fatalsToBrowser );
use File::Basename;
use Cwd qw(abs_path);

print "Content-type: text/html;\n\n";

$CGI::POST_MAX = 1024 * 5000;
my $safe_filename_characters = "a-zA-Z0-9_.-";
my $upload_dir = "/tce/www/stats/reports/";

my $query = new CGI;
my $filename = $query->param("update");
my $update;

if ($filename ne '')
{

	if (!$filename)
	{
		print $query->header ( );
		print "There was a problem uploading the file.";
		exit;
	}

	my ( $name, $path, $extension ) = fileparse ( $filename, '..*' );
	$filename = $name . $extension;
	$filename =~ tr/ /_/;
	$filename =~ s/[^$safe_filename_characters]//g;

	if ($filename =~ /^([$safe_filename_characters]+)$/)
	{
		$filename = $1;
	}
	else
	{
		die "Filename contains invalid characters";
	}

	my $upload_filehandle = $query->upload("update");

	open ( UPLOADFILE, ">$upload_dir/$filename" ) or die "$!";
	binmode UPLOADFILE;

	while (<$upload_filehandle>) {
		print UPLOADFILE;
	}
	autoflush UPLOADFILE 1;
	close UPLOADFILE;

#	print $query->header ( );

	$update = 1;
}

if ($update == 0) {

	print <<END;

<div class="page-title">
    <div class="title_left">
        <h3>Software Update</h3>
    </div>
</div>
<div class="clearfix"></div>

<div class="row">
    <div class="col-md-8 col-sm-8 col-xs-12">
        <div class="x_title title_block">
            <h2>Maintenance - Software Update</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_panel fixed_height_320">
            <div class="x_content">

END
	;
}

if ($update == 0)
{

	print <<END;


        <form id="upload_update" action="/cgi-bin/update.pl" enctype="multipart/form-data" method="post" class="form-inline">
            <label class="control-label col-md-7 col-sm-7 col-xs-12" for="update">Upload System Software Update File, Install and Reboot:</label>
              <div class="form-group">
                <input id="update" type="file" name="update" style='font-size: 8pt;' data-parsley-error-message="This field is required" required="required" multiple />
              </div>

              <button type="submit" class="btn btn-default" type="submit" name="Restore" value="Restore" style='font-size: 8pt;'>Install</button>
        </form>
END
	;
}

if ($update == 1) {

#	print $query->header('text/plain;charset=UTF-8');
	print <<END
       	<p>Installing System Update... <br /> This may take a moment...</p>
END
;
		system("sudo -u tc /tce/etc/wanos/makewanoscfg.sh -update $filename" );
}

if ($update == 2) {

#	print $query->header('text/plain;charset=UTF-8');
	print <<END
	<p>Software Installed Successfully !</p>
END
;
}

if ($update == 0) {

	print <<END
            </div>
        </div>
    </div>
</div>
END
;

}


